"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostDoorUpdate = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const doors_1 = require("../../functions/doors");
const shouldFire_1 = require("../../shouldFire");
const CustomCallback_1 = require("../private/CustomCallback");
class PostDoorUpdate extends CustomCallback_1.CustomCallback {
    constructor() {
        super();
        this.callbacksUsed = [
            // 1
            [isaac_typescript_definitions_1.ModCallback.POST_UPDATE, this.postUpdate],
        ];
    }
    shouldFire = shouldFire_1.shouldFireDoor;
    // ModCallback.POST_UPDATE (1)
    postUpdate = () => {
        for (const door of (0, doors_1.getDoors)()) {
            this.fire(door);
        }
    };
}
exports.PostDoorUpdate = PostDoorUpdate;
