"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostPickupInitLate = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const shouldFire_1 = require("../../shouldFire");
const CustomCallback_1 = require("../private/CustomCallback");
const v = {
    room: {
        firedSet: new Set(),
    },
};
class PostPickupInitLate extends CustomCallback_1.CustomCallback {
    v = v;
    constructor() {
        super();
        this.callbacksUsed = [
            // 35
            [isaac_typescript_definitions_1.ModCallback.POST_PICKUP_UPDATE, this.postPickupUpdate],
        ];
    }
    shouldFire = shouldFire_1.shouldFirePickup;
    // ModCallback.POST_PICKUP_UPDATE (35)
    postPickupUpdate = (pickup) => {
        const index = GetPtrHash(pickup);
        if (!v.room.firedSet.has(index)) {
            v.room.firedSet.add(index);
            this.fire(pickup);
        }
    };
}
exports.PostPickupInitLate = PostPickupInitLate;
