"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostPitUpdate = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const gridEntitiesSpecific_1 = require("../../functions/gridEntitiesSpecific");
const shouldFire_1 = require("../../shouldFire");
const CustomCallback_1 = require("../private/CustomCallback");
class PostPitUpdate extends CustomCallback_1.CustomCallback {
    constructor() {
        super();
        this.callbacksUsed = [
            // 1
            [isaac_typescript_definitions_1.ModCallback.POST_UPDATE, this.postUpdate],
        ];
    }
    shouldFire = shouldFire_1.shouldFirePit;
    // ModCallback.POST_UPDATE (1)
    postUpdate = () => {
        for (const pit of (0, gridEntitiesSpecific_1.getPits)()) {
            this.fire(pit);
        }
    };
}
exports.PostPitUpdate = PostPitUpdate;
