"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostTNTRender = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const gridEntitiesSpecific_1 = require("../../functions/gridEntitiesSpecific");
const shouldFire_1 = require("../../shouldFire");
const CustomCallback_1 = require("../private/CustomCallback");
class PostTNTRender extends CustomCallback_1.CustomCallback {
    constructor() {
        super();
        this.callbacksUsed = [
            // 2
            [isaac_typescript_definitions_1.ModCallback.POST_RENDER, this.postRender],
        ];
    }
    shouldFire = shouldFire_1.shouldFireTNT;
    // ModCallback.POST_RENDER (2)
    postRender = () => {
        for (const tnt of (0, gridEntitiesSpecific_1.getTNT)()) {
            this.fire(tnt);
        }
    };
}
exports.PostTNTRender = PostTNTRender;
