/// <reference types="isaac-typescript-definitions" />
import { Feature } from "../../private/Feature";
export declare class RoomClearFrame extends Feature {
    private readonly postRoomClearChangedTrue;
    /**
     * Helper function to get the game frame (i.e. `Game.GetFrameCount`) of the last time that this
     * room was cleared. Returns undefined if the room has never been cleared.
     *
     * Note that if the room is left, all room clear tracking for it will be discarded.
     *
     * In order to use this function, you must upgrade your mod with `ISCFeature.ROOM_CLEAR_FRAME`.
     *
     * @public
     */
    getRoomClearGameFrame(): int | undefined;
    /**
     * Helper function to get the render frame (i.e. `Isaac.GetFrameCount`) of the last time that this
     * room was cleared. Returns undefined if the room has never been cleared.
     *
     * Note that if the room is left, all room clear tracking for it will be discarded.
     *
     * In order to use this function, you must upgrade your mod with `ISCFeature.ROOM_CLEAR_FRAME`.
     *
     * @public
     */
    getRoomClearRenderFrame(): int | undefined;
    /**
     * Helper function to get the room frame (i.e. `Room.GetFrameCount`) of the last time that this
     * room was cleared. Returns undefined if the room has never been cleared.
     *
     * Note that if the room is left, all room clear tracking for it will be discarded.
     *
     * In order to use this function, you must upgrade your mod with `ISCFeature.ROOM_CLEAR_FRAME`.
     *
     * @public
     */
    getRoomClearRoomFrame(): int | undefined;
}
//# sourceMappingURL=RoomClearFrame.d.ts.map