"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DebugDisplayPressurePlate = void 0;
const ModCallbackCustom_1 = require("../../../../enums/ModCallbackCustom");
const render_1 = require("../../../../functions/render");
const Feature_1 = require("../../../private/Feature");
const utils_1 = require("./utils");
class DebugDisplayPressurePlate extends Feature_1.Feature {
    textCallback = utils_1.defaultGridEntityDisplayCallback;
    constructor() {
        super();
        this.customCallbacksUsed = [
            [
                ModCallbackCustom_1.ModCallbackCustom.POST_PRESSURE_PLATE_RENDER,
                this.postPressurePlateRender,
            ],
        ];
    }
    // ModCallbackCustom.POST_PRESSURE_PLATE_RENDER
    postPressurePlateRender = (pressurePlate) => {
        const text = this.textCallback(pressurePlate);
        (0, render_1.renderTextOnEntity)(pressurePlate, text);
    };
}
exports.DebugDisplayPressurePlate = DebugDisplayPressurePlate;
