"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fonts = exports.sfxManager = exports.musicManager = exports.itemConfig = exports.game = void 0;
/**
 * A cached version of the class returned from the `Game()` constructor.
 *
 * Use this instead of invoking the constructor again for a miniscule performance increase.
 *
 * Caching the results of this constructor is safe, but caching other classes (like `Level` or
 * `Room`) is not safe and can lead to the game crashing in certain situations.
 */
exports.game = Game();
/**
 * A cached version of the class returned from the `Isaac.GetItemConfig()` constructor.
 *
 * Use this instead of invoking the constructor again for a miniscule performance increase.
 *
 * Caching the results of this constructor is safe, but caching other classes (like `Level` or
 * `Room`) is not safe and can lead to the game crashing in certain situations.
 */
exports.itemConfig = Isaac.GetItemConfig();
/**
 * A cached version of the class returned from the `MusicManager()` constructor.
 *
 * Use this instead of invoking the constructor again for a miniscule performance increase.
 *
 * Caching the results of this constructor is safe, but caching other classes (like `Level` or
 * `Room`) is not safe and can lead to the game crashing in certain situations.
 */
exports.musicManager = MusicManager();
/**
 * A cached version of the class returned from the `SFXManager()` constructor.
 *
 * Use this instead of invoking the constructor again for a miniscule performance increase.
 *
 * Caching the results of this constructor is safe, but caching other classes (like `Level` or
 * `Room`) is not safe and can lead to the game crashing in certain situations.
 */
exports.sfxManager = SFXManager();
/**
 * An object containing all 7 vanilla fonts that are pre-loaded and ready to use.
 *
 * For more information on the vanilla fonts and to see what they look like, see:
 * https://wofsauge.github.io/IsaacDocs/rep/tutorials/Tutorial-Rendertext.html
 */
exports.fonts = {
    droid: Font(),
    pfTempestaSevenCondensed: Font(),
    teamMeatFont10: Font(),
    teamMeatFont12: Font(),
    teamMeatFont16Bold: Font(),
    terminus: Font(),
    upheaval: Font(),
};
exports.fonts.droid.Load("font/droid.fnt");
exports.fonts.pfTempestaSevenCondensed.Load("font/pftempestasevencondensed.fnt");
exports.fonts.teamMeatFont10.Load("font/teammeatfont10.fnt");
exports.fonts.teamMeatFont12.Load("font/teammeatfont12.fnt");
exports.fonts.teamMeatFont16Bold.Load("font/teammeatfont16bold.fnt");
exports.fonts.terminus.Load("font/terminus.fnt");
exports.fonts.upheaval.Load("font/upheaval.fnt");
