"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SlotDestructionType = void 0;
/** This is used in the `POST_SLOT_DESTROYED` custom callback. */
var SlotDestructionType;
(function (SlotDestructionType) {
    /**
     * When a machine or a beggar is blown up by a bomb or is otherwise removed without spawning a
     * collectible.
     *
     * Note that the destruction type for a Crane Game will be `SlotDestructionType.NORMAL`, even if
     * it destroyed via spawning three separate collectibles.
     */
    SlotDestructionType[SlotDestructionType["NORMAL"] = 0] = "NORMAL";
    /**
     * When a machine or a beggar is removed while spawning a collectible reward.
     *
     * Note that the destruction type for a Crane Game will be `SlotDestructionType.NORMAL`, even if
     * it destroyed via spawning three separate collectibles.
     */
    SlotDestructionType[SlotDestructionType["COLLECTIBLE_PAYOUT"] = 1] = "COLLECTIBLE_PAYOUT";
})(SlotDestructionType || (exports.SlotDestructionType = SlotDestructionType = {}));
