"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLanguageName = void 0;
const languageNames_1 = require("../objects/languageNames");
/**
 * Helper function to convert the language abbreviation from `Options.Language` to the "full"
 * language name.
 *
 * For example, if the current language is set to Korean, `Options.Language` will be set to "kr",
 * and this function will return "Korean".
 */
function getLanguageName() {
    const languageAbbreviation = Options.Language;
    return languageNames_1.LANGUAGE_NAMES[languageAbbreviation];
}
exports.getLanguageName = getLanguageName;
