"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.newReadonlyVector = exports.newReadonlyKColor = exports.newReadonlyColor = void 0;
/**
 * Helper function to create a read-only `Color` object. (Otherwise, you would have to manually
 * specify both the type and the constructor.)
 *
 * Note that read-only colors will be writable at run-time.
 */
function newReadonlyColor(r, g, b, a, ro, go, bo) {
    return Color(r, g, b, a, ro, go, bo);
}
exports.newReadonlyColor = newReadonlyColor;
/**
 * Helper function to create a read-only `KColor` object. (Otherwise, you would have to manually
 * specify both the type and the constructor.)
 *
 * Note that read-only colors will be writable at run-time.
 */
function newReadonlyKColor(r, g, b, a) {
    return KColor(r, g, b, a);
}
exports.newReadonlyKColor = newReadonlyKColor;
/**
 * Helper function to create a read-only `Vector` object. (Otherwise, you would have to manually
 * specify both the type and the constructor.)
 *
 * Note that read-only vectors will be writable at run-time.
 */
function newReadonlyVector(x, y) {
    return Vector(x, y);
}
exports.newReadonlyVector = newReadonlyVector;
