"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CARD_NAME_TO_TYPE_MAP = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const ReadonlyMap_1 = require("../types/ReadonlyMap");
// cspell:ignore hiero
/** Maps card names to the values of the `CardType` enum. */
exports.CARD_NAME_TO_TYPE_MAP = new ReadonlyMap_1.ReadonlyMap([
    ["fool", isaac_typescript_definitions_1.CardType.FOOL],
    ["magician", isaac_typescript_definitions_1.CardType.MAGICIAN],
    ["mag", isaac_typescript_definitions_1.CardType.MAGICIAN],
    ["highPriestess", isaac_typescript_definitions_1.CardType.HIGH_PRIESTESS],
    ["priestess", isaac_typescript_definitions_1.CardType.HIGH_PRIESTESS],
    ["priest", isaac_typescript_definitions_1.CardType.HIGH_PRIESTESS],
    ["hp", isaac_typescript_definitions_1.CardType.HIGH_PRIESTESS],
    ["empress", isaac_typescript_definitions_1.CardType.EMPRESS],
    ["emperor", isaac_typescript_definitions_1.CardType.EMPEROR],
    ["emp", isaac_typescript_definitions_1.CardType.EMPEROR],
    ["hierophant", isaac_typescript_definitions_1.CardType.HIEROPHANT],
    ["hi", isaac_typescript_definitions_1.CardType.HIEROPHANT],
    ["lovers", isaac_typescript_definitions_1.CardType.LOVERS],
    ["chariot", isaac_typescript_definitions_1.CardType.CHARIOT],
    ["justice", isaac_typescript_definitions_1.CardType.JUSTICE],
    ["hermit", isaac_typescript_definitions_1.CardType.HERMIT],
    ["wheelOfFortune", isaac_typescript_definitions_1.CardType.WHEEL_OF_FORTUNE],
    ["wheel", isaac_typescript_definitions_1.CardType.WHEEL_OF_FORTUNE],
    ["fortune", isaac_typescript_definitions_1.CardType.WHEEL_OF_FORTUNE],
    ["strength", isaac_typescript_definitions_1.CardType.STRENGTH],
    ["str", isaac_typescript_definitions_1.CardType.STRENGTH],
    ["hangedMan", isaac_typescript_definitions_1.CardType.HANGED_MAN],
    ["hanged", isaac_typescript_definitions_1.CardType.HANGED_MAN],
    ["death", isaac_typescript_definitions_1.CardType.DEATH],
    ["temperance", isaac_typescript_definitions_1.CardType.TEMPERANCE],
    ["devil", isaac_typescript_definitions_1.CardType.DEVIL],
    ["tower", isaac_typescript_definitions_1.CardType.TOWER],
    ["stars", isaac_typescript_definitions_1.CardType.STARS],
    ["moon", isaac_typescript_definitions_1.CardType.MOON],
    ["sun", isaac_typescript_definitions_1.CardType.SUN],
    ["judgement", isaac_typescript_definitions_1.CardType.JUDGEMENT],
    ["judge", isaac_typescript_definitions_1.CardType.JUDGEMENT],
    ["world", isaac_typescript_definitions_1.CardType.WORLD],
    ["2OfClubs", isaac_typescript_definitions_1.CardType.TWO_OF_CLUBS],
    ["2Clubs", isaac_typescript_definitions_1.CardType.TWO_OF_CLUBS],
    ["2OfDiamonds", isaac_typescript_definitions_1.CardType.TWO_OF_DIAMONDS],
    ["2Diamonds", isaac_typescript_definitions_1.CardType.TWO_OF_DIAMONDS],
    ["2OfSpades", isaac_typescript_definitions_1.CardType.TWO_OF_SPADES],
    ["2Spades", isaac_typescript_definitions_1.CardType.TWO_OF_SPADES],
    ["2OfHearts", isaac_typescript_definitions_1.CardType.TWO_OF_HEARTS],
    ["2Hearts", isaac_typescript_definitions_1.CardType.TWO_OF_HEARTS],
    ["aceOfClubs", isaac_typescript_definitions_1.CardType.ACE_OF_CLUBS],
    ["aceClubs", isaac_typescript_definitions_1.CardType.ACE_OF_CLUBS],
    ["aceOfDiamonds", isaac_typescript_definitions_1.CardType.ACE_OF_DIAMONDS],
    ["aceDiamonds", isaac_typescript_definitions_1.CardType.ACE_OF_DIAMONDS],
    ["aceOfSpades", isaac_typescript_definitions_1.CardType.ACE_OF_SPADES],
    ["aceSpades", isaac_typescript_definitions_1.CardType.ACE_OF_SPADES],
    ["aceOfHearts", isaac_typescript_definitions_1.CardType.ACE_OF_HEARTS],
    ["aceHearts", isaac_typescript_definitions_1.CardType.ACE_OF_HEARTS],
    ["joker", isaac_typescript_definitions_1.CardType.JOKER],
    ["hagalaz", isaac_typescript_definitions_1.CardType.RUNE_HAGALAZ],
    ["destruction", isaac_typescript_definitions_1.CardType.RUNE_HAGALAZ],
    ["jera", isaac_typescript_definitions_1.CardType.RUNE_JERA],
    ["abundance", isaac_typescript_definitions_1.CardType.RUNE_JERA],
    ["ehwaz", isaac_typescript_definitions_1.CardType.RUNE_EHWAZ],
    ["passage", isaac_typescript_definitions_1.CardType.RUNE_EHWAZ],
    ["dagaz", isaac_typescript_definitions_1.CardType.RUNE_DAGAZ],
    ["purity", isaac_typescript_definitions_1.CardType.RUNE_DAGAZ],
    ["ansuz", isaac_typescript_definitions_1.CardType.RUNE_ANSUZ],
    ["vision", isaac_typescript_definitions_1.CardType.RUNE_ANSUZ],
    ["perthro", isaac_typescript_definitions_1.CardType.RUNE_PERTHRO],
    ["change", isaac_typescript_definitions_1.CardType.RUNE_PERTHRO],
    ["berkano", isaac_typescript_definitions_1.CardType.RUNE_BERKANO],
    ["companionship", isaac_typescript_definitions_1.CardType.RUNE_BERKANO],
    ["algiz", isaac_typescript_definitions_1.CardType.RUNE_ALGIZ],
    ["resistance", isaac_typescript_definitions_1.CardType.RUNE_ALGIZ],
    ["shield", isaac_typescript_definitions_1.CardType.RUNE_ALGIZ],
    ["blankRune", isaac_typescript_definitions_1.CardType.RUNE_BLANK],
    ["blackRune", isaac_typescript_definitions_1.CardType.RUNE_BLACK],
    ["chaos", isaac_typescript_definitions_1.CardType.CHAOS],
    ["credit", isaac_typescript_definitions_1.CardType.CREDIT],
    ["rules", isaac_typescript_definitions_1.CardType.RULES],
    ["againstHumanity", isaac_typescript_definitions_1.CardType.AGAINST_HUMANITY],
    ["humanity", isaac_typescript_definitions_1.CardType.AGAINST_HUMANITY],
    ["suicideKing", isaac_typescript_definitions_1.CardType.SUICIDE_KING],
    ["suicide", isaac_typescript_definitions_1.CardType.SUICIDE_KING],
    ["getOutOfJailFree", isaac_typescript_definitions_1.CardType.GET_OUT_OF_JAIL_FREE],
    ["jail", isaac_typescript_definitions_1.CardType.GET_OUT_OF_JAIL_FREE],
    ["?", isaac_typescript_definitions_1.CardType.QUESTION_MARK],
    ["diceShard", isaac_typescript_definitions_1.CardType.DICE_SHARD],
    ["shard", isaac_typescript_definitions_1.CardType.DICE_SHARD],
    ["emergencyContact", isaac_typescript_definitions_1.CardType.EMERGENCY_CONTACT],
    ["contact", isaac_typescript_definitions_1.CardType.EMERGENCY_CONTACT],
    ["holy", isaac_typescript_definitions_1.CardType.HOLY],
    ["hugeGrowth", isaac_typescript_definitions_1.CardType.HUGE_GROWTH],
    ["growth", isaac_typescript_definitions_1.CardType.HUGE_GROWTH],
    ["ancientRecall", isaac_typescript_definitions_1.CardType.ANCIENT_RECALL],
    ["recall", isaac_typescript_definitions_1.CardType.ANCIENT_RECALL],
    ["eraWalk", isaac_typescript_definitions_1.CardType.ERA_WALK],
    ["walk", isaac_typescript_definitions_1.CardType.ERA_WALK],
    ["runeShard", isaac_typescript_definitions_1.CardType.RUNE_SHARD],
    ["shard", isaac_typescript_definitions_1.CardType.RUNE_SHARD],
    ["fool?", isaac_typescript_definitions_1.CardType.REVERSE_FOOL],
    ["magician?", isaac_typescript_definitions_1.CardType.REVERSE_MAGICIAN],
    ["magi?", isaac_typescript_definitions_1.CardType.REVERSE_MAGICIAN],
    ["mag?", isaac_typescript_definitions_1.CardType.REVERSE_MAGICIAN],
    ["highPriestess?", isaac_typescript_definitions_1.CardType.REVERSE_HIGH_PRIESTESS],
    ["high?", isaac_typescript_definitions_1.CardType.REVERSE_HIGH_PRIESTESS],
    ["hi?", isaac_typescript_definitions_1.CardType.REVERSE_HIGH_PRIESTESS],
    ["priestess?", isaac_typescript_definitions_1.CardType.REVERSE_HIGH_PRIESTESS],
    ["priest?", isaac_typescript_definitions_1.CardType.REVERSE_HIGH_PRIESTESS],
    ["hp?", isaac_typescript_definitions_1.CardType.REVERSE_HIGH_PRIESTESS],
    ["empress?", isaac_typescript_definitions_1.CardType.REVERSE_EMPRESS],
    ["emperor?", isaac_typescript_definitions_1.CardType.REVERSE_EMPEROR],
    ["emp?", isaac_typescript_definitions_1.CardType.REVERSE_EMPEROR],
    ["hierophant?", isaac_typescript_definitions_1.CardType.REVERSE_HIEROPHANT],
    ["hiero?", isaac_typescript_definitions_1.CardType.REVERSE_HIEROPHANT],
    ["lovers?", isaac_typescript_definitions_1.CardType.REVERSE_LOVERS],
    ["chariot?", isaac_typescript_definitions_1.CardType.REVERSE_CHARIOT],
    ["justice?", isaac_typescript_definitions_1.CardType.REVERSE_JUSTICE],
    ["hermit?", isaac_typescript_definitions_1.CardType.REVERSE_HERMIT],
    ["wheelOfFortune?", isaac_typescript_definitions_1.CardType.REVERSE_WHEEL_OF_FORTUNE],
    ["wheel?", isaac_typescript_definitions_1.CardType.REVERSE_WHEEL_OF_FORTUNE],
    ["fortune?", isaac_typescript_definitions_1.CardType.REVERSE_WHEEL_OF_FORTUNE],
    ["strength?", isaac_typescript_definitions_1.CardType.REVERSE_STRENGTH],
    ["str?", isaac_typescript_definitions_1.CardType.REVERSE_STRENGTH],
    ["hangedMan?", isaac_typescript_definitions_1.CardType.REVERSE_HANGED_MAN],
    ["hanged?", isaac_typescript_definitions_1.CardType.REVERSE_HANGED_MAN],
    ["death?", isaac_typescript_definitions_1.CardType.REVERSE_DEATH],
    ["temperance?", isaac_typescript_definitions_1.CardType.REVERSE_TEMPERANCE],
    ["devil?", isaac_typescript_definitions_1.CardType.REVERSE_DEVIL],
    ["tower?", isaac_typescript_definitions_1.CardType.REVERSE_TOWER],
    ["stars?", isaac_typescript_definitions_1.CardType.REVERSE_STARS],
    ["moon?", isaac_typescript_definitions_1.CardType.REVERSE_MOON],
    ["sun?", isaac_typescript_definitions_1.CardType.REVERSE_SUN],
    ["judgement?", isaac_typescript_definitions_1.CardType.REVERSE_JUDGEMENT],
    ["judge?", isaac_typescript_definitions_1.CardType.REVERSE_JUDGEMENT],
    ["world?", isaac_typescript_definitions_1.CardType.REVERSE_WORLD],
    ["crackedKey", isaac_typescript_definitions_1.CardType.CRACKED_KEY],
    ["key", isaac_typescript_definitions_1.CardType.CRACKED_KEY],
    ["queenOfHearts", isaac_typescript_definitions_1.CardType.QUEEN_OF_HEARTS],
    ["queenHearts", isaac_typescript_definitions_1.CardType.QUEEN_OF_HEARTS],
    ["wildcard", isaac_typescript_definitions_1.CardType.WILD],
    ["soulOfIsaac", isaac_typescript_definitions_1.CardType.SOUL_OF_ISAAC],
    ["soulIsaac", isaac_typescript_definitions_1.CardType.SOUL_OF_ISAAC],
    ["isaac", isaac_typescript_definitions_1.CardType.SOUL_OF_ISAAC],
    ["soulOfMagdalene", isaac_typescript_definitions_1.CardType.SOUL_OF_MAGDALENE],
    ["soulMagdalene", isaac_typescript_definitions_1.CardType.SOUL_OF_MAGDALENE],
    ["magdalene", isaac_typescript_definitions_1.CardType.SOUL_OF_MAGDALENE],
    ["soulOfCain", isaac_typescript_definitions_1.CardType.SOUL_OF_CAIN],
    ["soulCain", isaac_typescript_definitions_1.CardType.SOUL_OF_CAIN],
    ["cain", isaac_typescript_definitions_1.CardType.SOUL_OF_CAIN],
    ["soulOfJudas", isaac_typescript_definitions_1.CardType.SOUL_OF_JUDAS],
    ["soulJudas", isaac_typescript_definitions_1.CardType.SOUL_OF_JUDAS],
    ["judas", isaac_typescript_definitions_1.CardType.SOUL_OF_JUDAS],
    ["soulOf???", isaac_typescript_definitions_1.CardType.SOUL_OF_BLUE_BABY],
    ["soul???", isaac_typescript_definitions_1.CardType.SOUL_OF_BLUE_BABY],
    ["???", isaac_typescript_definitions_1.CardType.SOUL_OF_BLUE_BABY],
    ["soulOfBlueBaby", isaac_typescript_definitions_1.CardType.SOUL_OF_BLUE_BABY],
    ["soulBlueBaby", isaac_typescript_definitions_1.CardType.SOUL_OF_BLUE_BABY],
    ["blueBaby", isaac_typescript_definitions_1.CardType.SOUL_OF_BLUE_BABY],
    ["soulOfEve", isaac_typescript_definitions_1.CardType.SOUL_OF_EVE],
    ["soulEve", isaac_typescript_definitions_1.CardType.SOUL_OF_EVE],
    ["eve", isaac_typescript_definitions_1.CardType.SOUL_OF_EVE],
    ["soulOfSamson", isaac_typescript_definitions_1.CardType.SOUL_OF_SAMSON],
    ["soulSamson", isaac_typescript_definitions_1.CardType.SOUL_OF_SAMSON],
    ["samson", isaac_typescript_definitions_1.CardType.SOUL_OF_SAMSON],
    ["soulOfAzazel", isaac_typescript_definitions_1.CardType.SOUL_OF_AZAZEL],
    ["soulAzazel", isaac_typescript_definitions_1.CardType.SOUL_OF_AZAZEL],
    ["azazel", isaac_typescript_definitions_1.CardType.SOUL_OF_AZAZEL],
    ["soulOfLazarus", isaac_typescript_definitions_1.CardType.SOUL_OF_LAZARUS],
    ["soulLazarus", isaac_typescript_definitions_1.CardType.SOUL_OF_LAZARUS],
    ["lazarus", isaac_typescript_definitions_1.CardType.SOUL_OF_LAZARUS],
    ["soulOfEden", isaac_typescript_definitions_1.CardType.SOUL_OF_EDEN],
    ["soulEden", isaac_typescript_definitions_1.CardType.SOUL_OF_EDEN],
    ["eden", isaac_typescript_definitions_1.CardType.SOUL_OF_EDEN],
    ["soulOfTheLost", isaac_typescript_definitions_1.CardType.SOUL_OF_LOST],
    ["soulTheLost", isaac_typescript_definitions_1.CardType.SOUL_OF_LOST],
    ["theLost", isaac_typescript_definitions_1.CardType.SOUL_OF_LOST],
    ["soulOfLost", isaac_typescript_definitions_1.CardType.SOUL_OF_LOST],
    ["soulLost", isaac_typescript_definitions_1.CardType.SOUL_OF_LOST],
    ["lost", isaac_typescript_definitions_1.CardType.SOUL_OF_LOST],
    ["soulOfLilith", isaac_typescript_definitions_1.CardType.SOUL_OF_LILITH],
    ["soulLilith", isaac_typescript_definitions_1.CardType.SOUL_OF_LILITH],
    ["lilith", isaac_typescript_definitions_1.CardType.SOUL_OF_LILITH],
    ["soulOfTheKeeper", isaac_typescript_definitions_1.CardType.SOUL_OF_KEEPER],
    ["soulTheKeeper", isaac_typescript_definitions_1.CardType.SOUL_OF_KEEPER],
    ["theKeeper", isaac_typescript_definitions_1.CardType.SOUL_OF_KEEPER],
    ["soulOfKeeper", isaac_typescript_definitions_1.CardType.SOUL_OF_KEEPER],
    ["soulKeeper", isaac_typescript_definitions_1.CardType.SOUL_OF_KEEPER],
    ["keeper", isaac_typescript_definitions_1.CardType.SOUL_OF_KEEPER],
    ["soulOfApollyon", isaac_typescript_definitions_1.CardType.SOUL_OF_APOLLYON],
    ["soulApollyon", isaac_typescript_definitions_1.CardType.SOUL_OF_APOLLYON],
    ["apollyon", isaac_typescript_definitions_1.CardType.SOUL_OF_APOLLYON],
    ["soulOfTheForgotten", isaac_typescript_definitions_1.CardType.SOUL_OF_FORGOTTEN],
    ["soulTheForgotten", isaac_typescript_definitions_1.CardType.SOUL_OF_FORGOTTEN],
    ["theForgotten", isaac_typescript_definitions_1.CardType.SOUL_OF_FORGOTTEN],
    ["soulOfForgotten", isaac_typescript_definitions_1.CardType.SOUL_OF_FORGOTTEN],
    ["soulForgotten", isaac_typescript_definitions_1.CardType.SOUL_OF_FORGOTTEN],
    ["forgotten", isaac_typescript_definitions_1.CardType.SOUL_OF_FORGOTTEN],
    ["soulOfBethany", isaac_typescript_definitions_1.CardType.SOUL_OF_BETHANY],
    ["soulBethany", isaac_typescript_definitions_1.CardType.SOUL_OF_BETHANY],
    ["bethany", isaac_typescript_definitions_1.CardType.SOUL_OF_BETHANY],
    ["soulOfJacobAndEsau", isaac_typescript_definitions_1.CardType.SOUL_OF_JACOB_AND_ESAU],
    ["soulJacobAndEsau", isaac_typescript_definitions_1.CardType.SOUL_OF_JACOB_AND_ESAU],
    ["jacobAndEsau", isaac_typescript_definitions_1.CardType.SOUL_OF_JACOB_AND_ESAU],
    ["soulOfJacob&Esau", isaac_typescript_definitions_1.CardType.SOUL_OF_JACOB_AND_ESAU],
    ["soulJacob&Esau", isaac_typescript_definitions_1.CardType.SOUL_OF_JACOB_AND_ESAU],
    ["jacob&Esau", isaac_typescript_definitions_1.CardType.SOUL_OF_JACOB_AND_ESAU],
    ["soulOfJacob", isaac_typescript_definitions_1.CardType.SOUL_OF_JACOB_AND_ESAU],
    ["soulJacob", isaac_typescript_definitions_1.CardType.SOUL_OF_JACOB_AND_ESAU],
    ["jacob", isaac_typescript_definitions_1.CardType.SOUL_OF_JACOB_AND_ESAU], // 97
]);
