"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHARACTER_NAME_TO_TYPE_MAP = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const ReadonlyMap_1 = require("../types/ReadonlyMap");
/** Maps character names to the values of the `PlayerType` enum. */
exports.CHARACTER_NAME_TO_TYPE_MAP = new ReadonlyMap_1.ReadonlyMap([
    ["isaac", isaac_typescript_definitions_1.PlayerType.ISAAC],
    ["magdalene", isaac_typescript_definitions_1.PlayerType.MAGDALENE],
    ["maggy", isaac_typescript_definitions_1.PlayerType.MAGDALENE],
    ["cain", isaac_typescript_definitions_1.PlayerType.CAIN],
    ["judas", isaac_typescript_definitions_1.PlayerType.JUDAS],
    ["blueBaby", isaac_typescript_definitions_1.PlayerType.BLUE_BABY],
    ["bb", isaac_typescript_definitions_1.PlayerType.BLUE_BABY],
    ["eve", isaac_typescript_definitions_1.PlayerType.EVE],
    ["samson", isaac_typescript_definitions_1.PlayerType.SAMSON],
    ["azazel", isaac_typescript_definitions_1.PlayerType.AZAZEL],
    ["lazarus", isaac_typescript_definitions_1.PlayerType.LAZARUS],
    // Needed so that "laz2" does not take precedence over "lazarus".
    ["laz", isaac_typescript_definitions_1.PlayerType.LAZARUS],
    ["eden", isaac_typescript_definitions_1.PlayerType.EDEN],
    ["theLost", isaac_typescript_definitions_1.PlayerType.LOST],
    ["lost", isaac_typescript_definitions_1.PlayerType.LOST],
    ["lazarus2", isaac_typescript_definitions_1.PlayerType.LAZARUS_2],
    ["laz2", isaac_typescript_definitions_1.PlayerType.LAZARUS_2],
    ["darkJudas", isaac_typescript_definitions_1.PlayerType.DARK_JUDAS],
    ["dJudas", isaac_typescript_definitions_1.PlayerType.DARK_JUDAS],
    ["blackJudas", isaac_typescript_definitions_1.PlayerType.DARK_JUDAS],
    ["bJudas", isaac_typescript_definitions_1.PlayerType.DARK_JUDAS],
    ["lilith", isaac_typescript_definitions_1.PlayerType.LILITH],
    ["keeper", isaac_typescript_definitions_1.PlayerType.KEEPER],
    ["apollyon", isaac_typescript_definitions_1.PlayerType.APOLLYON],
    ["theForgotten", isaac_typescript_definitions_1.PlayerType.FORGOTTEN],
    ["forgotten", isaac_typescript_definitions_1.PlayerType.FORGOTTEN],
    ["theSoul", isaac_typescript_definitions_1.PlayerType.SOUL],
    ["soul", isaac_typescript_definitions_1.PlayerType.SOUL],
    ["bethany", isaac_typescript_definitions_1.PlayerType.BETHANY],
    ["jacob", isaac_typescript_definitions_1.PlayerType.JACOB],
    ["esau", isaac_typescript_definitions_1.PlayerType.ESAU],
    ["taintedIsaac", isaac_typescript_definitions_1.PlayerType.ISAAC_B],
    ["tIsaac", isaac_typescript_definitions_1.PlayerType.ISAAC_B],
    ["taintedMagdalene", isaac_typescript_definitions_1.PlayerType.MAGDALENE_B],
    ["tMagdalene", isaac_typescript_definitions_1.PlayerType.MAGDALENE_B],
    ["taintedMaggy", isaac_typescript_definitions_1.PlayerType.MAGDALENE_B],
    ["tMaggy", isaac_typescript_definitions_1.PlayerType.MAGDALENE_B],
    ["taintedCain", isaac_typescript_definitions_1.PlayerType.CAIN_B],
    ["tCain", isaac_typescript_definitions_1.PlayerType.CAIN_B],
    ["taintedJudas", isaac_typescript_definitions_1.PlayerType.JUDAS_B],
    ["tJudas", isaac_typescript_definitions_1.PlayerType.JUDAS_B],
    ["taintedBlueBaby", isaac_typescript_definitions_1.PlayerType.BLUE_BABY_B],
    ["tBlueBaby", isaac_typescript_definitions_1.PlayerType.BLUE_BABY_B],
    ["tbb", isaac_typescript_definitions_1.PlayerType.BLUE_BABY_B],
    ["taintedEve", isaac_typescript_definitions_1.PlayerType.EVE_B],
    ["tEve", isaac_typescript_definitions_1.PlayerType.EVE_B],
    ["taintedSamson", isaac_typescript_definitions_1.PlayerType.SAMSON_B],
    ["tSamson", isaac_typescript_definitions_1.PlayerType.SAMSON_B],
    ["taintedAzazel", isaac_typescript_definitions_1.PlayerType.AZAZEL_B],
    ["tAzazel", isaac_typescript_definitions_1.PlayerType.AZAZEL_B],
    ["taintedLazarus", isaac_typescript_definitions_1.PlayerType.LAZARUS_B],
    ["tLazarus", isaac_typescript_definitions_1.PlayerType.LAZARUS_B],
    ["taintedLaz", isaac_typescript_definitions_1.PlayerType.LAZARUS_B],
    ["tLaz", isaac_typescript_definitions_1.PlayerType.LAZARUS_B],
    ["taintedEden", isaac_typescript_definitions_1.PlayerType.EDEN_B],
    ["tEden", isaac_typescript_definitions_1.PlayerType.EDEN_B],
    ["taintedLost", isaac_typescript_definitions_1.PlayerType.LOST_B],
    ["tLost", isaac_typescript_definitions_1.PlayerType.LOST_B],
    ["taintedLilith", isaac_typescript_definitions_1.PlayerType.LILITH_B],
    ["tLilith", isaac_typescript_definitions_1.PlayerType.LILITH_B],
    ["taintedKeeper", isaac_typescript_definitions_1.PlayerType.KEEPER_B],
    ["tKeeper", isaac_typescript_definitions_1.PlayerType.KEEPER_B],
    ["taintedApollyon", isaac_typescript_definitions_1.PlayerType.APOLLYON_B],
    ["tApollyon", isaac_typescript_definitions_1.PlayerType.APOLLYON_B],
    ["taintedForgotten", isaac_typescript_definitions_1.PlayerType.FORGOTTEN_B],
    ["tForgotten", isaac_typescript_definitions_1.PlayerType.FORGOTTEN_B],
    ["taintedBethany", isaac_typescript_definitions_1.PlayerType.BETHANY_B],
    ["tBethany", isaac_typescript_definitions_1.PlayerType.BETHANY_B],
    ["taintedJacob", isaac_typescript_definitions_1.PlayerType.JACOB_B],
    ["tJacob", isaac_typescript_definitions_1.PlayerType.JACOB_B],
    ["taintedLazarusDead", isaac_typescript_definitions_1.PlayerType.LAZARUS_2_B],
    ["tLazarusDead", isaac_typescript_definitions_1.PlayerType.LAZARUS_2_B],
    ["taintedLazDead", isaac_typescript_definitions_1.PlayerType.LAZARUS_2_B],
    ["tLazDead", isaac_typescript_definitions_1.PlayerType.LAZARUS_2_B],
    ["deadTaintedLazarus", isaac_typescript_definitions_1.PlayerType.LAZARUS_2_B],
    ["deadTLazarus", isaac_typescript_definitions_1.PlayerType.LAZARUS_2_B],
    ["deadTaintedLaz", isaac_typescript_definitions_1.PlayerType.LAZARUS_2_B],
    ["deadTLaz", isaac_typescript_definitions_1.PlayerType.LAZARUS_2_B],
    ["taintedJacobGhost", isaac_typescript_definitions_1.PlayerType.JACOB_2_B],
    ["tJacobGhost", isaac_typescript_definitions_1.PlayerType.JACOB_2_B],
    ["taintedSoul", isaac_typescript_definitions_1.PlayerType.SOUL_B],
    ["tSoul", isaac_typescript_definitions_1.PlayerType.SOUL_B], // 40
]);
