"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DEFAULT_PLAYER_STAT_MAP = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const tears_1 = require("../functions/tears");
const ReadonlyMap_1 = require("../types/ReadonlyMap");
const DEFAULT_MAX_FIRE_DELAY = 10;
/** The default fire delay is represented in the tear stat, not the `MaxFireDelay` value. */
exports.DEFAULT_PLAYER_STAT_MAP = new ReadonlyMap_1.ReadonlyMap([
    [isaac_typescript_definitions_1.CacheFlag.DAMAGE, 3.5],
    // The default tears stat is 2.73.
    [isaac_typescript_definitions_1.CacheFlag.FIRE_DELAY, (0, tears_1.getTearsStat)(DEFAULT_MAX_FIRE_DELAY)],
    [isaac_typescript_definitions_1.CacheFlag.SHOT_SPEED, 1],
    [isaac_typescript_definitions_1.CacheFlag.RANGE, 6.5],
    [isaac_typescript_definitions_1.CacheFlag.SPEED, 1],
    [isaac_typescript_definitions_1.CacheFlag.LUCK, 0], // 1 << 10
]);
