"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GRID_ENTITY_TYPE_TO_BROKEN_STATE_MAP = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const ReadonlyMap_1 = require("../types/ReadonlyMap");
/** Not every grid entity can be broken. Thus use a map to represent this. */
exports.GRID_ENTITY_TYPE_TO_BROKEN_STATE_MAP = new ReadonlyMap_1.ReadonlyMap([
    // 2
    [isaac_typescript_definitions_1.GridEntityType.ROCK, isaac_typescript_definitions_1.RockState.BROKEN],
    // 4
    [isaac_typescript_definitions_1.GridEntityType.ROCK_TINTED, isaac_typescript_definitions_1.RockState.BROKEN],
    // 5
    [isaac_typescript_definitions_1.GridEntityType.ROCK_BOMB, isaac_typescript_definitions_1.RockState.BROKEN],
    // 6
    [isaac_typescript_definitions_1.GridEntityType.ROCK_ALT, isaac_typescript_definitions_1.RockState.BROKEN],
    // 10
    [isaac_typescript_definitions_1.GridEntityType.SPIDER_WEB, isaac_typescript_definitions_1.SpiderWebState.BROKEN],
    // 11
    [isaac_typescript_definitions_1.GridEntityType.LOCK, isaac_typescript_definitions_1.LockState.UNLOCKED],
    // 12
    [isaac_typescript_definitions_1.GridEntityType.TNT, isaac_typescript_definitions_1.TNTState.EXPLODED],
    // 14
    [isaac_typescript_definitions_1.GridEntityType.POOP, isaac_typescript_definitions_1.PoopState.COMPLETELY_DESTROYED],
    // 22
    [isaac_typescript_definitions_1.GridEntityType.ROCK_SUPER_SPECIAL, isaac_typescript_definitions_1.RockState.BROKEN],
    // 25
    [isaac_typescript_definitions_1.GridEntityType.ROCK_SPIKED, isaac_typescript_definitions_1.RockState.BROKEN],
    // 26
    [isaac_typescript_definitions_1.GridEntityType.ROCK_ALT_2, isaac_typescript_definitions_1.RockState.BROKEN],
    // 27
    [isaac_typescript_definitions_1.GridEntityType.ROCK_GOLD, isaac_typescript_definitions_1.RockState.BROKEN],
]);
