"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.KEYBOARD_TO_STRING_MAP = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const ReadonlyMap_1 = require("../types/ReadonlyMap");
/** Maps each keyboard enum member to its corresponding lowercase and uppercase characters. */
exports.KEYBOARD_TO_STRING_MAP = new ReadonlyMap_1.ReadonlyMap([
    [isaac_typescript_definitions_1.Keyboard.SPACE, [" ", " "]],
    [isaac_typescript_definitions_1.Keyboard.APOSTROPHE, ["'", '"']],
    [isaac_typescript_definitions_1.Keyboard.COMMA, [",", "<"]],
    [isaac_typescript_definitions_1.Keyboard.MINUS, ["-", "_"]],
    [isaac_typescript_definitions_1.Keyboard.PERIOD, [".", ">"]],
    [isaac_typescript_definitions_1.Keyboard.SLASH, ["/", "?"]],
    [isaac_typescript_definitions_1.Keyboard.ZERO, ["0", ")"]],
    [isaac_typescript_definitions_1.Keyboard.ONE, ["1", "!"]],
    [isaac_typescript_definitions_1.Keyboard.TWO, ["2", "@"]],
    [isaac_typescript_definitions_1.Keyboard.THREE, ["3", "#"]],
    [isaac_typescript_definitions_1.Keyboard.FOUR, ["4", "$"]],
    [isaac_typescript_definitions_1.Keyboard.FIVE, ["5", "%"]],
    [isaac_typescript_definitions_1.Keyboard.SIX, ["6", "^"]],
    [isaac_typescript_definitions_1.Keyboard.SEVEN, ["7", "&"]],
    [isaac_typescript_definitions_1.Keyboard.EIGHT, ["8", "*"]],
    [isaac_typescript_definitions_1.Keyboard.NINE, ["9", "("]],
    [isaac_typescript_definitions_1.Keyboard.SEMICOLON, [";", ":"]],
    [isaac_typescript_definitions_1.Keyboard.EQUAL, ["=", "+"]],
    [isaac_typescript_definitions_1.Keyboard.A, ["a", "A"]],
    [isaac_typescript_definitions_1.Keyboard.B, ["b", "B"]],
    [isaac_typescript_definitions_1.Keyboard.C, ["c", "C"]],
    [isaac_typescript_definitions_1.Keyboard.D, ["d", "D"]],
    [isaac_typescript_definitions_1.Keyboard.E, ["e", "E"]],
    [isaac_typescript_definitions_1.Keyboard.F, ["f", "F"]],
    [isaac_typescript_definitions_1.Keyboard.G, ["g", "G"]],
    [isaac_typescript_definitions_1.Keyboard.H, ["h", "H"]],
    [isaac_typescript_definitions_1.Keyboard.I, ["i", "I"]],
    [isaac_typescript_definitions_1.Keyboard.J, ["j", "J"]],
    [isaac_typescript_definitions_1.Keyboard.K, ["k", "K"]],
    [isaac_typescript_definitions_1.Keyboard.L, ["l", "L"]],
    [isaac_typescript_definitions_1.Keyboard.M, ["m", "M"]],
    [isaac_typescript_definitions_1.Keyboard.N, ["n", "N"]],
    [isaac_typescript_definitions_1.Keyboard.O, ["o", "O"]],
    [isaac_typescript_definitions_1.Keyboard.P, ["p", "P"]],
    [isaac_typescript_definitions_1.Keyboard.Q, ["q", "Q"]],
    [isaac_typescript_definitions_1.Keyboard.R, ["r", "R"]],
    [isaac_typescript_definitions_1.Keyboard.S, ["s", "S"]],
    [isaac_typescript_definitions_1.Keyboard.T, ["t", "T"]],
    [isaac_typescript_definitions_1.Keyboard.U, ["u", "U"]],
    [isaac_typescript_definitions_1.Keyboard.V, ["v", "V"]],
    [isaac_typescript_definitions_1.Keyboard.W, ["w", "W"]],
    [isaac_typescript_definitions_1.Keyboard.X, ["x", "X"]],
    [isaac_typescript_definitions_1.Keyboard.Y, ["y", "Y"]],
    [isaac_typescript_definitions_1.Keyboard.Z, ["z", "Z"]],
    [isaac_typescript_definitions_1.Keyboard.KP_0, ["0", "0"]],
    [isaac_typescript_definitions_1.Keyboard.KP_1, ["1", "1"]],
    [isaac_typescript_definitions_1.Keyboard.KP_2, ["2", "2"]],
    [isaac_typescript_definitions_1.Keyboard.KP_3, ["3", "3"]],
    [isaac_typescript_definitions_1.Keyboard.KP_4, ["4", "4"]],
    [isaac_typescript_definitions_1.Keyboard.KP_5, ["5", "5"]],
    [isaac_typescript_definitions_1.Keyboard.KP_6, ["6", "6"]],
    [isaac_typescript_definitions_1.Keyboard.KP_7, ["7", "7"]],
    [isaac_typescript_definitions_1.Keyboard.KP_8, ["8", "8"]],
    [isaac_typescript_definitions_1.Keyboard.KP_9, ["9", "9"]],
    [isaac_typescript_definitions_1.Keyboard.KP_DECIMAL, [".", "."]],
    [isaac_typescript_definitions_1.Keyboard.KP_DIVIDE, ["/", "/"]],
    [isaac_typescript_definitions_1.Keyboard.KP_MULTIPLY, ["*", "*"]],
    [isaac_typescript_definitions_1.Keyboard.KP_SUBTRACT, ["-", "-"]],
    [isaac_typescript_definitions_1.Keyboard.KP_ADD, ["+", "+"]],
    [isaac_typescript_definitions_1.Keyboard.LEFT_BRACKET, ["[", "{"]],
    [isaac_typescript_definitions_1.Keyboard.BACKSLASH, ["\\", "|"]],
    [isaac_typescript_definitions_1.Keyboard.RIGHT_BRACKET, ["]", "}"]],
    [isaac_typescript_definitions_1.Keyboard.GRAVE_ACCENT, ["`", "~"]], // 96
]);
