"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PILL_NAME_TO_EFFECT_MAP = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const ReadonlyMap_1 = require("../types/ReadonlyMap");
/** Maps pill effect names to the values of the `PillEffect` enum. */
exports.PILL_NAME_TO_EFFECT_MAP = new ReadonlyMap_1.ReadonlyMap([
    ["badGas", isaac_typescript_definitions_1.PillEffect.BAD_GAS],
    ["gas", isaac_typescript_definitions_1.PillEffect.BAD_GAS],
    ["badTrip", isaac_typescript_definitions_1.PillEffect.BAD_TRIP],
    ["trip", isaac_typescript_definitions_1.PillEffect.BAD_TRIP],
    ["ballsOfSteel", isaac_typescript_definitions_1.PillEffect.BALLS_OF_STEEL],
    ["ballsSteel", isaac_typescript_definitions_1.PillEffect.BALLS_OF_STEEL],
    ["steel", isaac_typescript_definitions_1.PillEffect.BALLS_OF_STEEL],
    ["bombsAreKey", isaac_typescript_definitions_1.PillEffect.BOMBS_ARE_KEYS],
    ["bombsKey", isaac_typescript_definitions_1.PillEffect.BOMBS_ARE_KEYS],
    ["key", isaac_typescript_definitions_1.PillEffect.BOMBS_ARE_KEYS],
    ["explosiveDiarrhea", isaac_typescript_definitions_1.PillEffect.EXPLOSIVE_DIARRHEA],
    ["diarrhea", isaac_typescript_definitions_1.PillEffect.EXPLOSIVE_DIARRHEA],
    ["fullHealth", isaac_typescript_definitions_1.PillEffect.FULL_HEALTH],
    ["healthDown", isaac_typescript_definitions_1.PillEffect.HEALTH_DOWN],
    ["healthUp", isaac_typescript_definitions_1.PillEffect.HEALTH_UP],
    ["iFoundPills", isaac_typescript_definitions_1.PillEffect.I_FOUND_PILLS],
    ["foundPills", isaac_typescript_definitions_1.PillEffect.I_FOUND_PILLS],
    ["pills", isaac_typescript_definitions_1.PillEffect.I_FOUND_PILLS],
    ["puberty", isaac_typescript_definitions_1.PillEffect.PUBERTY],
    ["prettyFly", isaac_typescript_definitions_1.PillEffect.PRETTY_FLY],
    ["fly", isaac_typescript_definitions_1.PillEffect.PRETTY_FLY],
    ["rangeDown", isaac_typescript_definitions_1.PillEffect.RANGE_DOWN],
    ["rangeUp", isaac_typescript_definitions_1.PillEffect.RANGE_UP],
    ["speedDown", isaac_typescript_definitions_1.PillEffect.SPEED_DOWN],
    ["speedUp", isaac_typescript_definitions_1.PillEffect.SPEED_UP],
    ["tearsDown", isaac_typescript_definitions_1.PillEffect.TEARS_DOWN],
    ["tearsUp", isaac_typescript_definitions_1.PillEffect.TEARS_UP],
    ["luckDown", isaac_typescript_definitions_1.PillEffect.LUCK_DOWN],
    ["luckUp", isaac_typescript_definitions_1.PillEffect.LUCK_UP],
    ["telepills", isaac_typescript_definitions_1.PillEffect.TELEPILLS],
    ["48HourEnergy", isaac_typescript_definitions_1.PillEffect.FORTY_EIGHT_HOUR_ENERGY],
    ["energy", isaac_typescript_definitions_1.PillEffect.FORTY_EIGHT_HOUR_ENERGY],
    ["48", isaac_typescript_definitions_1.PillEffect.FORTY_EIGHT_HOUR_ENERGY],
    ["hematemesis", isaac_typescript_definitions_1.PillEffect.HEMATEMESIS],
    ["paralysis", isaac_typescript_definitions_1.PillEffect.PARALYSIS],
    ["iCanSeeForever!", isaac_typescript_definitions_1.PillEffect.I_CAN_SEE_FOREVER],
    ["canSee", isaac_typescript_definitions_1.PillEffect.I_CAN_SEE_FOREVER],
    ["see", isaac_typescript_definitions_1.PillEffect.I_CAN_SEE_FOREVER],
    ["pheromones", isaac_typescript_definitions_1.PillEffect.PHEROMONES],
    ["amnesia", isaac_typescript_definitions_1.PillEffect.AMNESIA],
    ["lemonParty", isaac_typescript_definitions_1.PillEffect.LEMON_PARTY],
    ["party", isaac_typescript_definitions_1.PillEffect.LEMON_PARTY],
    ["RUAWizard", isaac_typescript_definitions_1.PillEffect.R_U_A_WIZARD],
    ["areYouAWizard", isaac_typescript_definitions_1.PillEffect.R_U_A_WIZARD],
    ["wizard", isaac_typescript_definitions_1.PillEffect.R_U_A_WIZARD],
    ["percs!", isaac_typescript_definitions_1.PillEffect.PERCS],
    ["addicted!", isaac_typescript_definitions_1.PillEffect.ADDICTED],
    ["relax", isaac_typescript_definitions_1.PillEffect.RELAX],
    ["???", isaac_typescript_definitions_1.PillEffect.QUESTION_MARKS],
    ["oneMakesYouLarger", isaac_typescript_definitions_1.PillEffect.ONE_MAKES_YOU_LARGER],
    ["larger", isaac_typescript_definitions_1.PillEffect.ONE_MAKES_YOU_LARGER],
    ["oneMakesYouSmaller", isaac_typescript_definitions_1.PillEffect.ONE_MAKES_YOU_SMALL],
    ["smaller", isaac_typescript_definitions_1.PillEffect.ONE_MAKES_YOU_SMALL],
    ["infested!", isaac_typescript_definitions_1.PillEffect.INFESTED_EXCLAMATION],
    ["infest!", isaac_typescript_definitions_1.PillEffect.INFESTED_EXCLAMATION],
    ["inf!", isaac_typescript_definitions_1.PillEffect.INFESTED_EXCLAMATION],
    ["infested?", isaac_typescript_definitions_1.PillEffect.INFESTED_QUESTION],
    ["infest?", isaac_typescript_definitions_1.PillEffect.INFESTED_QUESTION],
    ["inf?", isaac_typescript_definitions_1.PillEffect.INFESTED_QUESTION],
    ["powerPill", isaac_typescript_definitions_1.PillEffect.POWER],
    ["retroVision", isaac_typescript_definitions_1.PillEffect.RETRO_VISION],
    ["vision", isaac_typescript_definitions_1.PillEffect.RETRO_VISION],
    ["friendsTillTheEnd", isaac_typescript_definitions_1.PillEffect.FRIENDS_TILL_THE_END],
    ["friendsUntilTheEnd", isaac_typescript_definitions_1.PillEffect.FRIENDS_TILL_THE_END],
    ["xlax", isaac_typescript_definitions_1.PillEffect.X_LAX],
    ["somethingsWrong", isaac_typescript_definitions_1.PillEffect.SOMETHINGS_WRONG],
    ["wrong", isaac_typescript_definitions_1.PillEffect.SOMETHINGS_WRONG],
    ["imDrowsy", isaac_typescript_definitions_1.PillEffect.IM_DROWSY],
    ["drowsy", isaac_typescript_definitions_1.PillEffect.IM_DROWSY],
    ["imExcited!!!", isaac_typescript_definitions_1.PillEffect.IM_EXCITED],
    ["excited", isaac_typescript_definitions_1.PillEffect.IM_EXCITED],
    ["gulp!", isaac_typescript_definitions_1.PillEffect.GULP],
    ["horf!", isaac_typescript_definitions_1.PillEffect.HORF],
    [
        "feelsLikeImWalkingOnSunshine!",
        isaac_typescript_definitions_1.PillEffect.FEELS_LIKE_IM_WALKING_ON_SUNSHINE,
    ],
    ["walking", isaac_typescript_definitions_1.PillEffect.FEELS_LIKE_IM_WALKING_ON_SUNSHINE],
    ["sunshine", isaac_typescript_definitions_1.PillEffect.FEELS_LIKE_IM_WALKING_ON_SUNSHINE],
    ["vurp!", isaac_typescript_definitions_1.PillEffect.VURP],
    ["shotSpeedDown", isaac_typescript_definitions_1.PillEffect.SHOT_SPEED_DOWN],
    ["shotSpeedUp", isaac_typescript_definitions_1.PillEffect.SHOT_SPEED_UP],
    ["experimental", isaac_typescript_definitions_1.PillEffect.EXPERIMENTAL], // 49
]);
