"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BACKDROP_TYPE_TO_ROCK_ALT_TYPE = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const RockAltType_1 = require("../enums/RockAltType");
/** Used by the `getRockAltType` function. */
exports.BACKDROP_TYPE_TO_ROCK_ALT_TYPE = {
    [isaac_typescript_definitions_1.BackdropType.BASEMENT]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.CELLAR]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.BURNING_BASEMENT]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.CAVES]: RockAltType_1.RockAltType.MUSHROOM,
    [isaac_typescript_definitions_1.BackdropType.CATACOMBS]: RockAltType_1.RockAltType.MUSHROOM,
    [isaac_typescript_definitions_1.BackdropType.FLOODED_CAVES]: RockAltType_1.RockAltType.MUSHROOM,
    [isaac_typescript_definitions_1.BackdropType.DEPTHS]: RockAltType_1.RockAltType.SKULL,
    [isaac_typescript_definitions_1.BackdropType.NECROPOLIS]: RockAltType_1.RockAltType.SKULL,
    [isaac_typescript_definitions_1.BackdropType.DANK_DEPTHS]: RockAltType_1.RockAltType.SKULL,
    [isaac_typescript_definitions_1.BackdropType.WOMB]: RockAltType_1.RockAltType.POLYP,
    [isaac_typescript_definitions_1.BackdropType.UTERO]: RockAltType_1.RockAltType.POLYP,
    [isaac_typescript_definitions_1.BackdropType.SCARRED_WOMB]: RockAltType_1.RockAltType.POLYP,
    [isaac_typescript_definitions_1.BackdropType.BLUE_WOMB]: RockAltType_1.RockAltType.POLYP,
    [isaac_typescript_definitions_1.BackdropType.SHEOL]: RockAltType_1.RockAltType.SKULL,
    [isaac_typescript_definitions_1.BackdropType.CATHEDRAL]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.DARK_ROOM]: RockAltType_1.RockAltType.SKULL,
    [isaac_typescript_definitions_1.BackdropType.CHEST]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.MEGA_SATAN]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.LIBRARY]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.SHOP]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.CLEAN_BEDROOM]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.DIRTY_BEDROOM]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.SECRET]: RockAltType_1.RockAltType.MUSHROOM,
    [isaac_typescript_definitions_1.BackdropType.DICE]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.ARCADE]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.ERROR_ROOM]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.BLUE_WOMB_PASS]: RockAltType_1.RockAltType.POLYP,
    [isaac_typescript_definitions_1.BackdropType.GREED_SHOP]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.DUNGEON]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.SACRIFICE]: RockAltType_1.RockAltType.SKULL,
    [isaac_typescript_definitions_1.BackdropType.DOWNPOUR]: RockAltType_1.RockAltType.BUCKET_DOWNPOUR,
    [isaac_typescript_definitions_1.BackdropType.MINES]: RockAltType_1.RockAltType.MUSHROOM,
    [isaac_typescript_definitions_1.BackdropType.MAUSOLEUM]: RockAltType_1.RockAltType.SKULL,
    [isaac_typescript_definitions_1.BackdropType.CORPSE]: RockAltType_1.RockAltType.POLYP,
    [isaac_typescript_definitions_1.BackdropType.PLANETARIUM]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.DOWNPOUR_ENTRANCE]: RockAltType_1.RockAltType.BUCKET_DOWNPOUR,
    [isaac_typescript_definitions_1.BackdropType.MINES_ENTRANCE]: RockAltType_1.RockAltType.MUSHROOM,
    [isaac_typescript_definitions_1.BackdropType.MAUSOLEUM_ENTRANCE]: RockAltType_1.RockAltType.SKULL,
    [isaac_typescript_definitions_1.BackdropType.CORPSE_ENTRANCE]: RockAltType_1.RockAltType.SKULL,
    [isaac_typescript_definitions_1.BackdropType.MAUSOLEUM_2]: RockAltType_1.RockAltType.SKULL,
    [isaac_typescript_definitions_1.BackdropType.MAUSOLEUM_3]: RockAltType_1.RockAltType.SKULL,
    [isaac_typescript_definitions_1.BackdropType.MAUSOLEUM_4]: RockAltType_1.RockAltType.SKULL,
    [isaac_typescript_definitions_1.BackdropType.CORPSE_2]: RockAltType_1.RockAltType.POLYP,
    [isaac_typescript_definitions_1.BackdropType.CORPSE_3]: RockAltType_1.RockAltType.POLYP,
    [isaac_typescript_definitions_1.BackdropType.DROSS]: RockAltType_1.RockAltType.BUCKET_DROSS,
    [isaac_typescript_definitions_1.BackdropType.ASHPIT]: RockAltType_1.RockAltType.MUSHROOM,
    [isaac_typescript_definitions_1.BackdropType.GEHENNA]: RockAltType_1.RockAltType.SKULL,
    [isaac_typescript_definitions_1.BackdropType.MORTIS]: RockAltType_1.RockAltType.POLYP,
    [isaac_typescript_definitions_1.BackdropType.ISAACS_BEDROOM]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.HALLWAY]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.MOMS_BEDROOM]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.CLOSET]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.CLOSET_B]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.DOGMA]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.DUNGEON_GIDEON]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.DUNGEON_ROTGUT]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.DUNGEON_BEAST]: RockAltType_1.RockAltType.URN,
    [isaac_typescript_definitions_1.BackdropType.MINES_SHAFT]: RockAltType_1.RockAltType.MUSHROOM,
    [isaac_typescript_definitions_1.BackdropType.ASHPIT_SHAFT]: RockAltType_1.RockAltType.MUSHROOM,
    [isaac_typescript_definitions_1.BackdropType.DARK_CLOSET]: RockAltType_1.RockAltType.SKULL, // 60
};
