"use strict";
// cspell:disable
Object.defineProperty(exports, "__esModule", { value: true });
exports.BOSS_NAME_PNG_FILE_NAMES = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
/**
 * From the "nameimage" attribute in the "bossportraits.xml" file. Used when rendering the
 * "versusscreen.anm2" sprite.
 */
exports.BOSS_NAME_PNG_FILE_NAMES = {
    [isaac_typescript_definitions_1.BossID.MONSTRO]: "BossName_20.0_Monstro.png",
    [isaac_typescript_definitions_1.BossID.LARRY_JR]: "BossName_19.0_LarryJr.png",
    [isaac_typescript_definitions_1.BossID.CHUB]: "BossName_28.0_Chub.png",
    [isaac_typescript_definitions_1.BossID.GURDY]: "BossName_36.0_Gurdy.png",
    [isaac_typescript_definitions_1.BossID.MONSTRO_2]: "BossName_43.0_Monstro2.png",
    [isaac_typescript_definitions_1.BossID.MOM]: "BossName_45.0_Mom.png",
    [isaac_typescript_definitions_1.BossID.SCOLEX]: "BossName_62.1_Scolex.png",
    [isaac_typescript_definitions_1.BossID.MOMS_HEART]: "BossName_78.0_MomsHeart.png",
    [isaac_typescript_definitions_1.BossID.FAMINE]: "BossName_63.0_Famine.png",
    [isaac_typescript_definitions_1.BossID.PESTILENCE]: "BossName_64.0_Pestilence.png",
    [isaac_typescript_definitions_1.BossID.WAR]: "BossName_65.0_War.png",
    [isaac_typescript_definitions_1.BossID.DEATH]: "BossName_66.0_Death.png",
    [isaac_typescript_definitions_1.BossID.DUKE_OF_FLIES]: "BossName_67.0_DukeOfFlies.png",
    [isaac_typescript_definitions_1.BossID.PEEP]: "BossName_68.0_Peep.png",
    [isaac_typescript_definitions_1.BossID.LOKI]: "BossName_69.0_Loki.png",
    [isaac_typescript_definitions_1.BossID.BLASTOCYST]: "BossName_74.0_Blastocyst.png",
    [isaac_typescript_definitions_1.BossID.GEMINI]: "BossName_79.0_Gemini.png",
    [isaac_typescript_definitions_1.BossID.FISTULA]: "BossName_71.0_Fistula.png",
    [isaac_typescript_definitions_1.BossID.GISH]: "BossName_43.1_Gish.png",
    [isaac_typescript_definitions_1.BossID.STEVEN]: "BossName_79.1_Steven.png",
    [isaac_typescript_definitions_1.BossID.CHAD]: "BossName_28.1_CHAD.png",
    [isaac_typescript_definitions_1.BossID.HEADLESS_HORSEMAN]: "BossName_82.0_HeadlessHorseman.png",
    [isaac_typescript_definitions_1.BossID.FALLEN]: "BossName_81.0_TheFallen.png",
    [isaac_typescript_definitions_1.BossID.SATAN]: "BossName_84.0_Satan.png",
    [isaac_typescript_definitions_1.BossID.IT_LIVES]: "BossName_78.1_ItLives.png",
    [isaac_typescript_definitions_1.BossID.HOLLOW]: "BossName_19.1_TheHollow.png",
    [isaac_typescript_definitions_1.BossID.CARRION_QUEEN]: "BossName_28.2_CarrionQueen.png",
    [isaac_typescript_definitions_1.BossID.GURDY_JR]: "BossName_99.0_GurdyJr.png",
    [isaac_typescript_definitions_1.BossID.HUSK]: "BossName_67.1_TheHusk.png",
    [isaac_typescript_definitions_1.BossID.BLOAT]: "BossName_68.1_Bloat.png",
    [isaac_typescript_definitions_1.BossID.LOKII]: "BossName_69.1_Lokii.png",
    [isaac_typescript_definitions_1.BossID.BLIGHTED_OVUM]: "BossName_79.2_BlightedOvum.png",
    [isaac_typescript_definitions_1.BossID.TERATOMA]: "BossName_71.1_Teratoma.png",
    [isaac_typescript_definitions_1.BossID.WIDOW]: "BossName_100.0_Widow.png",
    [isaac_typescript_definitions_1.BossID.MASK_OF_INFAMY]: "BossName_97.0_MaskOfInfamy.png",
    [isaac_typescript_definitions_1.BossID.WRETCHED]: "BossName_100.1_TheWretched.png",
    [isaac_typescript_definitions_1.BossID.PIN]: "BossName_62.0_Pin.png",
    [isaac_typescript_definitions_1.BossID.CONQUEST]: "BossName_65.1_Conquest.png",
    // There is no dedicated "bossname_" PNG file for Isaac.
    [isaac_typescript_definitions_1.BossID.ISAAC]: "PlayerName_01_Isaac.png",
    [isaac_typescript_definitions_1.BossID.BLUE_BABY]: "BossName_102.1_BlueBaby.png",
    [isaac_typescript_definitions_1.BossID.DADDY_LONG_LEGS]: "BossName_101.0_DaddyLongLegs.png",
    [isaac_typescript_definitions_1.BossID.TRIACHNID]: "BossName_101.1_Triachnid.png",
    [isaac_typescript_definitions_1.BossID.HAUNT]: "BossName_260.0_TheHaunt.png",
    [isaac_typescript_definitions_1.BossID.DINGLE]: "BossName_261.0_Dingle.png",
    [isaac_typescript_definitions_1.BossID.MEGA_MAW]: "Portrait_262.0_MegaMaw.png",
    [isaac_typescript_definitions_1.BossID.GATE]: "BossName_263.0_MegaMaw2.png",
    [isaac_typescript_definitions_1.BossID.MEGA_FATTY]: "BossName_264.0_MegaFatty.png",
    [isaac_typescript_definitions_1.BossID.CAGE]: "BossName_265.0_Fatty2.png",
    [isaac_typescript_definitions_1.BossID.MAMA_GURDY]: "BossName_266.0_MamaGurdy.png",
    [isaac_typescript_definitions_1.BossID.DARK_ONE]: "BossName_267.0_DarkOne.png",
    [isaac_typescript_definitions_1.BossID.ADVERSARY]: "BossName_268.0_DarkOne2.png",
    [isaac_typescript_definitions_1.BossID.POLYCEPHALUS]: "BossName_269.0_Polycephalus.png",
    [isaac_typescript_definitions_1.BossID.MR_FRED]: "BossName_270.0_MegaFred.png",
    [isaac_typescript_definitions_1.BossID.LAMB]: "BossName_273.0_TheLamb.png",
    [isaac_typescript_definitions_1.BossID.MEGA_SATAN]: "BossName_274.0_MegaSatan.png",
    [isaac_typescript_definitions_1.BossID.GURGLING]: "BossName_276.0_Gurglings.png",
    [isaac_typescript_definitions_1.BossID.STAIN]: "BossName_401.0_TheStain.png",
    [isaac_typescript_definitions_1.BossID.BROWNIE]: "BossName_402.0_Brownie.png",
    [isaac_typescript_definitions_1.BossID.FORSAKEN]: "BossName_403.0_TheForsaken.png",
    [isaac_typescript_definitions_1.BossID.LITTLE_HORN]: "BossName_404.0_LittleHorn.png",
    [isaac_typescript_definitions_1.BossID.RAG_MAN]: "BossName_405.0_RagMan.png",
    [isaac_typescript_definitions_1.BossID.ULTRA_GREED]: "BossName_406.0_UltraGreed.png",
    [isaac_typescript_definitions_1.BossID.HUSH]: "BossName_407.0_Hush.png",
    [isaac_typescript_definitions_1.BossID.DANGLE]: "BossName_Dangle.png",
    [isaac_typescript_definitions_1.BossID.TURDLING]: "BossName_Turdlings.png",
    [isaac_typescript_definitions_1.BossID.FRAIL]: "BossName_TheFrail.png",
    [isaac_typescript_definitions_1.BossID.RAG_MEGA]: "BossName_RagMega.png",
    [isaac_typescript_definitions_1.BossID.SISTERS_VIS]: "BossName_SisterssVis.png",
    [isaac_typescript_definitions_1.BossID.BIG_HORN]: "BossName_BigHorn.png",
    [isaac_typescript_definitions_1.BossID.DELIRIUM]: "BossName_Delirium.png",
    // Ultra Greedier uses the same file as Ultra Greed.
    [isaac_typescript_definitions_1.BossID.ULTRA_GREEDIER]: "BossName_406.0_UltraGreed.png",
    [isaac_typescript_definitions_1.BossID.MATRIARCH]: "BossName_Matriarch.png",
    [isaac_typescript_definitions_1.BossID.PILE]: "BossName_Polycephalus2.png",
    [isaac_typescript_definitions_1.BossID.REAP_CREEP]: "BossName_ReapCreep.png",
    [isaac_typescript_definitions_1.BossID.LIL_BLUB]: "BossName_Beelzeblub.png",
    [isaac_typescript_definitions_1.BossID.WORMWOOD]: "BossName_Wormwood.png",
    [isaac_typescript_definitions_1.BossID.RAINMAKER]: "BossName_Rainmaker.png",
    [isaac_typescript_definitions_1.BossID.VISAGE]: "BossName_Visage.png",
    [isaac_typescript_definitions_1.BossID.SIREN]: "BossName_Siren.png",
    [isaac_typescript_definitions_1.BossID.TUFF_TWINS]: "BossName_TuffTwins.png",
    [isaac_typescript_definitions_1.BossID.HERETIC]: "BossName_Heretic.png",
    [isaac_typescript_definitions_1.BossID.HORNFEL]: "BossName_Hornfel.png",
    [isaac_typescript_definitions_1.BossID.GREAT_GIDEON]: "BossName_Gideon.png",
    [isaac_typescript_definitions_1.BossID.BABY_PLUM]: "BossName_BabyPlum.png",
    [isaac_typescript_definitions_1.BossID.SCOURGE]: "BossName_Scourge.png",
    [isaac_typescript_definitions_1.BossID.CHIMERA]: "BossName_Chimera.png",
    [isaac_typescript_definitions_1.BossID.ROTGUT]: "BossName_Rotgut.png",
    [isaac_typescript_definitions_1.BossID.MOTHER]: "BossName_Mother.png",
    // Mom (Mausoleum) uses the same file as Mom.
    [isaac_typescript_definitions_1.BossID.MAUSOLEUM_MOM]: "BossName_45.0_Mom.png",
    // Mom's Heart (Mausoleum) uses the same file as Mom's Heart.
    [isaac_typescript_definitions_1.BossID.MAUSOLEUM_MOMS_HEART]: "BossName_78.0_MomsHeart.png",
    [isaac_typescript_definitions_1.BossID.MIN_MIN]: "BossName_MinMin.png",
    [isaac_typescript_definitions_1.BossID.CLOG]: "BossName_Clog.png",
    [isaac_typescript_definitions_1.BossID.SINGE]: "BossName_Singe.png",
    [isaac_typescript_definitions_1.BossID.BUMBINO]: "BossName_Bumbino.png",
    [isaac_typescript_definitions_1.BossID.COLOSTOMIA]: "BossName_Colostomia.png",
    [isaac_typescript_definitions_1.BossID.SHELL]: "BossName_Shell.png",
    [isaac_typescript_definitions_1.BossID.TURDLET]: "BossName_Turdlet.png",
    [isaac_typescript_definitions_1.BossID.RAGLICH]: "BossName_Raglich.png",
    [isaac_typescript_definitions_1.BossID.DOGMA]: "BossName_Dogma.png",
    // The file name specified in "bossportraits.xml" for The Beast does not actually exist in the
    // game files.
    [isaac_typescript_definitions_1.BossID.BEAST]: "BossName_TheBeast.png",
    [isaac_typescript_definitions_1.BossID.HORNY_BOYS]: "BossName_HornyBoys.png",
    [isaac_typescript_definitions_1.BossID.CLUTCH]: "BossName_Clutch.png", // 102
    // [BossID.CADAVRA]: "BossName_Cadavra.png", // 103
};
