"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BOSS_NAMES = exports.DEFAULT_BOSS_NAME = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
exports.DEFAULT_BOSS_NAME = "Unknown";
/**
 * From "bossportraits.xml".
 *
 * Note that Blue Baby returns "Blue Baby" instead of "???".
 */
exports.BOSS_NAMES = {
    [isaac_typescript_definitions_1.BossID.MONSTRO]: "Monstro",
    [isaac_typescript_definitions_1.BossID.LARRY_JR]: "Larry Jr.",
    [isaac_typescript_definitions_1.BossID.CHUB]: "Chub",
    [isaac_typescript_definitions_1.BossID.GURDY]: "Gurdy",
    [isaac_typescript_definitions_1.BossID.MONSTRO_2]: "Monstro II",
    [isaac_typescript_definitions_1.BossID.MOM]: "Mom",
    [isaac_typescript_definitions_1.BossID.SCOLEX]: "Scolex",
    [isaac_typescript_definitions_1.BossID.MOMS_HEART]: "Mom's Heart",
    [isaac_typescript_definitions_1.BossID.FAMINE]: "Famine",
    [isaac_typescript_definitions_1.BossID.PESTILENCE]: "Pestilence",
    [isaac_typescript_definitions_1.BossID.WAR]: "War",
    [isaac_typescript_definitions_1.BossID.DEATH]: "Death",
    [isaac_typescript_definitions_1.BossID.DUKE_OF_FLIES]: "Duke of Flies",
    [isaac_typescript_definitions_1.BossID.PEEP]: "Peep",
    [isaac_typescript_definitions_1.BossID.LOKI]: "Loki",
    [isaac_typescript_definitions_1.BossID.BLASTOCYST]: "Blastocyst",
    [isaac_typescript_definitions_1.BossID.GEMINI]: "Gemini",
    [isaac_typescript_definitions_1.BossID.FISTULA]: "Fistula",
    [isaac_typescript_definitions_1.BossID.GISH]: "Gish",
    [isaac_typescript_definitions_1.BossID.STEVEN]: "Steven",
    [isaac_typescript_definitions_1.BossID.CHAD]: "C.H.A.D.",
    [isaac_typescript_definitions_1.BossID.HEADLESS_HORSEMAN]: "Headless Horseman",
    [isaac_typescript_definitions_1.BossID.FALLEN]: "The Fallen",
    [isaac_typescript_definitions_1.BossID.SATAN]: "Satan",
    [isaac_typescript_definitions_1.BossID.IT_LIVES]: "It Lives!",
    [isaac_typescript_definitions_1.BossID.HOLLOW]: "The Hollow",
    [isaac_typescript_definitions_1.BossID.CARRION_QUEEN]: "The Carrion Queen",
    [isaac_typescript_definitions_1.BossID.GURDY_JR]: "Gurdy Jr.",
    [isaac_typescript_definitions_1.BossID.HUSK]: "The Husk",
    [isaac_typescript_definitions_1.BossID.BLOAT]: "The Bloat",
    [isaac_typescript_definitions_1.BossID.LOKII]: "Lokii",
    [isaac_typescript_definitions_1.BossID.BLIGHTED_OVUM]: "The Blighted Ovum",
    [isaac_typescript_definitions_1.BossID.TERATOMA]: "Teratoma",
    [isaac_typescript_definitions_1.BossID.WIDOW]: "The Widow",
    [isaac_typescript_definitions_1.BossID.MASK_OF_INFAMY]: "Mask of Infamy",
    [isaac_typescript_definitions_1.BossID.WRETCHED]: "The Wretched",
    [isaac_typescript_definitions_1.BossID.PIN]: "Pin",
    [isaac_typescript_definitions_1.BossID.CONQUEST]: "Conquest",
    [isaac_typescript_definitions_1.BossID.ISAAC]: "Isaac",
    [isaac_typescript_definitions_1.BossID.BLUE_BABY]: "Blue Baby",
    [isaac_typescript_definitions_1.BossID.DADDY_LONG_LEGS]: "Daddy Long Legs",
    [isaac_typescript_definitions_1.BossID.TRIACHNID]: "Triachnid",
    [isaac_typescript_definitions_1.BossID.HAUNT]: "The Haunt",
    [isaac_typescript_definitions_1.BossID.DINGLE]: "Dingle",
    [isaac_typescript_definitions_1.BossID.MEGA_MAW]: "Mega Maw",
    // "Mega Maw II" is changed to "The Gate".
    [isaac_typescript_definitions_1.BossID.GATE]: "The Gate",
    [isaac_typescript_definitions_1.BossID.MEGA_FATTY]: "Mega Fatty",
    // "Mega Fatty II" is changed to "The Cage".
    [isaac_typescript_definitions_1.BossID.CAGE]: "The Cage",
    [isaac_typescript_definitions_1.BossID.MAMA_GURDY]: "Mega Gurdy",
    [isaac_typescript_definitions_1.BossID.DARK_ONE]: "Dark One",
    // "Dark One II" is changed to "The Adversary".
    [isaac_typescript_definitions_1.BossID.ADVERSARY]: "The Adversary",
    [isaac_typescript_definitions_1.BossID.POLYCEPHALUS]: "Polycephalus",
    // "Mega Fred" is changed to "Mr. Fred".
    [isaac_typescript_definitions_1.BossID.MR_FRED]: "Mr. Fred",
    [isaac_typescript_definitions_1.BossID.LAMB]: "The Lamb",
    [isaac_typescript_definitions_1.BossID.MEGA_SATAN]: "Mega Satan",
    [isaac_typescript_definitions_1.BossID.GURGLING]: "Gurglings",
    [isaac_typescript_definitions_1.BossID.STAIN]: "The Stain",
    [isaac_typescript_definitions_1.BossID.BROWNIE]: "Brownie",
    [isaac_typescript_definitions_1.BossID.FORSAKEN]: "The Forsaken",
    [isaac_typescript_definitions_1.BossID.LITTLE_HORN]: "Little Horn",
    [isaac_typescript_definitions_1.BossID.RAG_MAN]: "Rag Man",
    [isaac_typescript_definitions_1.BossID.ULTRA_GREED]: "Ultra Greed",
    [isaac_typescript_definitions_1.BossID.HUSH]: "Hush",
    [isaac_typescript_definitions_1.BossID.DANGLE]: "Dangle",
    [isaac_typescript_definitions_1.BossID.TURDLING]: "Turdling",
    [isaac_typescript_definitions_1.BossID.FRAIL]: "The Frail",
    [isaac_typescript_definitions_1.BossID.RAG_MEGA]: "Rag Mega",
    [isaac_typescript_definitions_1.BossID.SISTERS_VIS]: "Sisters Vis",
    [isaac_typescript_definitions_1.BossID.BIG_HORN]: "Big Horn",
    [isaac_typescript_definitions_1.BossID.DELIRIUM]: "Delirium",
    [isaac_typescript_definitions_1.BossID.ULTRA_GREEDIER]: "Ultra Greedier",
    [isaac_typescript_definitions_1.BossID.MATRIARCH]: "The Matriarch",
    [isaac_typescript_definitions_1.BossID.PILE]: "The Pile",
    [isaac_typescript_definitions_1.BossID.REAP_CREEP]: "Reap Creep",
    // "Beelzeblub" is changed to "Lil Blub".
    [isaac_typescript_definitions_1.BossID.LIL_BLUB]: "Lil Blub",
    [isaac_typescript_definitions_1.BossID.WORMWOOD]: "Wormwood",
    [isaac_typescript_definitions_1.BossID.RAINMAKER]: "The Rainmaker",
    [isaac_typescript_definitions_1.BossID.VISAGE]: "The Visage",
    [isaac_typescript_definitions_1.BossID.SIREN]: "The Siren",
    [isaac_typescript_definitions_1.BossID.TUFF_TWINS]: "Tuff Twins",
    [isaac_typescript_definitions_1.BossID.HERETIC]: "The Heretic",
    [isaac_typescript_definitions_1.BossID.HORNFEL]: "Hornfel",
    [isaac_typescript_definitions_1.BossID.GREAT_GIDEON]: "Great Gideon",
    [isaac_typescript_definitions_1.BossID.BABY_PLUM]: "Baby Plum",
    [isaac_typescript_definitions_1.BossID.SCOURGE]: "The Scourge",
    [isaac_typescript_definitions_1.BossID.CHIMERA]: "Chimera",
    [isaac_typescript_definitions_1.BossID.ROTGUT]: "Rotgut",
    [isaac_typescript_definitions_1.BossID.MOTHER]: "Mother",
    [isaac_typescript_definitions_1.BossID.MAUSOLEUM_MOM]: "Mom (Mausoleum)",
    [isaac_typescript_definitions_1.BossID.MAUSOLEUM_MOMS_HEART]: "Mom's Heart (Mausoleum)",
    [isaac_typescript_definitions_1.BossID.MIN_MIN]: "Min-Min",
    [isaac_typescript_definitions_1.BossID.CLOG]: "Clog",
    [isaac_typescript_definitions_1.BossID.SINGE]: "Singe",
    [isaac_typescript_definitions_1.BossID.BUMBINO]: "Bumbino",
    [isaac_typescript_definitions_1.BossID.COLOSTOMIA]: "Colostomia",
    [isaac_typescript_definitions_1.BossID.SHELL]: "The Shell",
    [isaac_typescript_definitions_1.BossID.TURDLET]: "Turdlet",
    [isaac_typescript_definitions_1.BossID.RAGLICH]: "Raglich",
    [isaac_typescript_definitions_1.BossID.DOGMA]: "Dogma",
    [isaac_typescript_definitions_1.BossID.BEAST]: "The Beast",
    [isaac_typescript_definitions_1.BossID.HORNY_BOYS]: "Horny Boys",
    [isaac_typescript_definitions_1.BossID.CLUTCH]: "Clutch", // 102
};
