"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHALLENGE_COLLECTIBLE_TYPES = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
/**
 * Contains the extra starting collectibles for each challenge. Challenges that do not grant extra
 * starting collectibles are represented by an empty array.
 *
 * Taken from the "challenges.xml" file.
 */
exports.CHALLENGE_COLLECTIBLE_TYPES = {
    // 0
    [isaac_typescript_definitions_1.Challenge.NULL]: [],
    // 1
    [isaac_typescript_definitions_1.Challenge.PITCH_BLACK]: [],
    // 2
    [isaac_typescript_definitions_1.Challenge.HIGH_BROW]: [
        isaac_typescript_definitions_1.CollectibleType.NUMBER_ONE,
        isaac_typescript_definitions_1.CollectibleType.BUTT_BOMBS,
        isaac_typescript_definitions_1.CollectibleType.E_COLI,
        isaac_typescript_definitions_1.CollectibleType.FLUSH, // 291
    ],
    // 3
    [isaac_typescript_definitions_1.Challenge.HEAD_TRAUMA]: [
        isaac_typescript_definitions_1.CollectibleType.SMALL_ROCK,
        isaac_typescript_definitions_1.CollectibleType.IRON_BAR,
        isaac_typescript_definitions_1.CollectibleType.TINY_PLANET,
        isaac_typescript_definitions_1.CollectibleType.SOY_MILK, // 330
    ],
    // 4
    [isaac_typescript_definitions_1.Challenge.DARKNESS_FALLS]: [
        isaac_typescript_definitions_1.CollectibleType.PENTAGRAM,
        isaac_typescript_definitions_1.CollectibleType.RAZOR_BLADE,
        isaac_typescript_definitions_1.CollectibleType.SACRIFICIAL_DAGGER,
        isaac_typescript_definitions_1.CollectibleType.DARK_MATTER, // 259
    ],
    // 5
    [isaac_typescript_definitions_1.Challenge.TANK]: [
        isaac_typescript_definitions_1.CollectibleType.BUCKET_OF_LARD,
        isaac_typescript_definitions_1.CollectibleType.INFAMY,
        isaac_typescript_definitions_1.CollectibleType.THUNDER_THIGHS, // 314
    ],
    // 6
    [isaac_typescript_definitions_1.Challenge.SOLAR_SYSTEM]: [
        isaac_typescript_definitions_1.CollectibleType.HALO_OF_FLIES,
        isaac_typescript_definitions_1.CollectibleType.TRANSCENDENCE,
        isaac_typescript_definitions_1.CollectibleType.DISTANT_ADMIRATION,
        isaac_typescript_definitions_1.CollectibleType.FOREVER_ALONE, // 128
    ],
    // 7
    [isaac_typescript_definitions_1.Challenge.SUICIDE_KING]: [
        isaac_typescript_definitions_1.CollectibleType.MY_REFLECTION,
        isaac_typescript_definitions_1.CollectibleType.MR_MEGA,
        isaac_typescript_definitions_1.CollectibleType.IPECAC, // 149
    ],
    // 8
    [isaac_typescript_definitions_1.Challenge.CAT_GOT_YOUR_TONGUE]: [
        isaac_typescript_definitions_1.CollectibleType.GUPPYS_TAIL,
        isaac_typescript_definitions_1.CollectibleType.GUPPYS_HEAD,
        isaac_typescript_definitions_1.CollectibleType.GUPPYS_HAIRBALL, // 187
    ],
    // 9
    [isaac_typescript_definitions_1.Challenge.DEMO_MAN]: [
        isaac_typescript_definitions_1.CollectibleType.DR_FETUS,
        isaac_typescript_definitions_1.CollectibleType.REMOTE_DETONATOR, // 137
    ],
    // 10
    [isaac_typescript_definitions_1.Challenge.CURSED]: [
        isaac_typescript_definitions_1.CollectibleType.RAW_LIVER,
        isaac_typescript_definitions_1.CollectibleType.COMPASS,
        isaac_typescript_definitions_1.CollectibleType.TREASURE_MAP,
        isaac_typescript_definitions_1.CollectibleType.BLUE_MAP, // 246
    ],
    // 11
    [isaac_typescript_definitions_1.Challenge.GLASS_CANNON]: [
        isaac_typescript_definitions_1.CollectibleType.LOKIS_HORNS,
        isaac_typescript_definitions_1.CollectibleType.EPIC_FETUS, // 168
    ],
    // 12
    [isaac_typescript_definitions_1.Challenge.WHEN_LIFE_GIVES_YOU_LEMONS]: [
        isaac_typescript_definitions_1.CollectibleType.LEMON_MISHAP,
        isaac_typescript_definitions_1.CollectibleType.NINE_VOLT,
        isaac_typescript_definitions_1.CollectibleType.HABIT, // 156
    ],
    // 13
    [isaac_typescript_definitions_1.Challenge.BEANS]: [
        isaac_typescript_definitions_1.CollectibleType.BEAN,
        isaac_typescript_definitions_1.CollectibleType.NINE_VOLT,
        isaac_typescript_definitions_1.CollectibleType.BLACK_BEAN,
        isaac_typescript_definitions_1.CollectibleType.PYRO,
        isaac_typescript_definitions_1.CollectibleType.BUTT_BOMBS, // 209
    ],
    // 14
    [isaac_typescript_definitions_1.Challenge.ITS_IN_THE_CARDS]: [
        isaac_typescript_definitions_1.CollectibleType.BATTERY,
        isaac_typescript_definitions_1.CollectibleType.DECK_OF_CARDS,
        isaac_typescript_definitions_1.CollectibleType.NINE_VOLT,
        isaac_typescript_definitions_1.CollectibleType.STARTER_DECK, // 251
    ],
    // 15
    [isaac_typescript_definitions_1.Challenge.SLOW_ROLL]: [
        isaac_typescript_definitions_1.CollectibleType.MY_REFLECTION,
        isaac_typescript_definitions_1.CollectibleType.CUPIDS_ARROW,
        isaac_typescript_definitions_1.CollectibleType.POLYPHEMUS, // 169
    ],
    // 16
    [isaac_typescript_definitions_1.Challenge.COMPUTER_SAVY]: [
        isaac_typescript_definitions_1.CollectibleType.SPOON_BENDER,
        isaac_typescript_definitions_1.CollectibleType.TECHNOLOGY,
        isaac_typescript_definitions_1.CollectibleType.TECHNOLOGY_2, // 152
    ],
    // 17
    [isaac_typescript_definitions_1.Challenge.WAKA_WAKA]: [
        isaac_typescript_definitions_1.CollectibleType.ANTI_GRAVITY,
        isaac_typescript_definitions_1.CollectibleType.STRANGE_ATTRACTOR, // 315
    ],
    // 18
    [isaac_typescript_definitions_1.Challenge.HOST]: [
        isaac_typescript_definitions_1.CollectibleType.MULLIGAN,
        isaac_typescript_definitions_1.CollectibleType.SPIDERBABY, // 211
    ],
    // 19
    [isaac_typescript_definitions_1.Challenge.FAMILY_MAN]: [
        isaac_typescript_definitions_1.CollectibleType.BROTHER_BOBBY,
        isaac_typescript_definitions_1.CollectibleType.SISTER_MAGGY,
        isaac_typescript_definitions_1.CollectibleType.DADS_KEY,
        isaac_typescript_definitions_1.CollectibleType.BFFS,
        isaac_typescript_definitions_1.CollectibleType.ROTTEN_BABY, // 268
    ],
    // 20
    [isaac_typescript_definitions_1.Challenge.PURIST]: [],
    // 21
    [isaac_typescript_definitions_1.Challenge.XXXXXXXXL]: [],
    // 22
    [isaac_typescript_definitions_1.Challenge.SPEED]: [],
    // 23
    [isaac_typescript_definitions_1.Challenge.BLUE_BOMBER]: [
        isaac_typescript_definitions_1.CollectibleType.BROTHER_BOBBY,
        isaac_typescript_definitions_1.CollectibleType.KAMIKAZE,
        isaac_typescript_definitions_1.CollectibleType.MR_MEGA,
        isaac_typescript_definitions_1.CollectibleType.PYROMANIAC, // 223
    ],
    // 24
    [isaac_typescript_definitions_1.Challenge.PAY_TO_PLAY]: [
        isaac_typescript_definitions_1.CollectibleType.SACK_OF_PENNIES,
        isaac_typescript_definitions_1.CollectibleType.MONEY_EQUALS_POWER, // 109
    ],
    // 25
    [isaac_typescript_definitions_1.Challenge.HAVE_A_HEART]: [
        isaac_typescript_definitions_1.CollectibleType.CHARM_OF_THE_VAMPIRE, // 62
    ],
    // 26
    [isaac_typescript_definitions_1.Challenge.I_RULE]: [
        isaac_typescript_definitions_1.CollectibleType.LADDER,
        isaac_typescript_definitions_1.CollectibleType.MOMS_KNIFE,
        isaac_typescript_definitions_1.CollectibleType.TRINITY_SHIELD,
        isaac_typescript_definitions_1.CollectibleType.BOOMERANG, // 338
    ],
    // 27
    [isaac_typescript_definitions_1.Challenge.BRAINS]: [
        isaac_typescript_definitions_1.CollectibleType.BOBS_BRAIN,
        isaac_typescript_definitions_1.CollectibleType.BOBS_BRAIN,
        isaac_typescript_definitions_1.CollectibleType.BOBS_BRAIN,
        isaac_typescript_definitions_1.CollectibleType.THUNDER_THIGHS, // 314
    ],
    // 28
    [isaac_typescript_definitions_1.Challenge.PRIDE_DAY]: [
        isaac_typescript_definitions_1.CollectibleType.RAINBOW_BABY,
        isaac_typescript_definitions_1.CollectibleType.THREE_DOLLAR_BILL, // 191
    ],
    // 29
    [isaac_typescript_definitions_1.Challenge.ONANS_STREAK]: [
        isaac_typescript_definitions_1.CollectibleType.CHOCOLATE_MILK, // 69
    ],
    // 30
    [isaac_typescript_definitions_1.Challenge.GUARDIAN]: [
        isaac_typescript_definitions_1.CollectibleType.HOLY_GRAIL,
        isaac_typescript_definitions_1.CollectibleType.ISAACS_HEART,
        isaac_typescript_definitions_1.CollectibleType.PUNCHING_BAG,
        isaac_typescript_definitions_1.CollectibleType.SPEAR_OF_DESTINY, // 400
    ],
    // 31
    [isaac_typescript_definitions_1.Challenge.BACKASSWARDS]: [],
    // 32
    [isaac_typescript_definitions_1.Challenge.APRILS_FOOL]: [],
    // 33
    [isaac_typescript_definitions_1.Challenge.POKEY_MANS]: [
        isaac_typescript_definitions_1.CollectibleType.MOMS_EYESHADOW,
        isaac_typescript_definitions_1.CollectibleType.FRIEND_BALL, // 382
    ],
    // 34
    [isaac_typescript_definitions_1.Challenge.ULTRA_HARD]: [
        isaac_typescript_definitions_1.CollectibleType.BOOK_OF_REVELATIONS,
        isaac_typescript_definitions_1.CollectibleType.CAFFEINE_PILL, // 340
    ],
    // 35
    [isaac_typescript_definitions_1.Challenge.PONG]: [
        isaac_typescript_definitions_1.CollectibleType.CUPIDS_ARROW,
        isaac_typescript_definitions_1.CollectibleType.RUBBER_CEMENT, // 221
    ],
    // 36
    [isaac_typescript_definitions_1.Challenge.SCAT_MAN]: [
        isaac_typescript_definitions_1.CollectibleType.SKATOLE,
        isaac_typescript_definitions_1.CollectibleType.POOP,
        isaac_typescript_definitions_1.CollectibleType.NINE_VOLT,
        isaac_typescript_definitions_1.CollectibleType.BUTT_BOMBS,
        isaac_typescript_definitions_1.CollectibleType.BUTT_BOMBS,
        isaac_typescript_definitions_1.CollectibleType.BUTT_BOMBS,
        isaac_typescript_definitions_1.CollectibleType.E_COLI,
        isaac_typescript_definitions_1.CollectibleType.BFFS,
        isaac_typescript_definitions_1.CollectibleType.THUNDER_THIGHS,
        isaac_typescript_definitions_1.CollectibleType.DIRTY_MIND, // 576
    ],
    // 37
    [isaac_typescript_definitions_1.Challenge.BLOODY_MARY]: [
        // Note that in "challenges.xml", it also includes "-584", which removes Book of Virtues from
        // Bethany.
        isaac_typescript_definitions_1.CollectibleType.BOOK_OF_BELIAL,
        isaac_typescript_definitions_1.CollectibleType.BLOOD_BAG,
        isaac_typescript_definitions_1.CollectibleType.ANEMIC,
        isaac_typescript_definitions_1.CollectibleType.BLOOD_OATH, // 569
    ],
    // 38
    [isaac_typescript_definitions_1.Challenge.BAPTISM_BY_FIRE]: [
        // Note that in "challenges.xml", it also includes "-584", which removes Book of Virtues from
        // Bethany.
        isaac_typescript_definitions_1.CollectibleType.GUPPYS_PAW,
        isaac_typescript_definitions_1.CollectibleType.SCHOOLBAG,
        isaac_typescript_definitions_1.CollectibleType.URN_OF_SOULS, // 640
    ],
    // 39
    [isaac_typescript_definitions_1.Challenge.ISAACS_AWAKENING]: [
        isaac_typescript_definitions_1.CollectibleType.TRINITY_SHIELD,
        isaac_typescript_definitions_1.CollectibleType.SPIRIT_SWORD,
        isaac_typescript_definitions_1.CollectibleType.MOMS_BRACELET, // 604
    ],
    // 40
    [isaac_typescript_definitions_1.Challenge.SEEING_DOUBLE]: [245],
    // 41
    [isaac_typescript_definitions_1.Challenge.PICA_RUN]: [
        isaac_typescript_definitions_1.CollectibleType.MOMS_PURSE,
        isaac_typescript_definitions_1.CollectibleType.MOMS_BOX,
        isaac_typescript_definitions_1.CollectibleType.MARBLES, // 538
    ],
    // 42
    [isaac_typescript_definitions_1.Challenge.HOT_POTATO]: [],
    // 43
    [isaac_typescript_definitions_1.Challenge.CANTRIPPED]: [],
    // 44
    [isaac_typescript_definitions_1.Challenge.RED_REDEMPTION]: [
        isaac_typescript_definitions_1.CollectibleType.DADS_KEY, // 175
    ],
    // 45
    [isaac_typescript_definitions_1.Challenge.DELETE_THIS]: [isaac_typescript_definitions_1.CollectibleType.TMTRAINER],
};
