"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHALLENGE_TRINKET_TYPE = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
/**
 * Contains the starting trinket for each challenge. Challenges that do not grant a starting trinket
 * will have a value of `undefined`.
 *
 * Taken from the "challenges.xml" file.
 */
exports.CHALLENGE_TRINKET_TYPE = {
    [isaac_typescript_definitions_1.Challenge.NULL]: undefined,
    [isaac_typescript_definitions_1.Challenge.PITCH_BLACK]: undefined,
    [isaac_typescript_definitions_1.Challenge.HIGH_BROW]: isaac_typescript_definitions_1.TrinketType.PETRIFIED_POOP,
    [isaac_typescript_definitions_1.Challenge.HEAD_TRAUMA]: undefined,
    [isaac_typescript_definitions_1.Challenge.DARKNESS_FALLS]: undefined,
    [isaac_typescript_definitions_1.Challenge.TANK]: undefined,
    [isaac_typescript_definitions_1.Challenge.SOLAR_SYSTEM]: undefined,
    [isaac_typescript_definitions_1.Challenge.SUICIDE_KING]: undefined,
    [isaac_typescript_definitions_1.Challenge.CAT_GOT_YOUR_TONGUE]: undefined,
    [isaac_typescript_definitions_1.Challenge.DEMO_MAN]: isaac_typescript_definitions_1.TrinketType.MATCH_STICK,
    [isaac_typescript_definitions_1.Challenge.CURSED]: isaac_typescript_definitions_1.TrinketType.CHILDS_HEART,
    [isaac_typescript_definitions_1.Challenge.GLASS_CANNON]: undefined,
    [isaac_typescript_definitions_1.Challenge.WHEN_LIFE_GIVES_YOU_LEMONS]: undefined,
    [isaac_typescript_definitions_1.Challenge.BEANS]: undefined,
    [isaac_typescript_definitions_1.Challenge.ITS_IN_THE_CARDS]: undefined,
    [isaac_typescript_definitions_1.Challenge.SLOW_ROLL]: undefined,
    [isaac_typescript_definitions_1.Challenge.COMPUTER_SAVY]: undefined,
    [isaac_typescript_definitions_1.Challenge.WAKA_WAKA]: undefined,
    [isaac_typescript_definitions_1.Challenge.HOST]: isaac_typescript_definitions_1.TrinketType.TICK,
    [isaac_typescript_definitions_1.Challenge.FAMILY_MAN]: undefined,
    [isaac_typescript_definitions_1.Challenge.PURIST]: undefined,
    [isaac_typescript_definitions_1.Challenge.XXXXXXXXL]: undefined,
    [isaac_typescript_definitions_1.Challenge.SPEED]: undefined,
    [isaac_typescript_definitions_1.Challenge.BLUE_BOMBER]: undefined,
    [isaac_typescript_definitions_1.Challenge.PAY_TO_PLAY]: undefined,
    [isaac_typescript_definitions_1.Challenge.HAVE_A_HEART]: undefined,
    [isaac_typescript_definitions_1.Challenge.I_RULE]: undefined,
    [isaac_typescript_definitions_1.Challenge.BRAINS]: undefined,
    [isaac_typescript_definitions_1.Challenge.PRIDE_DAY]: isaac_typescript_definitions_1.TrinketType.RAINBOW_WORM,
    [isaac_typescript_definitions_1.Challenge.ONANS_STREAK]: undefined,
    [isaac_typescript_definitions_1.Challenge.GUARDIAN]: undefined,
    [isaac_typescript_definitions_1.Challenge.BACKASSWARDS]: undefined,
    [isaac_typescript_definitions_1.Challenge.APRILS_FOOL]: undefined,
    [isaac_typescript_definitions_1.Challenge.POKEY_MANS]: undefined,
    [isaac_typescript_definitions_1.Challenge.ULTRA_HARD]: undefined,
    [isaac_typescript_definitions_1.Challenge.PONG]: undefined,
    [isaac_typescript_definitions_1.Challenge.SCAT_MAN]: isaac_typescript_definitions_1.TrinketType.MYSTERIOUS_CANDY,
    [isaac_typescript_definitions_1.Challenge.BLOODY_MARY]: isaac_typescript_definitions_1.TrinketType.CHILDS_HEART,
    [isaac_typescript_definitions_1.Challenge.BAPTISM_BY_FIRE]: isaac_typescript_definitions_1.TrinketType.MAGGYS_FAITH,
    [isaac_typescript_definitions_1.Challenge.ISAACS_AWAKENING]: undefined,
    [isaac_typescript_definitions_1.Challenge.SEEING_DOUBLE]: undefined,
    [isaac_typescript_definitions_1.Challenge.PICA_RUN]: undefined,
    [isaac_typescript_definitions_1.Challenge.HOT_POTATO]: undefined,
    [isaac_typescript_definitions_1.Challenge.CANTRIPPED]: undefined,
    [isaac_typescript_definitions_1.Challenge.RED_REDEMPTION]: undefined,
    [isaac_typescript_definitions_1.Challenge.DELETE_THIS]: undefined, // 45
};
