"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CHARACTER_STARTING_COLLECTIBLE_TYPES = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
exports.CHARACTER_STARTING_COLLECTIBLE_TYPES = {
    // -1
    [isaac_typescript_definitions_1.PlayerType.POSSESSOR]: [],
    // 0
    [isaac_typescript_definitions_1.PlayerType.ISAAC]: [isaac_typescript_definitions_1.CollectibleType.D6],
    // 1
    [isaac_typescript_definitions_1.PlayerType.MAGDALENE]: [isaac_typescript_definitions_1.CollectibleType.YUM_HEART],
    // 2
    [isaac_typescript_definitions_1.PlayerType.CAIN]: [isaac_typescript_definitions_1.CollectibleType.LUCKY_FOOT],
    // 3
    [isaac_typescript_definitions_1.PlayerType.JUDAS]: [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_BELIAL],
    // 4
    [isaac_typescript_definitions_1.PlayerType.BLUE_BABY]: [isaac_typescript_definitions_1.CollectibleType.POOP],
    // 5
    [isaac_typescript_definitions_1.PlayerType.EVE]: [
        isaac_typescript_definitions_1.CollectibleType.DEAD_BIRD,
        isaac_typescript_definitions_1.CollectibleType.WHORE_OF_BABYLON,
        isaac_typescript_definitions_1.CollectibleType.RAZOR_BLADE, // 126
    ],
    // 6
    [isaac_typescript_definitions_1.PlayerType.SAMSON]: [isaac_typescript_definitions_1.CollectibleType.BLOODY_LUST],
    // 7
    [isaac_typescript_definitions_1.PlayerType.AZAZEL]: [],
    // 8
    [isaac_typescript_definitions_1.PlayerType.LAZARUS]: [isaac_typescript_definitions_1.CollectibleType.ANEMIC],
    // (Lazarus Rags is not granted; the extra life is innate.)
    // 9
    [isaac_typescript_definitions_1.PlayerType.EDEN]: [],
    // 10
    [isaac_typescript_definitions_1.PlayerType.LOST]: [isaac_typescript_definitions_1.CollectibleType.ETERNAL_D6],
    // (Holy Mantle is not granted; the effect is innate.)
    // 11
    [isaac_typescript_definitions_1.PlayerType.LAZARUS_2]: [isaac_typescript_definitions_1.CollectibleType.ANEMIC],
    // (Even if the run is started as Lazarus 2 using e.g. `restart 11`, Anemic is still granted.)
    // 12
    [isaac_typescript_definitions_1.PlayerType.DARK_JUDAS]: [],
    // 13
    [isaac_typescript_definitions_1.PlayerType.LILITH]: [
        isaac_typescript_definitions_1.CollectibleType.BOX_OF_FRIENDS,
        isaac_typescript_definitions_1.CollectibleType.CAMBION_CONCEPTION, // 412
    ],
    // 14
    [isaac_typescript_definitions_1.PlayerType.KEEPER]: [isaac_typescript_definitions_1.CollectibleType.WOODEN_NICKEL],
    // 15
    [isaac_typescript_definitions_1.PlayerType.APOLLYON]: [isaac_typescript_definitions_1.CollectibleType.VOID],
    // 16
    [isaac_typescript_definitions_1.PlayerType.FORGOTTEN]: [],
    // 17
    [isaac_typescript_definitions_1.PlayerType.SOUL]: [],
    // 18
    [isaac_typescript_definitions_1.PlayerType.BETHANY]: [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_VIRTUES],
    // 19
    [isaac_typescript_definitions_1.PlayerType.JACOB]: [],
    // 20
    [isaac_typescript_definitions_1.PlayerType.ESAU]: [],
    // 21
    [isaac_typescript_definitions_1.PlayerType.ISAAC_B]: [],
    // 22
    [isaac_typescript_definitions_1.PlayerType.MAGDALENE_B]: [isaac_typescript_definitions_1.CollectibleType.YUM_HEART],
    // 23
    [isaac_typescript_definitions_1.PlayerType.CAIN_B]: [isaac_typescript_definitions_1.CollectibleType.BAG_OF_CRAFTING],
    // 24
    [isaac_typescript_definitions_1.PlayerType.JUDAS_B]: [isaac_typescript_definitions_1.CollectibleType.DARK_ARTS],
    // 25
    [isaac_typescript_definitions_1.PlayerType.BLUE_BABY_B]: [isaac_typescript_definitions_1.CollectibleType.HOLD],
    // 26
    [isaac_typescript_definitions_1.PlayerType.EVE_B]: [isaac_typescript_definitions_1.CollectibleType.SUMPTORIUM],
    // 27
    [isaac_typescript_definitions_1.PlayerType.SAMSON_B]: [],
    // (Berserk is not granted; the rage is innate.)
    // 28
    [isaac_typescript_definitions_1.PlayerType.AZAZEL_B]: [],
    // 29
    [isaac_typescript_definitions_1.PlayerType.LAZARUS_B]: [isaac_typescript_definitions_1.CollectibleType.FLIP],
    // 30
    [isaac_typescript_definitions_1.PlayerType.EDEN_B]: [],
    // 31
    [isaac_typescript_definitions_1.PlayerType.LOST_B]: [],
    // 32
    [isaac_typescript_definitions_1.PlayerType.LILITH_B]: [],
    // 33
    [isaac_typescript_definitions_1.PlayerType.KEEPER_B]: [],
    // 34
    [isaac_typescript_definitions_1.PlayerType.APOLLYON_B]: [isaac_typescript_definitions_1.CollectibleType.ABYSS],
    // 35
    [isaac_typescript_definitions_1.PlayerType.FORGOTTEN_B]: [],
    // 36
    [isaac_typescript_definitions_1.PlayerType.BETHANY_B]: [isaac_typescript_definitions_1.CollectibleType.LEMEGETON],
    // 37
    [isaac_typescript_definitions_1.PlayerType.JACOB_B]: [isaac_typescript_definitions_1.CollectibleType.ANIMA_SOLA],
    // 38
    [isaac_typescript_definitions_1.PlayerType.LAZARUS_2_B]: [isaac_typescript_definitions_1.CollectibleType.FLIP],
    // (Even if the run is started as Dead Tainted Lazarus using e.g. `restart 38`, Flip is still
    // granted.)
    // 39
    [isaac_typescript_definitions_1.PlayerType.JACOB_2_B]: [isaac_typescript_definitions_1.CollectibleType.ANIMA_SOLA],
    // (Even if the run is started as Tainted Jacob in "Lost" form using e.g. `restart 39`, Anima Sola
    // is still granted.)
    // 40
    [isaac_typescript_definitions_1.PlayerType.SOUL_B]: [],
};
