"use strict";
/* cspell:disable */
Object.defineProperty(exports, "__esModule", { value: true });
exports.COLLECTIBLE_DESCRIPTIONS = exports.DEFAULT_COLLECTIBLE_DESCRIPTION = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
exports.DEFAULT_COLLECTIBLE_DESCRIPTION = "Unknown";
/** Maps collectible types to the real English descriptions from the "stringtable.sta" file. */
exports.COLLECTIBLE_DESCRIPTIONS = {
    [isaac_typescript_definitions_1.CollectibleType.NULL]: exports.DEFAULT_COLLECTIBLE_DESCRIPTION,
    [isaac_typescript_definitions_1.CollectibleType.SAD_ONION]: "Tears up",
    [isaac_typescript_definitions_1.CollectibleType.INNER_EYE]: "Triple shot",
    [isaac_typescript_definitions_1.CollectibleType.SPOON_BENDER]: "Homing shots",
    [isaac_typescript_definitions_1.CollectibleType.CRICKETS_HEAD]: "DMG up",
    [isaac_typescript_definitions_1.CollectibleType.MY_REFLECTION]: "Boomerang tears",
    [isaac_typescript_definitions_1.CollectibleType.NUMBER_ONE]: "Tears up + range down",
    [isaac_typescript_definitions_1.CollectibleType.BLOOD_OF_THE_MARTYR]: "DMG up",
    [isaac_typescript_definitions_1.CollectibleType.BROTHER_BOBBY]: "Friends 'till the end",
    [isaac_typescript_definitions_1.CollectibleType.SKATOLE]: "Fly love",
    [isaac_typescript_definitions_1.CollectibleType.HALO_OF_FLIES]: "Projectile protection",
    [isaac_typescript_definitions_1.CollectibleType.ONE_UP]: "Extra life",
    [isaac_typescript_definitions_1.CollectibleType.MAGIC_MUSHROOM]: "All stats up!",
    [isaac_typescript_definitions_1.CollectibleType.VIRUS]: "Poison touch + speed up",
    [isaac_typescript_definitions_1.CollectibleType.ROID_RAGE]: "Speed and range up",
    [isaac_typescript_definitions_1.CollectibleType.HEART]: "HP up",
    [isaac_typescript_definitions_1.CollectibleType.RAW_LIVER]: "HP up",
    [isaac_typescript_definitions_1.CollectibleType.SKELETON_KEY]: "99 keys",
    [isaac_typescript_definitions_1.CollectibleType.DOLLAR]: "$$$",
    [isaac_typescript_definitions_1.CollectibleType.BOOM]: "10 bombs",
    [isaac_typescript_definitions_1.CollectibleType.TRANSCENDENCE]: "We all float down here...",
    [isaac_typescript_definitions_1.CollectibleType.COMPASS]: "The end is near",
    [isaac_typescript_definitions_1.CollectibleType.LUNCH]: "HP up",
    [isaac_typescript_definitions_1.CollectibleType.DINNER]: "HP up",
    [isaac_typescript_definitions_1.CollectibleType.DESSERT]: "HP up",
    [isaac_typescript_definitions_1.CollectibleType.BREAKFAST]: "HP up",
    [isaac_typescript_definitions_1.CollectibleType.ROTTEN_MEAT]: "HP up",
    [isaac_typescript_definitions_1.CollectibleType.WOODEN_SPOON]: "Speed up",
    [isaac_typescript_definitions_1.CollectibleType.BELT]: "Speed up",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_UNDERWEAR]: "Range up",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_HEELS]: "Range up",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_LIPSTICK]: "Range up",
    [isaac_typescript_definitions_1.CollectibleType.WIRE_COAT_HANGER]: "Tears up",
    [isaac_typescript_definitions_1.CollectibleType.BIBLE]: "Temporary flight",
    [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_BELIAL]: "Temporary DMG up",
    [isaac_typescript_definitions_1.CollectibleType.NECRONOMICON]: "Mass room damage",
    [isaac_typescript_definitions_1.CollectibleType.POOP]: "Plop!",
    [isaac_typescript_definitions_1.CollectibleType.MR_BOOM]: "Reusable bomb buddy",
    [isaac_typescript_definitions_1.CollectibleType.TAMMYS_HEAD]: "Reusable tear burst",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_BRA]: "Mass paralysis",
    [isaac_typescript_definitions_1.CollectibleType.KAMIKAZE]: "Become the bomb!",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_PAD]: "Mass fear",
    [isaac_typescript_definitions_1.CollectibleType.BOBS_ROTTEN_HEAD]: "Reusable ranged bomb",
    // There is no `CollectibleType` with a value of 43.
    [isaac_typescript_definitions_1.CollectibleType.TELEPORT]: "Teleport!",
    [isaac_typescript_definitions_1.CollectibleType.YUM_HEART]: "Reusable regeneration",
    [isaac_typescript_definitions_1.CollectibleType.LUCKY_FOOT]: "Luck up",
    [isaac_typescript_definitions_1.CollectibleType.DOCTORS_REMOTE]: "Reusable air strike",
    [isaac_typescript_definitions_1.CollectibleType.CUPIDS_ARROW]: "Piercing shots",
    [isaac_typescript_definitions_1.CollectibleType.SHOOP_DA_WHOOP]: "BLLLARRRRGGG!",
    [isaac_typescript_definitions_1.CollectibleType.STEVEN]: "DMG up",
    [isaac_typescript_definitions_1.CollectibleType.PENTAGRAM]: "DMG up",
    [isaac_typescript_definitions_1.CollectibleType.DR_FETUS]: "???",
    [isaac_typescript_definitions_1.CollectibleType.MAGNETO]: "Item snatcher",
    [isaac_typescript_definitions_1.CollectibleType.TREASURE_MAP]: "Full visible map",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_EYE]: "Eye in the back of your head",
    [isaac_typescript_definitions_1.CollectibleType.LEMON_MISHAP]: "Oops...",
    [isaac_typescript_definitions_1.CollectibleType.DISTANT_ADMIRATION]: "Attack fly",
    [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_SHADOWS]: "Temporary invincibility",
    [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_BELIAL_BIRTHRIGHT]: "Temporary DMG up",
    [isaac_typescript_definitions_1.CollectibleType.LADDER]: "Building bridges",
    // There is no `CollectibleType` with a value of 61.
    [isaac_typescript_definitions_1.CollectibleType.CHARM_OF_THE_VAMPIRE]: "Kills heal",
    [isaac_typescript_definitions_1.CollectibleType.BATTERY]: "Stores energy",
    [isaac_typescript_definitions_1.CollectibleType.STEAM_SALE]: "50% off",
    [isaac_typescript_definitions_1.CollectibleType.ANARCHIST_COOKBOOK]: "Summon bombs",
    [isaac_typescript_definitions_1.CollectibleType.HOURGLASS]: "Temporary enemy slowdown",
    [isaac_typescript_definitions_1.CollectibleType.SISTER_MAGGY]: "Friends 'till the end",
    [isaac_typescript_definitions_1.CollectibleType.TECHNOLOGY]: "Laser tears",
    [isaac_typescript_definitions_1.CollectibleType.CHOCOLATE_MILK]: "Charge shots",
    [isaac_typescript_definitions_1.CollectibleType.GROWTH_HORMONES]: "Speed + DMG up",
    [isaac_typescript_definitions_1.CollectibleType.MINI_MUSH]: "Speed + range up",
    [isaac_typescript_definitions_1.CollectibleType.ROSARY]: "Tears + faith up",
    [isaac_typescript_definitions_1.CollectibleType.CUBE_OF_MEAT]: "Gotta meat 'em all",
    [isaac_typescript_definitions_1.CollectibleType.QUARTER]: "+25 coins",
    [isaac_typescript_definitions_1.CollectibleType.PHD]: "Better pills",
    [isaac_typescript_definitions_1.CollectibleType.XRAY_VISION]: "I've seen everything",
    [isaac_typescript_definitions_1.CollectibleType.MY_LITTLE_UNICORN]: "Temporary badass",
    [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_REVELATIONS]: "Reusable soul protection",
    [isaac_typescript_definitions_1.CollectibleType.MARK]: "DMG + speed up",
    [isaac_typescript_definitions_1.CollectibleType.PACT]: "DMG + tears up",
    [isaac_typescript_definitions_1.CollectibleType.DEAD_CAT]: "9 lives",
    [isaac_typescript_definitions_1.CollectibleType.LORD_OF_THE_PIT]: "Demon wings",
    [isaac_typescript_definitions_1.CollectibleType.NAIL]: "Temporary demon form",
    [isaac_typescript_definitions_1.CollectibleType.WE_NEED_TO_GO_DEEPER]: "Reusable level skip",
    [isaac_typescript_definitions_1.CollectibleType.DECK_OF_CARDS]: "Reusable card generator ",
    [isaac_typescript_definitions_1.CollectibleType.MONSTROS_TOOTH]: "Summon Monstro",
    [isaac_typescript_definitions_1.CollectibleType.LOKIS_HORNS]: "Cross tears",
    [isaac_typescript_definitions_1.CollectibleType.LITTLE_CHUBBY]: "Attack buddy",
    [isaac_typescript_definitions_1.CollectibleType.SPIDER_BITE]: "Slow effect",
    [isaac_typescript_definitions_1.CollectibleType.SMALL_ROCK]: "DMG up",
    [isaac_typescript_definitions_1.CollectibleType.SPELUNKER_HAT]: "See-through doors",
    [isaac_typescript_definitions_1.CollectibleType.SUPER_BANDAGE]: "+2 hearts",
    [isaac_typescript_definitions_1.CollectibleType.GAMEKID]: "Temporary Man-Pac",
    [isaac_typescript_definitions_1.CollectibleType.SACK_OF_PENNIES]: "Gives money",
    [isaac_typescript_definitions_1.CollectibleType.ROBO_BABY]: "Friends 'till the bbbbzzzt",
    [isaac_typescript_definitions_1.CollectibleType.LITTLE_CHAD]: "Gives kisses",
    [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_SIN]: "Reusable item generator",
    [isaac_typescript_definitions_1.CollectibleType.RELIC]: "Soul generator",
    [isaac_typescript_definitions_1.CollectibleType.LITTLE_GISH]: "Sticky friend",
    [isaac_typescript_definitions_1.CollectibleType.LITTLE_STEVEN]: "Psychic friend",
    [isaac_typescript_definitions_1.CollectibleType.HALO]: "All stats up",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_BOTTLE_OF_PILLS]: "Reusable pill generator",
    [isaac_typescript_definitions_1.CollectibleType.COMMON_COLD]: "Poison damage",
    [isaac_typescript_definitions_1.CollectibleType.PARASITE]: "Split shot",
    [isaac_typescript_definitions_1.CollectibleType.D6]: "Reroll your destiny",
    [isaac_typescript_definitions_1.CollectibleType.MR_MEGA]: "Bigger boom",
    [isaac_typescript_definitions_1.CollectibleType.PINKING_SHEARS]: "Cut and run",
    [isaac_typescript_definitions_1.CollectibleType.WAFER]: "Damage resistance",
    [isaac_typescript_definitions_1.CollectibleType.MONEY_EQUALS_POWER]: "$$$ = DMG",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_CONTACTS]: "Freeze effect",
    [isaac_typescript_definitions_1.CollectibleType.BEAN]: "Toot on command",
    [isaac_typescript_definitions_1.CollectibleType.GUARDIAN_ANGEL]: "Extra protection",
    [isaac_typescript_definitions_1.CollectibleType.DEMON_BABY]: "Auto-turret friend",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_KNIFE]: "Stab stab stab",
    [isaac_typescript_definitions_1.CollectibleType.OUIJA_BOARD]: "Spectral tears",
    [isaac_typescript_definitions_1.CollectibleType.NINE_VOLT]: "Quicker charge",
    [isaac_typescript_definitions_1.CollectibleType.DEAD_BIRD]: "Protective buddy",
    [isaac_typescript_definitions_1.CollectibleType.BRIMSTONE]: "Blood laser barrage",
    [isaac_typescript_definitions_1.CollectibleType.BLOOD_BAG]: "HP up",
    [isaac_typescript_definitions_1.CollectibleType.ODD_MUSHROOM_THIN]: "Tears + speed up, DMG down",
    [isaac_typescript_definitions_1.CollectibleType.ODD_MUSHROOM_LARGE]: "HP + DMG up, speed down",
    [isaac_typescript_definitions_1.CollectibleType.WHORE_OF_BABYLON]: "Curse up",
    [isaac_typescript_definitions_1.CollectibleType.MONSTER_MANUAL]: "Temporary buddy generator",
    [isaac_typescript_definitions_1.CollectibleType.DEAD_SEA_SCROLLS]: "It's a mystery",
    [isaac_typescript_definitions_1.CollectibleType.BOBBY_BOMB]: "Homing bombs",
    [isaac_typescript_definitions_1.CollectibleType.RAZOR_BLADE]: "Feel my pain",
    [isaac_typescript_definitions_1.CollectibleType.FORGET_ME_NOW]: "I don't remember...",
    [isaac_typescript_definitions_1.CollectibleType.FOREVER_ALONE]: "Attack fly",
    [isaac_typescript_definitions_1.CollectibleType.BUCKET_OF_LARD]: "HP up",
    [isaac_typescript_definitions_1.CollectibleType.PONY]: "Flight + dash attack",
    [isaac_typescript_definitions_1.CollectibleType.BOMB_BAG]: "Gives bombs",
    [isaac_typescript_definitions_1.CollectibleType.LUMP_OF_COAL]: "My Xmas present",
    [isaac_typescript_definitions_1.CollectibleType.GUPPYS_PAW]: "Soul converter",
    [isaac_typescript_definitions_1.CollectibleType.GUPPYS_TAIL]: "Cursed?",
    [isaac_typescript_definitions_1.CollectibleType.IV_BAG]: "Portable blood bank",
    [isaac_typescript_definitions_1.CollectibleType.BEST_FRIEND]: "Friends 'till the end",
    [isaac_typescript_definitions_1.CollectibleType.REMOTE_DETONATOR]: "Remote bomb detonation",
    [isaac_typescript_definitions_1.CollectibleType.STIGMATA]: "DMG + HP up",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_PURSE]: "More trinket room",
    [isaac_typescript_definitions_1.CollectibleType.BOBS_CURSE]: "+5 poison bombs",
    [isaac_typescript_definitions_1.CollectibleType.PAGEANT_BOY]: "Ultimate grand supreme",
    [isaac_typescript_definitions_1.CollectibleType.SCAPULAR]: "Pray for a miracle",
    [isaac_typescript_definitions_1.CollectibleType.SPEED_BALL]: "Speed + shot speed up",
    [isaac_typescript_definitions_1.CollectibleType.BUM_FRIEND]: "He's greedy",
    [isaac_typescript_definitions_1.CollectibleType.GUPPYS_HEAD]: "Reusable fly hive",
    [isaac_typescript_definitions_1.CollectibleType.PRAYER_CARD]: "Reusable eternity ",
    [isaac_typescript_definitions_1.CollectibleType.NOTCHED_AXE]: "Rocks don't stand a chance",
    [isaac_typescript_definitions_1.CollectibleType.INFESTATION]: "Fly revenge",
    [isaac_typescript_definitions_1.CollectibleType.IPECAC]: "Explosive shots",
    [isaac_typescript_definitions_1.CollectibleType.TOUGH_LOVE]: "Tooth shot",
    [isaac_typescript_definitions_1.CollectibleType.MULLIGAN]: "They grow inside",
    [isaac_typescript_definitions_1.CollectibleType.TECHNOLOGY_2]: "Extra laser",
    [isaac_typescript_definitions_1.CollectibleType.MUTANT_SPIDER]: "Quad shot",
    [isaac_typescript_definitions_1.CollectibleType.CHEMICAL_PEEL]: "DMG up",
    [isaac_typescript_definitions_1.CollectibleType.PEEPER]: "Plop!",
    [isaac_typescript_definitions_1.CollectibleType.HABIT]: "Item martyr",
    [isaac_typescript_definitions_1.CollectibleType.BLOODY_LUST]: "RAGE!",
    [isaac_typescript_definitions_1.CollectibleType.CRYSTAL_BALL]: "I see my future",
    [isaac_typescript_definitions_1.CollectibleType.SPIRIT_OF_THE_NIGHT]: "Scary",
    [isaac_typescript_definitions_1.CollectibleType.CRACK_THE_SKY]: "Holy white death",
    [isaac_typescript_definitions_1.CollectibleType.ANKH]: "Eternal life?",
    [isaac_typescript_definitions_1.CollectibleType.CELTIC_CROSS]: "Blessing of protection",
    [isaac_typescript_definitions_1.CollectibleType.GHOST_BABY]: "Spectral buddy",
    [isaac_typescript_definitions_1.CollectibleType.CANDLE]: "Reusable flames",
    [isaac_typescript_definitions_1.CollectibleType.CAT_O_NINE_TAILS]: "Shot speed + damage up",
    [isaac_typescript_definitions_1.CollectibleType.D20]: "Reroll the basics",
    [isaac_typescript_definitions_1.CollectibleType.HARLEQUIN_BABY]: "Double shot buddy",
    [isaac_typescript_definitions_1.CollectibleType.EPIC_FETUS]: "On-demand air strike",
    [isaac_typescript_definitions_1.CollectibleType.POLYPHEMUS]: "Mega tears",
    [isaac_typescript_definitions_1.CollectibleType.DADDY_LONGLEGS]: "Daddy's love",
    [isaac_typescript_definitions_1.CollectibleType.SPIDER_BUTT]: "Mass enemy slowdown + damage",
    [isaac_typescript_definitions_1.CollectibleType.SACRIFICIAL_DAGGER]: "My fate protects me",
    [isaac_typescript_definitions_1.CollectibleType.MITRE]: "Blessing of purity",
    [isaac_typescript_definitions_1.CollectibleType.RAINBOW_BABY]: "Random buddy",
    [isaac_typescript_definitions_1.CollectibleType.DADS_KEY]: "Opens all doors...",
    [isaac_typescript_definitions_1.CollectibleType.STEM_CELLS]: "HP + shot speed up",
    [isaac_typescript_definitions_1.CollectibleType.PORTABLE_SLOT]: "Gamble 24/7",
    [isaac_typescript_definitions_1.CollectibleType.HOLY_WATER]: "Splash!",
    [isaac_typescript_definitions_1.CollectibleType.FATE]: "Flight eternal",
    [isaac_typescript_definitions_1.CollectibleType.BLACK_BEAN]: "Toot on touch",
    [isaac_typescript_definitions_1.CollectibleType.WHITE_PONY]: "Flight + holy death",
    [isaac_typescript_definitions_1.CollectibleType.SACRED_HEART]: "Homing shots + DMG up",
    [isaac_typescript_definitions_1.CollectibleType.TOOTH_PICKS]: "Tears + shot speed up",
    [isaac_typescript_definitions_1.CollectibleType.HOLY_GRAIL]: "Flight + HP up",
    [isaac_typescript_definitions_1.CollectibleType.DEAD_DOVE]: "Flight + spectral tears",
    [isaac_typescript_definitions_1.CollectibleType.BLOOD_RIGHTS]: "Mass enemy damage at a cost",
    [isaac_typescript_definitions_1.CollectibleType.GUPPYS_HAIRBALL]: "Swing it",
    [isaac_typescript_definitions_1.CollectibleType.ABEL]: "Mirrored buddy",
    [isaac_typescript_definitions_1.CollectibleType.SMB_SUPER_FAN]: "All stats up",
    [isaac_typescript_definitions_1.CollectibleType.PYRO]: "99 bombs",
    [isaac_typescript_definitions_1.CollectibleType.THREE_DOLLAR_BILL]: "Rainbow tears",
    [isaac_typescript_definitions_1.CollectibleType.TELEPATHY_BOOK]: "Temporary psychic shot",
    [isaac_typescript_definitions_1.CollectibleType.MEAT]: "DMG + HP up",
    [isaac_typescript_definitions_1.CollectibleType.MAGIC_8_BALL]: "Shot speed up",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_COIN_PURSE]: "What's all this...?",
    [isaac_typescript_definitions_1.CollectibleType.SQUEEZY]: "Tears up",
    [isaac_typescript_definitions_1.CollectibleType.JESUS_JUICE]: "Damage + range up",
    [isaac_typescript_definitions_1.CollectibleType.BOX]: "Stuff",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_KEY]: "Better chest loot +2 keys",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_EYESHADOW]: "Charm tears",
    [isaac_typescript_definitions_1.CollectibleType.IRON_BAR]: "DMG up + concussive tears",
    [isaac_typescript_definitions_1.CollectibleType.MIDAS_TOUCH]: "Golden touch",
    [isaac_typescript_definitions_1.CollectibleType.HUMBLEING_BUNDLE]: "1+1 free 4Evar",
    [isaac_typescript_definitions_1.CollectibleType.FANNY_PACK]: "Filled with goodies",
    [isaac_typescript_definitions_1.CollectibleType.SHARP_PLUG]: "Infinite charge... at a cost",
    [isaac_typescript_definitions_1.CollectibleType.GUILLOTINE]: "DMG + tears up. An out-of-body experience!",
    [isaac_typescript_definitions_1.CollectibleType.BALL_OF_BANDAGES]: "Gotta lick 'em all!",
    [isaac_typescript_definitions_1.CollectibleType.CHAMPION_BELT]: "DMG + challenge up",
    [isaac_typescript_definitions_1.CollectibleType.BUTT_BOMBS]: "Toxic blast +5 bombs",
    [isaac_typescript_definitions_1.CollectibleType.GNAWED_LEAF]: "Unbreakable",
    [isaac_typescript_definitions_1.CollectibleType.SPIDERBABY]: "Spider revenge",
    [isaac_typescript_definitions_1.CollectibleType.GUPPYS_COLLAR]: "Eternal life?",
    [isaac_typescript_definitions_1.CollectibleType.LOST_CONTACT]: "Shielded tears",
    [isaac_typescript_definitions_1.CollectibleType.ANEMIC]: "Toxic blood",
    [isaac_typescript_definitions_1.CollectibleType.GOAT_HEAD]: "He accepts your offering",
    [isaac_typescript_definitions_1.CollectibleType.CEREMONIAL_ROBES]: "DMG + evil up",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_WIG]: "You feel itchy...",
    [isaac_typescript_definitions_1.CollectibleType.PLACENTA]: "Regeneration + HP up",
    [isaac_typescript_definitions_1.CollectibleType.OLD_BANDAGE]: "HP up",
    [isaac_typescript_definitions_1.CollectibleType.SAD_BOMBS]: "Tear blasts +5 bombs",
    [isaac_typescript_definitions_1.CollectibleType.RUBBER_CEMENT]: "Bouncing tears",
    [isaac_typescript_definitions_1.CollectibleType.ANTI_GRAVITY]: "Anti-gravity tears + tears up",
    [isaac_typescript_definitions_1.CollectibleType.PYROMANIAC]: "It hurts so good +5 bombs",
    [isaac_typescript_definitions_1.CollectibleType.CRICKETS_BODY]: "Bursting shots + tears up",
    [isaac_typescript_definitions_1.CollectibleType.GIMPY]: "Sweet suffering",
    [isaac_typescript_definitions_1.CollectibleType.BLACK_LOTUS]: "HP up x3",
    [isaac_typescript_definitions_1.CollectibleType.PIGGY_BANK]: "My life savings",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_PERFUME]: "Fear shot + tears up",
    [isaac_typescript_definitions_1.CollectibleType.MONSTROS_LUNG]: "Charged burst attack",
    [isaac_typescript_definitions_1.CollectibleType.ABADDON]: "Evil + DMG up + fear shot",
    [isaac_typescript_definitions_1.CollectibleType.BALL_OF_TAR]: "Sticky feet...",
    [isaac_typescript_definitions_1.CollectibleType.STOP_WATCH]: "Let's slow this down a bit...",
    [isaac_typescript_definitions_1.CollectibleType.TINY_PLANET]: "Orbiting tears + range up",
    [isaac_typescript_definitions_1.CollectibleType.INFESTATION_2]: "Infestation shot",
    // There is no `CollectibleType` with a value of 235.
    [isaac_typescript_definitions_1.CollectibleType.E_COLI]: "Turdy touch",
    [isaac_typescript_definitions_1.CollectibleType.DEATHS_TOUCH]: "Piercing shots + DMG up",
    [isaac_typescript_definitions_1.CollectibleType.KEY_PIECE_1]: "???",
    [isaac_typescript_definitions_1.CollectibleType.KEY_PIECE_2]: "???",
    [isaac_typescript_definitions_1.CollectibleType.EXPERIMENTAL_TREATMENT]: "Some stats up, some stats down",
    [isaac_typescript_definitions_1.CollectibleType.CONTRACT_FROM_BELOW]: "Wealth... but at what cost?",
    [isaac_typescript_definitions_1.CollectibleType.INFAMY]: "Blocks damage... sometimes",
    [isaac_typescript_definitions_1.CollectibleType.TRINITY_SHIELD]: "You feel guarded",
    [isaac_typescript_definitions_1.CollectibleType.TECH_5]: "It's still being tested...",
    [isaac_typescript_definitions_1.CollectibleType.TWENTY_TWENTY]: "Double shot",
    [isaac_typescript_definitions_1.CollectibleType.BLUE_MAP]: "Secrets",
    [isaac_typescript_definitions_1.CollectibleType.BFFS]: "Your friends rule",
    [isaac_typescript_definitions_1.CollectibleType.HIVE_MIND]: "Giant spiders and flies",
    [isaac_typescript_definitions_1.CollectibleType.THERES_OPTIONS]: "More options",
    [isaac_typescript_definitions_1.CollectibleType.BOGO_BOMBS]: "1+1 BOOM!",
    [isaac_typescript_definitions_1.CollectibleType.STARTER_DECK]: "Extra card room",
    [isaac_typescript_definitions_1.CollectibleType.LITTLE_BAGGY]: "Extra pill room",
    [isaac_typescript_definitions_1.CollectibleType.MAGIC_SCAB]: "HP + luck up",
    [isaac_typescript_definitions_1.CollectibleType.BLOOD_CLOT]: "DMG + range up",
    [isaac_typescript_definitions_1.CollectibleType.SCREW]: "Tears + shot speed up",
    [isaac_typescript_definitions_1.CollectibleType.HOT_BOMBS]: "Burning blast +5 bombs",
    [isaac_typescript_definitions_1.CollectibleType.FIRE_MIND]: "Flaming tears",
    [isaac_typescript_definitions_1.CollectibleType.MISSING_NO]: "Syntax error",
    [isaac_typescript_definitions_1.CollectibleType.DARK_MATTER]: "DMG up + fear shot",
    [isaac_typescript_definitions_1.CollectibleType.BLACK_CANDLE]: "Curse immunity + evil up",
    [isaac_typescript_definitions_1.CollectibleType.PROPTOSIS]: "Short range mega tears",
    [isaac_typescript_definitions_1.CollectibleType.MISSING_PAGE_2]: "Evil up. Your enemies will pay!",
    [isaac_typescript_definitions_1.CollectibleType.CLEAR_RUNE]: "Rune mimic",
    [isaac_typescript_definitions_1.CollectibleType.SMART_FLY]: "Revenge fly",
    [isaac_typescript_definitions_1.CollectibleType.DRY_BABY]: "Immortal friend",
    [isaac_typescript_definitions_1.CollectibleType.JUICY_SACK]: "Sticky babies",
    [isaac_typescript_definitions_1.CollectibleType.ROBO_BABY_2]: "We worked out all the kinks",
    [isaac_typescript_definitions_1.CollectibleType.ROTTEN_BABY]: "Infested friend",
    [isaac_typescript_definitions_1.CollectibleType.HEADLESS_BABY]: "Bloody friend",
    [isaac_typescript_definitions_1.CollectibleType.LEECH]: "Blood sucker",
    [isaac_typescript_definitions_1.CollectibleType.MYSTERY_SACK]: "?",
    [isaac_typescript_definitions_1.CollectibleType.BBF]: "Big Beautiful Fly",
    [isaac_typescript_definitions_1.CollectibleType.BOBS_BRAIN]: "Explosive thoughts",
    [isaac_typescript_definitions_1.CollectibleType.BEST_BUD]: "Sworn protector",
    [isaac_typescript_definitions_1.CollectibleType.LIL_BRIMSTONE]: "Evil friend",
    [isaac_typescript_definitions_1.CollectibleType.ISAACS_HEART]: "Protect it",
    [isaac_typescript_definitions_1.CollectibleType.LIL_HAUNT]: "Fear him",
    [isaac_typescript_definitions_1.CollectibleType.DARK_BUM]: "He wants to take your life",
    [isaac_typescript_definitions_1.CollectibleType.BIG_FAN]: "Fat protector",
    [isaac_typescript_definitions_1.CollectibleType.SISSY_LONGLEGS]: "She loves you",
    [isaac_typescript_definitions_1.CollectibleType.PUNCHING_BAG]: "Scape goat",
    [isaac_typescript_definitions_1.CollectibleType.HOW_TO_JUMP]: "It's time you learned how",
    [isaac_typescript_definitions_1.CollectibleType.D100]: "REEROLLLLL!",
    [isaac_typescript_definitions_1.CollectibleType.D4]: "Reroll into something else",
    [isaac_typescript_definitions_1.CollectibleType.D10]: "Reroll enemies",
    [isaac_typescript_definitions_1.CollectibleType.BLANK_CARD]: "Card mimic",
    [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_SECRETS]: "Tome of knowledge",
    [isaac_typescript_definitions_1.CollectibleType.BOX_OF_SPIDERS]: "It's a box of spiders",
    [isaac_typescript_definitions_1.CollectibleType.RED_CANDLE]: "Flame on",
    [isaac_typescript_definitions_1.CollectibleType.JAR]: "Save your life",
    [isaac_typescript_definitions_1.CollectibleType.FLUSH]: "...",
    [isaac_typescript_definitions_1.CollectibleType.SATANIC_BIBLE]: "Reusable evil... but at what cost?",
    [isaac_typescript_definitions_1.CollectibleType.HEAD_OF_KRAMPUS]: "Krampus rage",
    [isaac_typescript_definitions_1.CollectibleType.BUTTER_BEAN]: "Reusable knock-back",
    [isaac_typescript_definitions_1.CollectibleType.MAGIC_FINGERS]: "Pay to win",
    [isaac_typescript_definitions_1.CollectibleType.CONVERTER]: "Convert your soul",
    [isaac_typescript_definitions_1.CollectibleType.BLUE_BOX]: "? ?",
    [isaac_typescript_definitions_1.CollectibleType.UNICORN_STUMP]: "You feel stumped",
    [isaac_typescript_definitions_1.CollectibleType.TAURUS]: "Speed down + rage is building",
    [isaac_typescript_definitions_1.CollectibleType.ARIES]: "Ramming speed",
    [isaac_typescript_definitions_1.CollectibleType.CANCER]: "HP up + you feel protected",
    [isaac_typescript_definitions_1.CollectibleType.LEO]: "Stompy",
    [isaac_typescript_definitions_1.CollectibleType.VIRGO]: "You feel refreshed and protected",
    [isaac_typescript_definitions_1.CollectibleType.LIBRA]: "You feel balanced",
    [isaac_typescript_definitions_1.CollectibleType.SCORPIO]: "Poison tears",
    [isaac_typescript_definitions_1.CollectibleType.SAGITTARIUS]: "Piercing shots + speed up",
    [isaac_typescript_definitions_1.CollectibleType.CAPRICORN]: "All stats up",
    [isaac_typescript_definitions_1.CollectibleType.AQUARIUS]: "Trail of tears",
    [isaac_typescript_definitions_1.CollectibleType.PISCES]: "Tears up + knock-back shot",
    [isaac_typescript_definitions_1.CollectibleType.EVES_MASCARA]: "DMG up, tears + shot speed down",
    [isaac_typescript_definitions_1.CollectibleType.JUDAS_SHADOW]: "Sweet revenge",
    [isaac_typescript_definitions_1.CollectibleType.MAGGYS_BOW]: "HP up + you feel healthy",
    [isaac_typescript_definitions_1.CollectibleType.HOLY_MANTLE]: "Holy shield",
    [isaac_typescript_definitions_1.CollectibleType.THUNDER_THIGHS]: "HP up + speed down + you feel stompy",
    [isaac_typescript_definitions_1.CollectibleType.STRANGE_ATTRACTOR]: "Magnetic tears",
    [isaac_typescript_definitions_1.CollectibleType.CURSED_EYE]: "Cursed charge shot",
    [isaac_typescript_definitions_1.CollectibleType.MYSTERIOUS_LIQUID]: "Toxic splash damage",
    [isaac_typescript_definitions_1.CollectibleType.GEMINI]: "Conjoined friend",
    [isaac_typescript_definitions_1.CollectibleType.CAINS_OTHER_EYE]: "Near-sighted friend",
    [isaac_typescript_definitions_1.CollectibleType.BLUE_BABYS_ONLY_FRIEND]: "Controlled friend",
    [isaac_typescript_definitions_1.CollectibleType.SAMSONS_CHAINS]: "The ol' ball and chain",
    [isaac_typescript_definitions_1.CollectibleType.MONGO_BABY]: "Mongo friend",
    [isaac_typescript_definitions_1.CollectibleType.ISAACS_TEARS]: "Collected tears",
    [isaac_typescript_definitions_1.CollectibleType.UNDEFINED]: "Undefined",
    [isaac_typescript_definitions_1.CollectibleType.SCISSORS]: "Lose your head",
    [isaac_typescript_definitions_1.CollectibleType.BREATH_OF_LIFE]: "Invincibility at a cost",
    [isaac_typescript_definitions_1.CollectibleType.POLAROID]: "Fate chosen",
    [isaac_typescript_definitions_1.CollectibleType.NEGATIVE]: "Fate chosen",
    [isaac_typescript_definitions_1.CollectibleType.LUDOVICO_TECHNIQUE]: "Controlled tears",
    [isaac_typescript_definitions_1.CollectibleType.SOY_MILK]: "DMG down + tears way up",
    [isaac_typescript_definitions_1.CollectibleType.GODHEAD]: "God tears",
    [isaac_typescript_definitions_1.CollectibleType.LAZARUS_RAGS]: "Eternal life?",
    [isaac_typescript_definitions_1.CollectibleType.MIND]: "I know all",
    [isaac_typescript_definitions_1.CollectibleType.BODY]: "I feel all",
    [isaac_typescript_definitions_1.CollectibleType.SOUL]: "I am all",
    [isaac_typescript_definitions_1.CollectibleType.DEAD_ONION]: "Toxic aura tears",
    [isaac_typescript_definitions_1.CollectibleType.BROKEN_WATCH]: "I think it's broken",
    [isaac_typescript_definitions_1.CollectibleType.BOOMERANG]: "It will never leave you",
    [isaac_typescript_definitions_1.CollectibleType.SAFETY_PIN]: "Evil + range + shot speed up",
    [isaac_typescript_definitions_1.CollectibleType.CAFFEINE_PILL]: "Speed up + size down",
    [isaac_typescript_definitions_1.CollectibleType.TORN_PHOTO]: "Tears + shot speed up",
    [isaac_typescript_definitions_1.CollectibleType.BLUE_CAP]: "HP + tears up + shot speed down",
    [isaac_typescript_definitions_1.CollectibleType.LATCH_KEY]: "Luck up",
    [isaac_typescript_definitions_1.CollectibleType.MATCH_BOOK]: "Evil up",
    [isaac_typescript_definitions_1.CollectibleType.SYNTHOIL]: "DMG + range up",
    [isaac_typescript_definitions_1.CollectibleType.SNACK]: "HP up",
    [isaac_typescript_definitions_1.CollectibleType.DIPLOPIA]: "Double item vision",
    [isaac_typescript_definitions_1.CollectibleType.PLACEBO]: "Pill mimic",
    [isaac_typescript_definitions_1.CollectibleType.WOODEN_NICKEL]: "Flip a coin",
    [isaac_typescript_definitions_1.CollectibleType.TOXIC_SHOCK]: "Mass poison",
    [isaac_typescript_definitions_1.CollectibleType.MEGA_BEAN]: "Giga fart!",
    [isaac_typescript_definitions_1.CollectibleType.GLASS_CANNON]: "Be gentle...",
    [isaac_typescript_definitions_1.CollectibleType.BOMBER_BOY]: "Cross blast + 5 bombs",
    [isaac_typescript_definitions_1.CollectibleType.CRACK_JACKS]: "HP up. Don't swallow the prize!",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_PEARLS]: "Range + luck up",
    [isaac_typescript_definitions_1.CollectibleType.CAR_BATTERY]: "Active power up",
    [isaac_typescript_definitions_1.CollectibleType.BOX_OF_FRIENDS]: "Double your friends",
    [isaac_typescript_definitions_1.CollectibleType.WIZ]: "Double wiz shot!",
    [isaac_typescript_definitions_1.CollectibleType.EIGHT_INCH_NAILS]: "Stick it to 'em!",
    [isaac_typescript_definitions_1.CollectibleType.INCUBUS]: "Dark friend",
    [isaac_typescript_definitions_1.CollectibleType.FATES_REWARD]: "Your fate beside you",
    [isaac_typescript_definitions_1.CollectibleType.LIL_CHEST]: "What's in the box?",
    [isaac_typescript_definitions_1.CollectibleType.SWORN_PROTECTOR]: "Protective friend",
    [isaac_typescript_definitions_1.CollectibleType.FRIEND_ZONE]: "Friendly fly",
    [isaac_typescript_definitions_1.CollectibleType.LOST_FLY]: "Lost protector",
    [isaac_typescript_definitions_1.CollectibleType.SCATTER_BOMBS]: "We put bombs in your bombs!",
    [isaac_typescript_definitions_1.CollectibleType.STICKY_BOMBS]: "Egg sack bombs!",
    [isaac_typescript_definitions_1.CollectibleType.EPIPHORA]: "Intensifying tears",
    [isaac_typescript_definitions_1.CollectibleType.CONTINUUM]: "Transcendent tears",
    [isaac_typescript_definitions_1.CollectibleType.MR_DOLLY]: "Range + tears up",
    [isaac_typescript_definitions_1.CollectibleType.CURSE_OF_THE_TOWER]: "Embrace chaos",
    [isaac_typescript_definitions_1.CollectibleType.CHARGED_BABY]: "Bbbzzzzzt! ",
    [isaac_typescript_definitions_1.CollectibleType.DEAD_EYE]: "Accuracy brings power",
    [isaac_typescript_definitions_1.CollectibleType.HOLY_LIGHT]: "Holy death shot",
    [isaac_typescript_definitions_1.CollectibleType.HOST_HAT]: "Blast resistance",
    [isaac_typescript_definitions_1.CollectibleType.RESTOCK]: "Never ending stores!",
    [isaac_typescript_definitions_1.CollectibleType.BURSTING_SACK]: "Spider love",
    [isaac_typescript_definitions_1.CollectibleType.NUMBER_TWO]: "Uh oh...",
    [isaac_typescript_definitions_1.CollectibleType.PUPULA_DUPLEX]: "Wide shot",
    [isaac_typescript_definitions_1.CollectibleType.PAY_TO_PLAY]: "Money talks",
    [isaac_typescript_definitions_1.CollectibleType.EDENS_BLESSING]: "Tears up + your future shines brighter",
    [isaac_typescript_definitions_1.CollectibleType.FRIEND_BALL]: "Gotta fetch 'em all!",
    [isaac_typescript_definitions_1.CollectibleType.TEAR_DETONATOR]: "Remote tear detonation",
    [isaac_typescript_definitions_1.CollectibleType.LIL_GURDY]: "A gurd of your own!",
    [isaac_typescript_definitions_1.CollectibleType.BUMBO]: "Bumbo want coin!",
    [isaac_typescript_definitions_1.CollectibleType.D12]: "Rerolls rocks",
    [isaac_typescript_definitions_1.CollectibleType.CENSER]: "Peace be with you",
    [isaac_typescript_definitions_1.CollectibleType.KEY_BUM]: "He wants your keys!",
    [isaac_typescript_definitions_1.CollectibleType.RUNE_BAG]: "Rune generator",
    [isaac_typescript_definitions_1.CollectibleType.SERAPHIM]: "Sworn friend",
    [isaac_typescript_definitions_1.CollectibleType.BETRAYAL]: "Turn your enemy",
    [isaac_typescript_definitions_1.CollectibleType.ZODIAC]: "The heavens will change you",
    [isaac_typescript_definitions_1.CollectibleType.SERPENTS_KISS]: "The kiss of death",
    [isaac_typescript_definitions_1.CollectibleType.MARKED]: "Directed tears",
    [isaac_typescript_definitions_1.CollectibleType.TECH_X]: "Laser ring tears",
    [isaac_typescript_definitions_1.CollectibleType.VENTRICLE_RAZOR]: "Short cutter",
    [isaac_typescript_definitions_1.CollectibleType.TRACTOR_BEAM]: "Controlled tears",
    [isaac_typescript_definitions_1.CollectibleType.GODS_FLESH]: "Shrink shot!",
    [isaac_typescript_definitions_1.CollectibleType.MAW_OF_THE_VOID]: "Consume thy enemy!",
    [isaac_typescript_definitions_1.CollectibleType.SPEAR_OF_DESTINY]: "Your destiny",
    [isaac_typescript_definitions_1.CollectibleType.EXPLOSIVO]: "Sticky bomb shot",
    [isaac_typescript_definitions_1.CollectibleType.CHAOS]: "!!!",
    [isaac_typescript_definitions_1.CollectibleType.SPIDER_MOD]: "Mod buddy",
    [isaac_typescript_definitions_1.CollectibleType.FARTING_BABY]: "He farts",
    [isaac_typescript_definitions_1.CollectibleType.GB_BUG]: "Double tap glitch",
    [isaac_typescript_definitions_1.CollectibleType.D8]: "Reroll stats",
    [isaac_typescript_definitions_1.CollectibleType.PURITY]: "Aura stat boost",
    [isaac_typescript_definitions_1.CollectibleType.ATHAME]: "Call to the void",
    [isaac_typescript_definitions_1.CollectibleType.EMPTY_VESSEL]: "I reward an empty vessel",
    [isaac_typescript_definitions_1.CollectibleType.EVIL_EYE]: "Eye shot",
    [isaac_typescript_definitions_1.CollectibleType.LUSTY_BLOOD]: "Their blood brings rage!",
    [isaac_typescript_definitions_1.CollectibleType.CAMBION_CONCEPTION]: "Feed them hate",
    [isaac_typescript_definitions_1.CollectibleType.IMMACULATE_CONCEPTION]: "Feed them love",
    [isaac_typescript_definitions_1.CollectibleType.MORE_OPTIONS]: "There's options",
    [isaac_typescript_definitions_1.CollectibleType.CROWN_OF_LIGHT]: "The untainted gain power",
    [isaac_typescript_definitions_1.CollectibleType.DEEP_POCKETS]: "More money!",
    [isaac_typescript_definitions_1.CollectibleType.SUCCUBUS]: "Damage booster",
    [isaac_typescript_definitions_1.CollectibleType.FRUIT_CAKE]: "Rainbow effects!",
    [isaac_typescript_definitions_1.CollectibleType.TELEPORT_2]: "I-Teleport!",
    [isaac_typescript_definitions_1.CollectibleType.BLACK_POWDER]: "Spin the black circle!",
    [isaac_typescript_definitions_1.CollectibleType.KIDNEY_BEAN]: "Love toots",
    [isaac_typescript_definitions_1.CollectibleType.GLOWING_HOUR_GLASS]: "Turn back time",
    [isaac_typescript_definitions_1.CollectibleType.CIRCLE_OF_PROTECTION]: "Protect me from myself",
    [isaac_typescript_definitions_1.CollectibleType.SACK_HEAD]: "More sacks!",
    [isaac_typescript_definitions_1.CollectibleType.NIGHT_LIGHT]: "Scared of the dark?",
    [isaac_typescript_definitions_1.CollectibleType.OBSESSED_FAN]: "Follows my every move...",
    [isaac_typescript_definitions_1.CollectibleType.MINE_CRAFTER]: "Booom!",
    [isaac_typescript_definitions_1.CollectibleType.PJS]: "You feel cozy",
    [isaac_typescript_definitions_1.CollectibleType.HEAD_OF_THE_KEEPER]: "Penny tears",
    [isaac_typescript_definitions_1.CollectibleType.PAPA_FLY]: "Turret follower",
    [isaac_typescript_definitions_1.CollectibleType.MULTIDIMENSIONAL_BABY]: "ydduB Buddy",
    [isaac_typescript_definitions_1.CollectibleType.GLITTER_BOMBS]: "Prize bombs",
    [isaac_typescript_definitions_1.CollectibleType.MY_SHADOW]: "Me! And my shaaaadow!",
    [isaac_typescript_definitions_1.CollectibleType.JAR_OF_FLIES]: "Bug catcher",
    [isaac_typescript_definitions_1.CollectibleType.LIL_LOKI]: "4-way buddy!",
    [isaac_typescript_definitions_1.CollectibleType.MILK]: "Don't cry over it...",
    [isaac_typescript_definitions_1.CollectibleType.D7]: "Roll again",
    [isaac_typescript_definitions_1.CollectibleType.BINKY]: "Tears up",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_BOX]: "What's inside?",
    [isaac_typescript_definitions_1.CollectibleType.KIDNEY_STONE]: "Matt's kidney stone",
    [isaac_typescript_definitions_1.CollectibleType.MEGA_BLAST]: "Laser breath",
    [isaac_typescript_definitions_1.CollectibleType.DARK_PRINCES_CROWN]: "Loss is power",
    [isaac_typescript_definitions_1.CollectibleType.APPLE]: "Trick or treat?",
    [isaac_typescript_definitions_1.CollectibleType.LEAD_PENCIL]: "He's a bleeder!",
    [isaac_typescript_definitions_1.CollectibleType.DOG_TOOTH]: "Bark at the moon!",
    [isaac_typescript_definitions_1.CollectibleType.DEAD_TOOTH]: "Toxic breath",
    [isaac_typescript_definitions_1.CollectibleType.LINGER_BEAN]: "Crying makes me toot",
    [isaac_typescript_definitions_1.CollectibleType.SHARD_OF_GLASS]: "Blood and guts!",
    [isaac_typescript_definitions_1.CollectibleType.METAL_PLATE]: "It itches...",
    [isaac_typescript_definitions_1.CollectibleType.EYE_OF_GREED]: "Gold tears!",
    [isaac_typescript_definitions_1.CollectibleType.TAROT_CLOTH]: "I see the future",
    [isaac_typescript_definitions_1.CollectibleType.VARICOSE_VEINS]: "I'm leaking...",
    [isaac_typescript_definitions_1.CollectibleType.COMPOUND_FRACTURE]: "Bone tears!",
    [isaac_typescript_definitions_1.CollectibleType.POLYDACTYLY]: "Hold me!",
    [isaac_typescript_definitions_1.CollectibleType.DADS_LOST_COIN]: "I remember this...",
    [isaac_typescript_definitions_1.CollectibleType.MIDNIGHT_SNACK]: "HP up",
    [isaac_typescript_definitions_1.CollectibleType.CONE_HEAD]: "Hard headed!",
    [isaac_typescript_definitions_1.CollectibleType.BELLY_BUTTON]: "What's in there?",
    [isaac_typescript_definitions_1.CollectibleType.SINUS_INFECTION]: "Booger tears!",
    [isaac_typescript_definitions_1.CollectibleType.GLAUCOMA]: "Blind tears!",
    [isaac_typescript_definitions_1.CollectibleType.PARASITOID]: "Egg tears!",
    [isaac_typescript_definitions_1.CollectibleType.EYE_OF_BELIAL]: "Possessed tears!",
    [isaac_typescript_definitions_1.CollectibleType.SULFURIC_ACID]: "Acid tears!",
    [isaac_typescript_definitions_1.CollectibleType.GLYPH_OF_BALANCE]: "A gift from above",
    [isaac_typescript_definitions_1.CollectibleType.ANALOG_STICK]: "360 tears!",
    [isaac_typescript_definitions_1.CollectibleType.CONTAGION]: "Outbreak!",
    [isaac_typescript_definitions_1.CollectibleType.FINGER]: "Watch where you point that!",
    [isaac_typescript_definitions_1.CollectibleType.SHADE]: "It follows",
    [isaac_typescript_definitions_1.CollectibleType.DEPRESSION]: ":(",
    [isaac_typescript_definitions_1.CollectibleType.HUSHY]: "Lil hush!",
    [isaac_typescript_definitions_1.CollectibleType.LIL_MONSTRO]: "Ain't he cute?",
    [isaac_typescript_definitions_1.CollectibleType.KING_BABY]: "Hail to the king baby",
    [isaac_typescript_definitions_1.CollectibleType.BIG_CHUBBY]: "Chub chub",
    [isaac_typescript_definitions_1.CollectibleType.BROKEN_GLASS_CANNON]: "You broke it!",
    [isaac_typescript_definitions_1.CollectibleType.PLAN_C]: "My last resort",
    [isaac_typescript_definitions_1.CollectibleType.D1]: "What will it be?",
    [isaac_typescript_definitions_1.CollectibleType.VOID]: "Consume",
    [isaac_typescript_definitions_1.CollectibleType.PAUSE]: "Stop!",
    [isaac_typescript_definitions_1.CollectibleType.SMELTER]: "Trinket melter!",
    [isaac_typescript_definitions_1.CollectibleType.COMPOST]: "Gain more friends!",
    [isaac_typescript_definitions_1.CollectibleType.DATAMINER]: "109",
    [isaac_typescript_definitions_1.CollectibleType.CLICKER]: "Change",
    [isaac_typescript_definitions_1.CollectibleType.MAMA_MEGA]: "BOOOOOOOOOM!",
    [isaac_typescript_definitions_1.CollectibleType.WAIT_WHAT]: "I can't believe it's not butter bean!",
    [isaac_typescript_definitions_1.CollectibleType.CROOKED_PENNY]: "50/50",
    [isaac_typescript_definitions_1.CollectibleType.DULL_RAZOR]: "I feel numb...",
    [isaac_typescript_definitions_1.CollectibleType.POTATO_PEELER]: "A pound of flesh...",
    [isaac_typescript_definitions_1.CollectibleType.METRONOME]: "Waggles a finger",
    [isaac_typescript_definitions_1.CollectibleType.D_INFINITY]: "Reroll forever",
    [isaac_typescript_definitions_1.CollectibleType.EDENS_SOUL]: "...",
    [isaac_typescript_definitions_1.CollectibleType.ACID_BABY]: "Pills pills pills!",
    [isaac_typescript_definitions_1.CollectibleType.YO_LISTEN]: "Yo listen!",
    [isaac_typescript_definitions_1.CollectibleType.ADRENALINE]: "Panic = power",
    [isaac_typescript_definitions_1.CollectibleType.JACOBS_LADDER]: "Electric tears",
    [isaac_typescript_definitions_1.CollectibleType.GHOST_PEPPER]: "Flame tears",
    [isaac_typescript_definitions_1.CollectibleType.EUTHANASIA]: "Needle shot",
    [isaac_typescript_definitions_1.CollectibleType.CAMO_UNDIES]: "Camo kid",
    [isaac_typescript_definitions_1.CollectibleType.DUALITY]: "You feel very balanced",
    [isaac_typescript_definitions_1.CollectibleType.EUCHARIST]: "Peace be with you",
    [isaac_typescript_definitions_1.CollectibleType.SACK_OF_SACKS]: "Gives sacks",
    [isaac_typescript_definitions_1.CollectibleType.GREEDS_GULLET]: "Money = health!",
    [isaac_typescript_definitions_1.CollectibleType.LARGE_ZIT]: "Creep shots",
    [isaac_typescript_definitions_1.CollectibleType.LITTLE_HORN]: "Big brother is watching",
    [isaac_typescript_definitions_1.CollectibleType.BROWN_NUGGET]: "Friendly fly",
    [isaac_typescript_definitions_1.CollectibleType.POKE_GO]: "Gotta catch em...",
    [isaac_typescript_definitions_1.CollectibleType.BACKSTABBER]: "Watch your back!",
    [isaac_typescript_definitions_1.CollectibleType.SHARP_STRAW]: "More blood!",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_RAZOR]: "It's sharp!",
    [isaac_typescript_definitions_1.CollectibleType.BLOODSHOT_EYE]: "Bloody friend",
    [isaac_typescript_definitions_1.CollectibleType.DELIRIOUS]: "Unleash the power!",
    [isaac_typescript_definitions_1.CollectibleType.ANGRY_FLY]: "He's violent",
    [isaac_typescript_definitions_1.CollectibleType.BLACK_HOLE]: "Nothing can escape",
    [isaac_typescript_definitions_1.CollectibleType.BOZO]: "Party time!",
    [isaac_typescript_definitions_1.CollectibleType.BROKEN_MODEM]: "Lag!",
    [isaac_typescript_definitions_1.CollectibleType.MYSTERY_GIFT]: "Wrapped up nice for you!",
    [isaac_typescript_definitions_1.CollectibleType.SPRINKLER]: "Sprinkles.",
    [isaac_typescript_definitions_1.CollectibleType.FAST_BOMBS]: "Rapid bomb drops",
    [isaac_typescript_definitions_1.CollectibleType.BUDDY_IN_A_BOX]: "What could it be?!",
    [isaac_typescript_definitions_1.CollectibleType.LIL_DELIRIUM]: "Delirious friend",
    [isaac_typescript_definitions_1.CollectibleType.JUMPER_CABLES]: "Bloody recharge",
    [isaac_typescript_definitions_1.CollectibleType.COUPON]: "Allow 6 weeks for delivery",
    [isaac_typescript_definitions_1.CollectibleType.TELEKINESIS]: "Power of the mind",
    [isaac_typescript_definitions_1.CollectibleType.MOVING_BOX]: "Pack and unpack",
    [isaac_typescript_definitions_1.CollectibleType.TECHNOLOGY_ZERO]: "Static tears",
    [isaac_typescript_definitions_1.CollectibleType.LEPROSY]: "You're tearing me apart!",
    [isaac_typescript_definitions_1.CollectibleType.SEVEN_SEALS]: "Lil harbingers!",
    [isaac_typescript_definitions_1.CollectibleType.MR_ME]: "Caaan do!",
    [isaac_typescript_definitions_1.CollectibleType.ANGELIC_PRISM]: "Eclipsed by the moon",
    [isaac_typescript_definitions_1.CollectibleType.POP]: "Eyeball tears",
    [isaac_typescript_definitions_1.CollectibleType.DEATHS_LIST]: "Just hope you're not next...",
    [isaac_typescript_definitions_1.CollectibleType.HAEMOLACRIA]: "I'm seeing red...",
    [isaac_typescript_definitions_1.CollectibleType.LACHRYPHAGY]: "Feed them!",
    [isaac_typescript_definitions_1.CollectibleType.TRISAGION]: "Smite thy enemy",
    [isaac_typescript_definitions_1.CollectibleType.SCHOOLBAG]: "Extra active item room",
    [isaac_typescript_definitions_1.CollectibleType.BLANKET]: "You feel safe",
    [isaac_typescript_definitions_1.CollectibleType.SACRIFICIAL_ALTAR]: "He demands a sacrifice",
    [isaac_typescript_definitions_1.CollectibleType.LIL_SPEWER]: "Puking buddy",
    [isaac_typescript_definitions_1.CollectibleType.MARBLES]: "Choking hazard",
    [isaac_typescript_definitions_1.CollectibleType.MYSTERY_EGG]: "Sacrificial insemination",
    [isaac_typescript_definitions_1.CollectibleType.FLAT_STONE]: "Skipping tears",
    [isaac_typescript_definitions_1.CollectibleType.MARROW]: "HP up?",
    [isaac_typescript_definitions_1.CollectibleType.SLIPPED_RIB]: "Projectile shield",
    [isaac_typescript_definitions_1.CollectibleType.HALLOWED_GROUND]: "Portable sanctuary",
    [isaac_typescript_definitions_1.CollectibleType.POINTY_RIB]: "Stabbing time",
    [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_THE_DEAD]: "Rise from the grave",
    [isaac_typescript_definitions_1.CollectibleType.DADS_RING]: "Father's blessing",
    [isaac_typescript_definitions_1.CollectibleType.DIVORCE_PAPERS]: "Tears up + you feel empty",
    [isaac_typescript_definitions_1.CollectibleType.JAW_BONE]: "Fetch!",
    [isaac_typescript_definitions_1.CollectibleType.BRITTLE_BONES]: "Everything hurts",
    [isaac_typescript_definitions_1.CollectibleType.BROKEN_SHOVEL_1]: "It feels cursed",
    [isaac_typescript_definitions_1.CollectibleType.BROKEN_SHOVEL_2]: "It feels cursed",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_SHOVEL]: "Lost but not forgotten",
    [isaac_typescript_definitions_1.CollectibleType.MUCORMYCOSIS]: "Spore shot",
    [isaac_typescript_definitions_1.CollectibleType.TWO_SPOOKY]: "4me",
    [isaac_typescript_definitions_1.CollectibleType.GOLDEN_RAZOR]: "Pain from gain",
    [isaac_typescript_definitions_1.CollectibleType.SULFUR]: "Temporary demon form",
    [isaac_typescript_definitions_1.CollectibleType.FORTUNE_COOKIE]: "Reusable fortunes",
    [isaac_typescript_definitions_1.CollectibleType.EYE_SORE]: "More eyes",
    [isaac_typescript_definitions_1.CollectibleType.ONE_HUNDRED_TWENTY_VOLT]: "Zap!",
    [isaac_typescript_definitions_1.CollectibleType.IT_HURTS]: "No it doesn't...",
    [isaac_typescript_definitions_1.CollectibleType.ALMOND_MILK]: "DMG down + tears up + you feel nutty",
    [isaac_typescript_definitions_1.CollectibleType.ROCK_BOTTOM]: "It's only up from there",
    [isaac_typescript_definitions_1.CollectibleType.NANCY_BOMBS]: "Random blast +5 bombs",
    [isaac_typescript_definitions_1.CollectibleType.BAR_OF_SOAP]: "Tears + shot speed up",
    [isaac_typescript_definitions_1.CollectibleType.BLOOD_PUPPY]: "What a cute little thing!",
    [isaac_typescript_definitions_1.CollectibleType.DREAM_CATCHER]: "Sweet dreams",
    [isaac_typescript_definitions_1.CollectibleType.PASCHAL_CANDLE]: "Keep the flame burning",
    [isaac_typescript_definitions_1.CollectibleType.DIVINE_INTERVENTION]: "Double tap shield",
    [isaac_typescript_definitions_1.CollectibleType.BLOOD_OATH]: "Bleed me dry",
    [isaac_typescript_definitions_1.CollectibleType.PLAYDOUGH_COOKIE]: "Tasty rainbow",
    [isaac_typescript_definitions_1.CollectibleType.ORPHAN_SOCKS]: "Speed up + your feet feel stronger",
    [isaac_typescript_definitions_1.CollectibleType.EYE_OF_THE_OCCULT]: "DMG up + range up + controlled tears",
    [isaac_typescript_definitions_1.CollectibleType.IMMACULATE_HEART]: "Halo of tears",
    [isaac_typescript_definitions_1.CollectibleType.MONSTRANCE]: "Purifying light",
    [isaac_typescript_definitions_1.CollectibleType.INTRUDER]: "Invasive friend",
    [isaac_typescript_definitions_1.CollectibleType.DIRTY_MIND]: "Filthy friends",
    [isaac_typescript_definitions_1.CollectibleType.DAMOCLES]: "A king's fortune... but at what cost?",
    [isaac_typescript_definitions_1.CollectibleType.FREE_LEMONADE]: "Party time!",
    [isaac_typescript_definitions_1.CollectibleType.SPIRIT_SWORD]: "Divine blade",
    [isaac_typescript_definitions_1.CollectibleType.RED_KEY]: "Explore the other side",
    [isaac_typescript_definitions_1.CollectibleType.PSY_FLY]: "Flamboyant protector",
    [isaac_typescript_definitions_1.CollectibleType.WAVY_CAP]: "Tears up. A mind changing experience!",
    [isaac_typescript_definitions_1.CollectibleType.ROCKET_IN_A_JAR]: "Rocket propulsion +5 bombs",
    [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_VIRTUES]: "Spiritual companionship",
    [isaac_typescript_definitions_1.CollectibleType.ALABASTER_BOX]: "A sacred offering",
    [isaac_typescript_definitions_1.CollectibleType.STAIRWAY]: "May you get what you came for",
    // There is no `CollectibleType` with a value of 587.
    [isaac_typescript_definitions_1.CollectibleType.SOL]: "Radiant victory",
    [isaac_typescript_definitions_1.CollectibleType.LUNA]: "The moon's blessing shines upon you",
    [isaac_typescript_definitions_1.CollectibleType.MERCURIUS]: "Speed up + you feel elusive",
    [isaac_typescript_definitions_1.CollectibleType.VENUS]: "HP up + you feel pretty",
    [isaac_typescript_definitions_1.CollectibleType.TERRA]: "Born to rock",
    [isaac_typescript_definitions_1.CollectibleType.MARS]: "Double tap dash",
    [isaac_typescript_definitions_1.CollectibleType.JUPITER]: "You're a gas giant!",
    [isaac_typescript_definitions_1.CollectibleType.SATURNUS]: "Ring of tears",
    [isaac_typescript_definitions_1.CollectibleType.URANUS]: "Ice tears",
    [isaac_typescript_definitions_1.CollectibleType.NEPTUNUS]: "Open the floodgates",
    [isaac_typescript_definitions_1.CollectibleType.PLUTO]: "Size down",
    [isaac_typescript_definitions_1.CollectibleType.VOODOO_HEAD]: "Extra curse rooms",
    [isaac_typescript_definitions_1.CollectibleType.EYE_DROPS]: "Tears up",
    [isaac_typescript_definitions_1.CollectibleType.ACT_OF_CONTRITION]: "Tears up, you feel forgiven",
    [isaac_typescript_definitions_1.CollectibleType.MEMBER_CARD]: "Exclusive access!",
    [isaac_typescript_definitions_1.CollectibleType.BATTERY_PACK]: "Instant energy!",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_BRACELET]: "Mother's strength",
    [isaac_typescript_definitions_1.CollectibleType.SCOOPER]: "Plop!",
    [isaac_typescript_definitions_1.CollectibleType.OCULAR_RIFT]: "Stare into the abyss",
    [isaac_typescript_definitions_1.CollectibleType.BOILED_BABY]: "Messy friend",
    [isaac_typescript_definitions_1.CollectibleType.FREEZER_BABY]: "Iced iced baby",
    [isaac_typescript_definitions_1.CollectibleType.ETERNAL_D6]: "???",
    [isaac_typescript_definitions_1.CollectibleType.BIRD_CAGE]: "Fat buddy",
    [isaac_typescript_definitions_1.CollectibleType.LARYNX]: "Hear my pain",
    [isaac_typescript_definitions_1.CollectibleType.LOST_SOUL]: "Protect him",
    // There is no `CollectibleType` with a value of 613.
    [isaac_typescript_definitions_1.CollectibleType.BLOOD_BOMBS]: "Bloody blast + HP up",
    [isaac_typescript_definitions_1.CollectibleType.LIL_DUMPY]: "Puffy buddy",
    [isaac_typescript_definitions_1.CollectibleType.BIRDS_EYE]: "It burns",
    [isaac_typescript_definitions_1.CollectibleType.LODESTONE]: "Magnetizing tears",
    [isaac_typescript_definitions_1.CollectibleType.ROTTEN_TOMATO]: "Delicious!",
    [isaac_typescript_definitions_1.CollectibleType.BIRTHRIGHT]: "???",
    // There is no `CollectibleType` with a value of 620.
    [isaac_typescript_definitions_1.CollectibleType.RED_STEW]: "Full HP + temporary DMG up",
    [isaac_typescript_definitions_1.CollectibleType.GENESIS]: "In the beginning",
    [isaac_typescript_definitions_1.CollectibleType.SHARP_KEY]: "Open your enemies",
    [isaac_typescript_definitions_1.CollectibleType.BOOSTER_PACK]: "Collect them all!",
    [isaac_typescript_definitions_1.CollectibleType.MEGA_MUSH]: "I'm a big boy now!",
    [isaac_typescript_definitions_1.CollectibleType.KNIFE_PIECE_1]: "???",
    [isaac_typescript_definitions_1.CollectibleType.KNIFE_PIECE_2]: "???",
    [isaac_typescript_definitions_1.CollectibleType.DEATH_CERTIFICATE]: "Where am I?",
    [isaac_typescript_definitions_1.CollectibleType.BOT_FLY]: "Defense drone",
    // There is no `CollectibleType` with a value of 630.
    [isaac_typescript_definitions_1.CollectibleType.MEAT_CLEAVER]: "Slice but no dice",
    [isaac_typescript_definitions_1.CollectibleType.EVIL_CHARM]: "Luck up + you feel protected",
    [isaac_typescript_definitions_1.CollectibleType.DOGMA]: "Ascended",
    [isaac_typescript_definitions_1.CollectibleType.PURGATORY]: "Help from beyond",
    [isaac_typescript_definitions_1.CollectibleType.STITCHES]: "Bait and switch",
    [isaac_typescript_definitions_1.CollectibleType.R_KEY]: "Time to start over",
    [isaac_typescript_definitions_1.CollectibleType.KNOCKOUT_DROPS]: "They pack a punch!",
    [isaac_typescript_definitions_1.CollectibleType.ERASER]: "Erase thy enemy",
    [isaac_typescript_definitions_1.CollectibleType.YUCK_HEART]: "Gross!",
    [isaac_typescript_definitions_1.CollectibleType.URN_OF_SOULS]: "Unleash their sorrow",
    [isaac_typescript_definitions_1.CollectibleType.AKELDAMA]: "Spill your guts",
    [isaac_typescript_definitions_1.CollectibleType.MAGIC_SKIN]: "All your desires fulfilled",
    [isaac_typescript_definitions_1.CollectibleType.REVELATION]: "Awaken your faith",
    [isaac_typescript_definitions_1.CollectibleType.CONSOLATION_PRIZE]: "+1 to lowest stat",
    [isaac_typescript_definitions_1.CollectibleType.TINYTOMA]: "Itching for revenge",
    [isaac_typescript_definitions_1.CollectibleType.BRIMSTONE_BOMBS]: "Demon blast +5 bombs",
    [isaac_typescript_definitions_1.CollectibleType.FOUR_FIVE_VOLT]: "Beat the juice out of them!",
    // There is no `CollectibleType` with a value of 648.
    [isaac_typescript_definitions_1.CollectibleType.FRUITY_PLUM]: "Bouncy friend",
    [isaac_typescript_definitions_1.CollectibleType.PLUM_FLUTE]: "Play time!",
    [isaac_typescript_definitions_1.CollectibleType.STAR_OF_BETHLEHEM]: "Follow the light",
    [isaac_typescript_definitions_1.CollectibleType.CUBE_BABY]: "Kick it!",
    [isaac_typescript_definitions_1.CollectibleType.VADE_RETRO]: "Begone!",
    [isaac_typescript_definitions_1.CollectibleType.FALSE_PHD]: "Worse pills + evil up",
    [isaac_typescript_definitions_1.CollectibleType.SPIN_TO_WIN]: "Let it rip!",
    [isaac_typescript_definitions_1.CollectibleType.DAMOCLES_PASSIVE]: "A king's fortune... but at what cost?",
    [isaac_typescript_definitions_1.CollectibleType.VASCULITIS]: "Clogged enemies",
    [isaac_typescript_definitions_1.CollectibleType.GIANT_CELL]: "Micro friends",
    [isaac_typescript_definitions_1.CollectibleType.TROPICAMIDE]: "Tear size + range up",
    [isaac_typescript_definitions_1.CollectibleType.CARD_READING]: "A link to your future",
    [isaac_typescript_definitions_1.CollectibleType.QUINTS]: "They lurk inside",
    // There is no `CollectibleType` with a value of 662.
    [isaac_typescript_definitions_1.CollectibleType.TOOTH_AND_NAIL]: "You feel prickly",
    [isaac_typescript_definitions_1.CollectibleType.BINGE_EATER]: "All you can eat",
    [isaac_typescript_definitions_1.CollectibleType.GUPPYS_EYE]: "An eye for secrets",
    // There is no `CollectibleType` with a value of 666.
    [isaac_typescript_definitions_1.CollectibleType.STRAWMAN]: "A helping hand",
    [isaac_typescript_definitions_1.CollectibleType.DADS_NOTE]: "...",
    [isaac_typescript_definitions_1.CollectibleType.SAUSAGE]: "All stats up",
    [isaac_typescript_definitions_1.CollectibleType.OPTIONS]: "There might be options",
    [isaac_typescript_definitions_1.CollectibleType.CANDY_HEART]: "Power of love",
    [isaac_typescript_definitions_1.CollectibleType.POUND_OF_FLESH]: "Blood money",
    [isaac_typescript_definitions_1.CollectibleType.REDEMPTION]: "Deliver me from evil",
    [isaac_typescript_definitions_1.CollectibleType.SPIRIT_SHACKLES]: "Unfinished business",
    [isaac_typescript_definitions_1.CollectibleType.CRACKED_ORB]: "Shards of knowledge",
    [isaac_typescript_definitions_1.CollectibleType.EMPTY_HEART]: "It multiplies",
    [isaac_typescript_definitions_1.CollectibleType.ASTRAL_PROJECTION]: "The true out-of-body experience!",
    [isaac_typescript_definitions_1.CollectibleType.C_SECTION]: "Fetus shots",
    [isaac_typescript_definitions_1.CollectibleType.LIL_ABADDON]: "Abyssal friend",
    [isaac_typescript_definitions_1.CollectibleType.MONTEZUMAS_REVENGE]: "Oh no...",
    [isaac_typescript_definitions_1.CollectibleType.LIL_PORTAL]: "It hungers",
    [isaac_typescript_definitions_1.CollectibleType.WORM_FRIEND]: "Clingy buddy",
    [isaac_typescript_definitions_1.CollectibleType.BONE_SPURS]: "Break your enemies",
    [isaac_typescript_definitions_1.CollectibleType.HUNGRY_SOUL]: "Out for blood",
    [isaac_typescript_definitions_1.CollectibleType.JAR_OF_WISPS]: "Your faith grows",
    [isaac_typescript_definitions_1.CollectibleType.SOUL_LOCKET]: "Power of faith",
    [isaac_typescript_definitions_1.CollectibleType.FRIEND_FINDER]: "Best friends forever!",
    [isaac_typescript_definitions_1.CollectibleType.INNER_CHILD]: "Let him free",
    [isaac_typescript_definitions_1.CollectibleType.GLITCHED_CROWN]: "?????",
    [isaac_typescript_definitions_1.CollectibleType.JELLY_BELLY]: "Bounce away!",
    [isaac_typescript_definitions_1.CollectibleType.SACRED_ORB]: "Destined for greatness",
    [isaac_typescript_definitions_1.CollectibleType.SANGUINE_BOND]: "He awaits your offering",
    [isaac_typescript_definitions_1.CollectibleType.SWARM]: "Infest",
    [isaac_typescript_definitions_1.CollectibleType.HEARTBREAK]: "Eternal sorrow",
    [isaac_typescript_definitions_1.CollectibleType.BLOODY_GUST]: "May your rage bring haste",
    [isaac_typescript_definitions_1.CollectibleType.SALVATION]: "Divine protection",
    [isaac_typescript_definitions_1.CollectibleType.VANISHING_TWIN]: "He wants revenge",
    [isaac_typescript_definitions_1.CollectibleType.TWISTED_PAIR]: "Double trouble!",
    [isaac_typescript_definitions_1.CollectibleType.AZAZELS_RAGE]: "Ancient power",
    [isaac_typescript_definitions_1.CollectibleType.ECHO_CHAMBER]: "I can see see the future future future",
    [isaac_typescript_definitions_1.CollectibleType.ISAACS_TOMB]: "Buried memories",
    [isaac_typescript_definitions_1.CollectibleType.VENGEFUL_SPIRIT]: "Hot blooded",
    [isaac_typescript_definitions_1.CollectibleType.ESAU_JR]: "Lost brother",
    [isaac_typescript_definitions_1.CollectibleType.BERSERK]: "Rip and tear",
    [isaac_typescript_definitions_1.CollectibleType.DARK_ARTS]: "One with the shadows",
    [isaac_typescript_definitions_1.CollectibleType.ABYSS]: "Come forth from the depths",
    [isaac_typescript_definitions_1.CollectibleType.SUPPER]: "HP up",
    [isaac_typescript_definitions_1.CollectibleType.STAPLER]: "DMG up",
    [isaac_typescript_definitions_1.CollectibleType.SUPLEX]: "Angel breaker",
    [isaac_typescript_definitions_1.CollectibleType.BAG_OF_CRAFTING]: "Make your destiny",
    [isaac_typescript_definitions_1.CollectibleType.FLIP]: "Life and death",
    [isaac_typescript_definitions_1.CollectibleType.LEMEGETON]: "Item summoner",
    [isaac_typescript_definitions_1.CollectibleType.SUMPTORIUM]: "Return",
    [isaac_typescript_definitions_1.CollectibleType.RECALL]: "Come back",
    [isaac_typescript_definitions_1.CollectibleType.HOLD]: "Saved for later",
    [isaac_typescript_definitions_1.CollectibleType.KEEPERS_SACK]: "Spending power",
    [isaac_typescript_definitions_1.CollectibleType.KEEPERS_KIN]: "Under a rock",
    // There is no `CollectibleType` with a value of 718.
    [isaac_typescript_definitions_1.CollectibleType.KEEPERS_BOX]: "Portable shop",
    [isaac_typescript_definitions_1.CollectibleType.EVERYTHING_JAR]: "Anything is possible",
    [isaac_typescript_definitions_1.CollectibleType.TMTRAINER]: "Isaac and his mother lived alone in a small house on a hill",
    [isaac_typescript_definitions_1.CollectibleType.ANIMA_SOLA]: "Repent",
    [isaac_typescript_definitions_1.CollectibleType.SPINDOWN_DICE]: "-1",
    [isaac_typescript_definitions_1.CollectibleType.HYPERCOAGULATION]: "Thick blooded",
    [isaac_typescript_definitions_1.CollectibleType.IBS]: "Your stomach rumbles",
    [isaac_typescript_definitions_1.CollectibleType.HEMOPTYSIS]: "Double tap sneeze",
    [isaac_typescript_definitions_1.CollectibleType.GHOST_BOMBS]: "Spooky blast +5 bombs",
    [isaac_typescript_definitions_1.CollectibleType.GELLO]: "Demonic gestation",
    [isaac_typescript_definitions_1.CollectibleType.DECAP_ATTACK]: "Chuck away!",
    [isaac_typescript_definitions_1.CollectibleType.GLASS_EYE]: "DMG + luck up",
    [isaac_typescript_definitions_1.CollectibleType.STYE]: "DMG + range up",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_RING]: "DMG up", // 732
};
