"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.COLLECTIBLE_NAMES = exports.DEFAULT_COLLECTIBLE_NAME = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
exports.DEFAULT_COLLECTIBLE_NAME = "Unknown";
/**
 * Maps collectible types to the real English names from the "stringtable.sta" file.
 *
 * For a mapping of name to `CollectibleType`, see `COLLECTIBLE_NAME_TO_TYPE_MAP`.
 */
exports.COLLECTIBLE_NAMES = {
    [isaac_typescript_definitions_1.CollectibleType.NULL]: exports.DEFAULT_COLLECTIBLE_NAME,
    [isaac_typescript_definitions_1.CollectibleType.SAD_ONION]: "The Sad Onion",
    [isaac_typescript_definitions_1.CollectibleType.INNER_EYE]: "The Inner Eye",
    [isaac_typescript_definitions_1.CollectibleType.SPOON_BENDER]: "Spoon Bender",
    [isaac_typescript_definitions_1.CollectibleType.CRICKETS_HEAD]: "Cricket's Head",
    [isaac_typescript_definitions_1.CollectibleType.MY_REFLECTION]: "My Reflection",
    [isaac_typescript_definitions_1.CollectibleType.NUMBER_ONE]: "Number One",
    [isaac_typescript_definitions_1.CollectibleType.BLOOD_OF_THE_MARTYR]: "Blood of the Martyr",
    [isaac_typescript_definitions_1.CollectibleType.BROTHER_BOBBY]: "Brother Bobby",
    [isaac_typescript_definitions_1.CollectibleType.SKATOLE]: "Skatole",
    [isaac_typescript_definitions_1.CollectibleType.HALO_OF_FLIES]: "Halo of Flies",
    [isaac_typescript_definitions_1.CollectibleType.ONE_UP]: "1up!",
    [isaac_typescript_definitions_1.CollectibleType.MAGIC_MUSHROOM]: "Magic Mushroom",
    [isaac_typescript_definitions_1.CollectibleType.VIRUS]: "The Virus",
    [isaac_typescript_definitions_1.CollectibleType.ROID_RAGE]: "Roid Rage",
    [isaac_typescript_definitions_1.CollectibleType.HEART]: "<3",
    [isaac_typescript_definitions_1.CollectibleType.RAW_LIVER]: "Raw Liver",
    [isaac_typescript_definitions_1.CollectibleType.SKELETON_KEY]: "Skeleton Key",
    [isaac_typescript_definitions_1.CollectibleType.DOLLAR]: "A Dollar",
    [isaac_typescript_definitions_1.CollectibleType.BOOM]: "Boom!",
    [isaac_typescript_definitions_1.CollectibleType.TRANSCENDENCE]: "Transcendence",
    [isaac_typescript_definitions_1.CollectibleType.COMPASS]: "The Compass",
    [isaac_typescript_definitions_1.CollectibleType.LUNCH]: "Lunch",
    [isaac_typescript_definitions_1.CollectibleType.DINNER]: "Dinner",
    [isaac_typescript_definitions_1.CollectibleType.DESSERT]: "Dessert",
    [isaac_typescript_definitions_1.CollectibleType.BREAKFAST]: "Breakfast",
    [isaac_typescript_definitions_1.CollectibleType.ROTTEN_MEAT]: "Rotten Meat",
    [isaac_typescript_definitions_1.CollectibleType.WOODEN_SPOON]: "Wooden Spoon",
    [isaac_typescript_definitions_1.CollectibleType.BELT]: "The Belt",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_UNDERWEAR]: "Mom's Underwear",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_HEELS]: "Mom's Heels",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_LIPSTICK]: "Mom's Lipstick",
    [isaac_typescript_definitions_1.CollectibleType.WIRE_COAT_HANGER]: "Wire Coat Hanger",
    [isaac_typescript_definitions_1.CollectibleType.BIBLE]: "The Bible",
    [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_BELIAL]: "The Book of Belial",
    [isaac_typescript_definitions_1.CollectibleType.NECRONOMICON]: "The Necronomicon",
    [isaac_typescript_definitions_1.CollectibleType.POOP]: "The Poop",
    [isaac_typescript_definitions_1.CollectibleType.MR_BOOM]: "Mr. Boom",
    [isaac_typescript_definitions_1.CollectibleType.TAMMYS_HEAD]: "Tammy's Head",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_BRA]: "Mom's Bra",
    [isaac_typescript_definitions_1.CollectibleType.KAMIKAZE]: "Kamikaze!",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_PAD]: "Mom's Pad",
    [isaac_typescript_definitions_1.CollectibleType.BOBS_ROTTEN_HEAD]: "Bob's Rotten Head",
    // There is no `CollectibleType` with a value of 43.
    [isaac_typescript_definitions_1.CollectibleType.TELEPORT]: "Teleport!",
    [isaac_typescript_definitions_1.CollectibleType.YUM_HEART]: "Yum Heart",
    [isaac_typescript_definitions_1.CollectibleType.LUCKY_FOOT]: "Lucky Foot",
    [isaac_typescript_definitions_1.CollectibleType.DOCTORS_REMOTE]: "Doctor's Remote",
    [isaac_typescript_definitions_1.CollectibleType.CUPIDS_ARROW]: "Cupid's Arrow",
    [isaac_typescript_definitions_1.CollectibleType.SHOOP_DA_WHOOP]: "Shoop da Whoop!",
    [isaac_typescript_definitions_1.CollectibleType.STEVEN]: "Steven",
    [isaac_typescript_definitions_1.CollectibleType.PENTAGRAM]: "Pentagram",
    [isaac_typescript_definitions_1.CollectibleType.DR_FETUS]: "Dr. Fetus",
    [isaac_typescript_definitions_1.CollectibleType.MAGNETO]: "Magneto",
    [isaac_typescript_definitions_1.CollectibleType.TREASURE_MAP]: "Treasure Map",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_EYE]: "Mom's Eye",
    [isaac_typescript_definitions_1.CollectibleType.LEMON_MISHAP]: "Lemon Mishap",
    [isaac_typescript_definitions_1.CollectibleType.DISTANT_ADMIRATION]: "Distant Admiration",
    [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_SHADOWS]: "Book of Shadows",
    [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_BELIAL_BIRTHRIGHT]: "The Book of Belial",
    [isaac_typescript_definitions_1.CollectibleType.LADDER]: "The Ladder",
    // There is no `CollectibleType` with a value of 61.
    [isaac_typescript_definitions_1.CollectibleType.CHARM_OF_THE_VAMPIRE]: "Charm of the Vampire",
    [isaac_typescript_definitions_1.CollectibleType.BATTERY]: "The Battery",
    [isaac_typescript_definitions_1.CollectibleType.STEAM_SALE]: "Steam Sale",
    [isaac_typescript_definitions_1.CollectibleType.ANARCHIST_COOKBOOK]: "Anarchist Cookbook",
    [isaac_typescript_definitions_1.CollectibleType.HOURGLASS]: "The Hourglass",
    [isaac_typescript_definitions_1.CollectibleType.SISTER_MAGGY]: "Sister Maggy",
    [isaac_typescript_definitions_1.CollectibleType.TECHNOLOGY]: "Technology",
    [isaac_typescript_definitions_1.CollectibleType.CHOCOLATE_MILK]: "Chocolate Milk",
    [isaac_typescript_definitions_1.CollectibleType.GROWTH_HORMONES]: "Growth Hormones",
    [isaac_typescript_definitions_1.CollectibleType.MINI_MUSH]: "Mini Mush",
    [isaac_typescript_definitions_1.CollectibleType.ROSARY]: "Rosary",
    [isaac_typescript_definitions_1.CollectibleType.CUBE_OF_MEAT]: "Cube of Meat",
    [isaac_typescript_definitions_1.CollectibleType.QUARTER]: "A Quarter",
    [isaac_typescript_definitions_1.CollectibleType.PHD]: "PHD",
    [isaac_typescript_definitions_1.CollectibleType.XRAY_VISION]: "X-Ray Vision",
    [isaac_typescript_definitions_1.CollectibleType.MY_LITTLE_UNICORN]: "My Little Unicorn",
    [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_REVELATIONS]: "Book of Revelations",
    [isaac_typescript_definitions_1.CollectibleType.MARK]: "The Mark",
    [isaac_typescript_definitions_1.CollectibleType.PACT]: "The Pact",
    [isaac_typescript_definitions_1.CollectibleType.DEAD_CAT]: "Dead Cat",
    [isaac_typescript_definitions_1.CollectibleType.LORD_OF_THE_PIT]: "Lord of the Pit",
    [isaac_typescript_definitions_1.CollectibleType.NAIL]: "The Nail",
    [isaac_typescript_definitions_1.CollectibleType.WE_NEED_TO_GO_DEEPER]: "We Need To Go Deeper!",
    [isaac_typescript_definitions_1.CollectibleType.DECK_OF_CARDS]: "Deck of Cards",
    [isaac_typescript_definitions_1.CollectibleType.MONSTROS_TOOTH]: "Monstro's Tooth",
    [isaac_typescript_definitions_1.CollectibleType.LOKIS_HORNS]: "Loki's Horns",
    [isaac_typescript_definitions_1.CollectibleType.LITTLE_CHUBBY]: "Little Chubby",
    [isaac_typescript_definitions_1.CollectibleType.SPIDER_BITE]: "Spider Bite",
    [isaac_typescript_definitions_1.CollectibleType.SMALL_ROCK]: "The Small Rock",
    [isaac_typescript_definitions_1.CollectibleType.SPELUNKER_HAT]: "Spelunker Hat",
    [isaac_typescript_definitions_1.CollectibleType.SUPER_BANDAGE]: "Super Bandage",
    [isaac_typescript_definitions_1.CollectibleType.GAMEKID]: "The Gamekid",
    [isaac_typescript_definitions_1.CollectibleType.SACK_OF_PENNIES]: "Sack of Pennies",
    [isaac_typescript_definitions_1.CollectibleType.ROBO_BABY]: "Robo-Baby",
    [isaac_typescript_definitions_1.CollectibleType.LITTLE_CHAD]: "Little C.H.A.D.",
    [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_SIN]: "The Book of Sin",
    [isaac_typescript_definitions_1.CollectibleType.RELIC]: "The Relic",
    [isaac_typescript_definitions_1.CollectibleType.LITTLE_GISH]: "Little Gish",
    [isaac_typescript_definitions_1.CollectibleType.LITTLE_STEVEN]: "Little Steven",
    [isaac_typescript_definitions_1.CollectibleType.HALO]: "The Halo",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_BOTTLE_OF_PILLS]: "Mom's Bottle of Pills",
    [isaac_typescript_definitions_1.CollectibleType.COMMON_COLD]: "The Common Cold",
    [isaac_typescript_definitions_1.CollectibleType.PARASITE]: "The Parasite",
    [isaac_typescript_definitions_1.CollectibleType.D6]: "The D6",
    [isaac_typescript_definitions_1.CollectibleType.MR_MEGA]: "Mr. Mega",
    [isaac_typescript_definitions_1.CollectibleType.PINKING_SHEARS]: "The Pinking Shears",
    [isaac_typescript_definitions_1.CollectibleType.WAFER]: "The Wafer",
    [isaac_typescript_definitions_1.CollectibleType.MONEY_EQUALS_POWER]: "Money = Power",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_CONTACTS]: "Mom's Contacts",
    [isaac_typescript_definitions_1.CollectibleType.BEAN]: "The Bean",
    [isaac_typescript_definitions_1.CollectibleType.GUARDIAN_ANGEL]: "Guardian Angel",
    [isaac_typescript_definitions_1.CollectibleType.DEMON_BABY]: "Demon Baby",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_KNIFE]: "Mom's Knife",
    [isaac_typescript_definitions_1.CollectibleType.OUIJA_BOARD]: "Ouija Board",
    [isaac_typescript_definitions_1.CollectibleType.NINE_VOLT]: "9 Volt",
    [isaac_typescript_definitions_1.CollectibleType.DEAD_BIRD]: "Dead Bird",
    [isaac_typescript_definitions_1.CollectibleType.BRIMSTONE]: "Brimstone",
    [isaac_typescript_definitions_1.CollectibleType.BLOOD_BAG]: "Blood Bag",
    [isaac_typescript_definitions_1.CollectibleType.ODD_MUSHROOM_THIN]: "Odd Mushroom",
    [isaac_typescript_definitions_1.CollectibleType.ODD_MUSHROOM_LARGE]: "Odd Mushroom",
    [isaac_typescript_definitions_1.CollectibleType.WHORE_OF_BABYLON]: "Whore of Babylon",
    [isaac_typescript_definitions_1.CollectibleType.MONSTER_MANUAL]: "Monster Manual",
    [isaac_typescript_definitions_1.CollectibleType.DEAD_SEA_SCROLLS]: "Dead Sea Scrolls",
    [isaac_typescript_definitions_1.CollectibleType.BOBBY_BOMB]: "Bobby-Bomb",
    [isaac_typescript_definitions_1.CollectibleType.RAZOR_BLADE]: "Razor Blade",
    [isaac_typescript_definitions_1.CollectibleType.FORGET_ME_NOW]: "Forget Me Now",
    [isaac_typescript_definitions_1.CollectibleType.FOREVER_ALONE]: "Forever Alone",
    [isaac_typescript_definitions_1.CollectibleType.BUCKET_OF_LARD]: "Bucket of Lard",
    [isaac_typescript_definitions_1.CollectibleType.PONY]: "A Pony",
    [isaac_typescript_definitions_1.CollectibleType.BOMB_BAG]: "Bomb Bag",
    [isaac_typescript_definitions_1.CollectibleType.LUMP_OF_COAL]: "A Lump of Coal",
    [isaac_typescript_definitions_1.CollectibleType.GUPPYS_PAW]: "Guppy's Paw",
    [isaac_typescript_definitions_1.CollectibleType.GUPPYS_TAIL]: "Guppy's Tail",
    [isaac_typescript_definitions_1.CollectibleType.IV_BAG]: "IV Bag",
    [isaac_typescript_definitions_1.CollectibleType.BEST_FRIEND]: "Best Friend",
    [isaac_typescript_definitions_1.CollectibleType.REMOTE_DETONATOR]: "Remote Detonator",
    [isaac_typescript_definitions_1.CollectibleType.STIGMATA]: "Stigmata",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_PURSE]: "Mom's Purse",
    [isaac_typescript_definitions_1.CollectibleType.BOBS_CURSE]: "Bob's Curse",
    [isaac_typescript_definitions_1.CollectibleType.PAGEANT_BOY]: "Pageant Boy",
    [isaac_typescript_definitions_1.CollectibleType.SCAPULAR]: "Scapular",
    [isaac_typescript_definitions_1.CollectibleType.SPEED_BALL]: "Speed Ball",
    [isaac_typescript_definitions_1.CollectibleType.BUM_FRIEND]: "Bum Friend",
    [isaac_typescript_definitions_1.CollectibleType.GUPPYS_HEAD]: "Guppy's Head",
    [isaac_typescript_definitions_1.CollectibleType.PRAYER_CARD]: "Prayer Card",
    [isaac_typescript_definitions_1.CollectibleType.NOTCHED_AXE]: "Notched Axe",
    [isaac_typescript_definitions_1.CollectibleType.INFESTATION]: "Infestation",
    [isaac_typescript_definitions_1.CollectibleType.IPECAC]: "Ipecac",
    [isaac_typescript_definitions_1.CollectibleType.TOUGH_LOVE]: "Tough Love",
    [isaac_typescript_definitions_1.CollectibleType.MULLIGAN]: "The Mulligan",
    [isaac_typescript_definitions_1.CollectibleType.TECHNOLOGY_2]: "Technology 2",
    [isaac_typescript_definitions_1.CollectibleType.MUTANT_SPIDER]: "Mutant Spider",
    [isaac_typescript_definitions_1.CollectibleType.CHEMICAL_PEEL]: "Chemical Peel",
    [isaac_typescript_definitions_1.CollectibleType.PEEPER]: "The Peeper",
    [isaac_typescript_definitions_1.CollectibleType.HABIT]: "Habit",
    [isaac_typescript_definitions_1.CollectibleType.BLOODY_LUST]: "Bloody Lust",
    [isaac_typescript_definitions_1.CollectibleType.CRYSTAL_BALL]: "Crystal Ball",
    [isaac_typescript_definitions_1.CollectibleType.SPIRIT_OF_THE_NIGHT]: "Spirit of the Night",
    [isaac_typescript_definitions_1.CollectibleType.CRACK_THE_SKY]: "Crack the Sky",
    [isaac_typescript_definitions_1.CollectibleType.ANKH]: "Ankh",
    [isaac_typescript_definitions_1.CollectibleType.CELTIC_CROSS]: "Celtic Cross",
    [isaac_typescript_definitions_1.CollectibleType.GHOST_BABY]: "Ghost Baby",
    [isaac_typescript_definitions_1.CollectibleType.CANDLE]: "The Candle",
    [isaac_typescript_definitions_1.CollectibleType.CAT_O_NINE_TAILS]: "Cat-o-nine-tails",
    [isaac_typescript_definitions_1.CollectibleType.D20]: "D20",
    [isaac_typescript_definitions_1.CollectibleType.HARLEQUIN_BABY]: "Harlequin Baby",
    [isaac_typescript_definitions_1.CollectibleType.EPIC_FETUS]: "Epic Fetus",
    [isaac_typescript_definitions_1.CollectibleType.POLYPHEMUS]: "Polyphemus",
    [isaac_typescript_definitions_1.CollectibleType.DADDY_LONGLEGS]: "Daddy Longlegs",
    [isaac_typescript_definitions_1.CollectibleType.SPIDER_BUTT]: "Spider Butt",
    [isaac_typescript_definitions_1.CollectibleType.SACRIFICIAL_DAGGER]: "Sacrificial Dagger",
    [isaac_typescript_definitions_1.CollectibleType.MITRE]: "Mitre",
    [isaac_typescript_definitions_1.CollectibleType.RAINBOW_BABY]: "Rainbow Baby",
    [isaac_typescript_definitions_1.CollectibleType.DADS_KEY]: "Dad's Key",
    [isaac_typescript_definitions_1.CollectibleType.STEM_CELLS]: "Stem Cells",
    [isaac_typescript_definitions_1.CollectibleType.PORTABLE_SLOT]: "Portable Slot",
    [isaac_typescript_definitions_1.CollectibleType.HOLY_WATER]: "Holy Water",
    [isaac_typescript_definitions_1.CollectibleType.FATE]: "Fate",
    [isaac_typescript_definitions_1.CollectibleType.BLACK_BEAN]: "The Black Bean",
    [isaac_typescript_definitions_1.CollectibleType.WHITE_PONY]: "White Pony",
    [isaac_typescript_definitions_1.CollectibleType.SACRED_HEART]: "Sacred Heart",
    [isaac_typescript_definitions_1.CollectibleType.TOOTH_PICKS]: "Tooth Picks",
    [isaac_typescript_definitions_1.CollectibleType.HOLY_GRAIL]: "Holy Grail",
    [isaac_typescript_definitions_1.CollectibleType.DEAD_DOVE]: "Dead Dove",
    [isaac_typescript_definitions_1.CollectibleType.BLOOD_RIGHTS]: "Blood Rights",
    [isaac_typescript_definitions_1.CollectibleType.GUPPYS_HAIRBALL]: "Guppy's Hairball",
    [isaac_typescript_definitions_1.CollectibleType.ABEL]: "Abel",
    [isaac_typescript_definitions_1.CollectibleType.SMB_SUPER_FAN]: "SMB Super Fan",
    [isaac_typescript_definitions_1.CollectibleType.PYRO]: "Pyro",
    [isaac_typescript_definitions_1.CollectibleType.THREE_DOLLAR_BILL]: "3 Dollar Bill",
    [isaac_typescript_definitions_1.CollectibleType.TELEPATHY_BOOK]: "Telepathy For Dummies",
    [isaac_typescript_definitions_1.CollectibleType.MEAT]: "MEAT!",
    [isaac_typescript_definitions_1.CollectibleType.MAGIC_8_BALL]: "Magic 8 Ball",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_COIN_PURSE]: "Mom's Coin Purse",
    [isaac_typescript_definitions_1.CollectibleType.SQUEEZY]: "Squeezy",
    [isaac_typescript_definitions_1.CollectibleType.JESUS_JUICE]: "Jesus Juice",
    [isaac_typescript_definitions_1.CollectibleType.BOX]: "Box",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_KEY]: "Mom's Key",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_EYESHADOW]: "Mom's Eyeshadow",
    [isaac_typescript_definitions_1.CollectibleType.IRON_BAR]: "Iron Bar",
    [isaac_typescript_definitions_1.CollectibleType.MIDAS_TOUCH]: "Midas' Touch",
    [isaac_typescript_definitions_1.CollectibleType.HUMBLEING_BUNDLE]: "Humbleing Bundle",
    [isaac_typescript_definitions_1.CollectibleType.FANNY_PACK]: "Fanny Pack",
    [isaac_typescript_definitions_1.CollectibleType.SHARP_PLUG]: "Sharp Plug",
    [isaac_typescript_definitions_1.CollectibleType.GUILLOTINE]: "Guillotine",
    [isaac_typescript_definitions_1.CollectibleType.BALL_OF_BANDAGES]: "Ball of Bandages",
    [isaac_typescript_definitions_1.CollectibleType.CHAMPION_BELT]: "Champion Belt",
    [isaac_typescript_definitions_1.CollectibleType.BUTT_BOMBS]: "Butt Bombs",
    [isaac_typescript_definitions_1.CollectibleType.GNAWED_LEAF]: "Gnawed Leaf",
    [isaac_typescript_definitions_1.CollectibleType.SPIDERBABY]: "Spiderbaby",
    [isaac_typescript_definitions_1.CollectibleType.GUPPYS_COLLAR]: "Guppy's Collar",
    [isaac_typescript_definitions_1.CollectibleType.LOST_CONTACT]: "Lost Contact",
    [isaac_typescript_definitions_1.CollectibleType.ANEMIC]: "Anemic",
    [isaac_typescript_definitions_1.CollectibleType.GOAT_HEAD]: "Goat Head",
    [isaac_typescript_definitions_1.CollectibleType.CEREMONIAL_ROBES]: "Ceremonial Robes",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_WIG]: "Mom's Wig",
    [isaac_typescript_definitions_1.CollectibleType.PLACENTA]: "Placenta",
    [isaac_typescript_definitions_1.CollectibleType.OLD_BANDAGE]: "Old Bandage",
    [isaac_typescript_definitions_1.CollectibleType.SAD_BOMBS]: "Sad Bombs",
    [isaac_typescript_definitions_1.CollectibleType.RUBBER_CEMENT]: "Rubber Cement",
    [isaac_typescript_definitions_1.CollectibleType.ANTI_GRAVITY]: "Anti-Gravity",
    [isaac_typescript_definitions_1.CollectibleType.PYROMANIAC]: "Pyromaniac",
    [isaac_typescript_definitions_1.CollectibleType.CRICKETS_BODY]: "Cricket's Body",
    [isaac_typescript_definitions_1.CollectibleType.GIMPY]: "Gimpy",
    [isaac_typescript_definitions_1.CollectibleType.BLACK_LOTUS]: "Black Lotus",
    [isaac_typescript_definitions_1.CollectibleType.PIGGY_BANK]: "Piggy Bank",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_PERFUME]: "Mom's Perfume",
    [isaac_typescript_definitions_1.CollectibleType.MONSTROS_LUNG]: "Monstro's Lung",
    [isaac_typescript_definitions_1.CollectibleType.ABADDON]: "Abaddon",
    [isaac_typescript_definitions_1.CollectibleType.BALL_OF_TAR]: "Ball of Tar",
    [isaac_typescript_definitions_1.CollectibleType.STOP_WATCH]: "Stop Watch",
    [isaac_typescript_definitions_1.CollectibleType.TINY_PLANET]: "Tiny Planet",
    [isaac_typescript_definitions_1.CollectibleType.INFESTATION_2]: "Infestation 2",
    // There is no `CollectibleType` with a value of 235.
    [isaac_typescript_definitions_1.CollectibleType.E_COLI]: "E. Coli",
    [isaac_typescript_definitions_1.CollectibleType.DEATHS_TOUCH]: "Death's Touch",
    [isaac_typescript_definitions_1.CollectibleType.KEY_PIECE_1]: "Key Piece 1",
    [isaac_typescript_definitions_1.CollectibleType.KEY_PIECE_2]: "Key Piece 2",
    [isaac_typescript_definitions_1.CollectibleType.EXPERIMENTAL_TREATMENT]: "Experimental Treatment",
    [isaac_typescript_definitions_1.CollectibleType.CONTRACT_FROM_BELOW]: "Contract from Below",
    [isaac_typescript_definitions_1.CollectibleType.INFAMY]: "Infamy",
    [isaac_typescript_definitions_1.CollectibleType.TRINITY_SHIELD]: "Trinity Shield",
    [isaac_typescript_definitions_1.CollectibleType.TECH_5]: "Tech.5",
    [isaac_typescript_definitions_1.CollectibleType.TWENTY_TWENTY]: "20/20",
    [isaac_typescript_definitions_1.CollectibleType.BLUE_MAP]: "Blue Map",
    [isaac_typescript_definitions_1.CollectibleType.BFFS]: "BFFS!",
    [isaac_typescript_definitions_1.CollectibleType.HIVE_MIND]: "Hive Mind",
    [isaac_typescript_definitions_1.CollectibleType.THERES_OPTIONS]: "There's Options",
    [isaac_typescript_definitions_1.CollectibleType.BOGO_BOMBS]: "BOGO Bombs",
    [isaac_typescript_definitions_1.CollectibleType.STARTER_DECK]: "Starter Deck",
    [isaac_typescript_definitions_1.CollectibleType.LITTLE_BAGGY]: "Little Baggy",
    [isaac_typescript_definitions_1.CollectibleType.MAGIC_SCAB]: "Magic Scab",
    [isaac_typescript_definitions_1.CollectibleType.BLOOD_CLOT]: "Blood Clot",
    [isaac_typescript_definitions_1.CollectibleType.SCREW]: "Screw",
    [isaac_typescript_definitions_1.CollectibleType.HOT_BOMBS]: "Hot Bombs",
    [isaac_typescript_definitions_1.CollectibleType.FIRE_MIND]: "Fire Mind",
    [isaac_typescript_definitions_1.CollectibleType.MISSING_NO]: "Missing No.",
    [isaac_typescript_definitions_1.CollectibleType.DARK_MATTER]: "Dark Matter",
    [isaac_typescript_definitions_1.CollectibleType.BLACK_CANDLE]: "Black Candle",
    [isaac_typescript_definitions_1.CollectibleType.PROPTOSIS]: "Proptosis",
    [isaac_typescript_definitions_1.CollectibleType.MISSING_PAGE_2]: "Missing Page 2",
    [isaac_typescript_definitions_1.CollectibleType.CLEAR_RUNE]: "Clear Rune",
    [isaac_typescript_definitions_1.CollectibleType.SMART_FLY]: "Smart Fly",
    [isaac_typescript_definitions_1.CollectibleType.DRY_BABY]: "Dry Baby",
    [isaac_typescript_definitions_1.CollectibleType.JUICY_SACK]: "Juicy Sack",
    [isaac_typescript_definitions_1.CollectibleType.ROBO_BABY_2]: "Robo-Baby 2.0",
    [isaac_typescript_definitions_1.CollectibleType.ROTTEN_BABY]: "Rotten Baby",
    [isaac_typescript_definitions_1.CollectibleType.HEADLESS_BABY]: "Headless Baby",
    [isaac_typescript_definitions_1.CollectibleType.LEECH]: "Leech",
    [isaac_typescript_definitions_1.CollectibleType.MYSTERY_SACK]: "Mystery Sack",
    [isaac_typescript_definitions_1.CollectibleType.BBF]: "BBF",
    [isaac_typescript_definitions_1.CollectibleType.BOBS_BRAIN]: "Bob's Brain",
    [isaac_typescript_definitions_1.CollectibleType.BEST_BUD]: "Best Bud",
    [isaac_typescript_definitions_1.CollectibleType.LIL_BRIMSTONE]: "Lil Brimstone",
    [isaac_typescript_definitions_1.CollectibleType.ISAACS_HEART]: "Isaac's Heart",
    [isaac_typescript_definitions_1.CollectibleType.LIL_HAUNT]: "Lil Haunt",
    [isaac_typescript_definitions_1.CollectibleType.DARK_BUM]: "Dark Bum",
    [isaac_typescript_definitions_1.CollectibleType.BIG_FAN]: "Big Fan",
    [isaac_typescript_definitions_1.CollectibleType.SISSY_LONGLEGS]: "Sissy Longlegs",
    [isaac_typescript_definitions_1.CollectibleType.PUNCHING_BAG]: "Punching Bag",
    [isaac_typescript_definitions_1.CollectibleType.HOW_TO_JUMP]: "How to Jump",
    [isaac_typescript_definitions_1.CollectibleType.D100]: "D100",
    [isaac_typescript_definitions_1.CollectibleType.D4]: "D4",
    [isaac_typescript_definitions_1.CollectibleType.D10]: "D10",
    [isaac_typescript_definitions_1.CollectibleType.BLANK_CARD]: "Blank Card",
    [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_SECRETS]: "Book of Secrets",
    [isaac_typescript_definitions_1.CollectibleType.BOX_OF_SPIDERS]: "Box of Spiders",
    [isaac_typescript_definitions_1.CollectibleType.RED_CANDLE]: "Red Candle",
    [isaac_typescript_definitions_1.CollectibleType.JAR]: "The Jar",
    [isaac_typescript_definitions_1.CollectibleType.FLUSH]: "Flush!",
    [isaac_typescript_definitions_1.CollectibleType.SATANIC_BIBLE]: "Satanic Bible",
    [isaac_typescript_definitions_1.CollectibleType.HEAD_OF_KRAMPUS]: "Head of Krampus",
    [isaac_typescript_definitions_1.CollectibleType.BUTTER_BEAN]: "Butter Bean",
    [isaac_typescript_definitions_1.CollectibleType.MAGIC_FINGERS]: "Magic Fingers",
    [isaac_typescript_definitions_1.CollectibleType.CONVERTER]: "Converter",
    [isaac_typescript_definitions_1.CollectibleType.BLUE_BOX]: "Pandora's Box",
    [isaac_typescript_definitions_1.CollectibleType.UNICORN_STUMP]: "Unicorn Stump",
    [isaac_typescript_definitions_1.CollectibleType.TAURUS]: "Taurus",
    [isaac_typescript_definitions_1.CollectibleType.ARIES]: "Aries",
    [isaac_typescript_definitions_1.CollectibleType.CANCER]: "Cancer",
    [isaac_typescript_definitions_1.CollectibleType.LEO]: "Leo",
    [isaac_typescript_definitions_1.CollectibleType.VIRGO]: "Virgo",
    [isaac_typescript_definitions_1.CollectibleType.LIBRA]: "Libra",
    [isaac_typescript_definitions_1.CollectibleType.SCORPIO]: "Scorpio",
    [isaac_typescript_definitions_1.CollectibleType.SAGITTARIUS]: "Sagittarius",
    [isaac_typescript_definitions_1.CollectibleType.CAPRICORN]: "Capricorn",
    [isaac_typescript_definitions_1.CollectibleType.AQUARIUS]: "Aquarius",
    [isaac_typescript_definitions_1.CollectibleType.PISCES]: "Pisces",
    [isaac_typescript_definitions_1.CollectibleType.EVES_MASCARA]: "Eve's Mascara",
    [isaac_typescript_definitions_1.CollectibleType.JUDAS_SHADOW]: "Judas' Shadow",
    [isaac_typescript_definitions_1.CollectibleType.MAGGYS_BOW]: "Maggy's Bow",
    [isaac_typescript_definitions_1.CollectibleType.HOLY_MANTLE]: "Holy Mantle",
    [isaac_typescript_definitions_1.CollectibleType.THUNDER_THIGHS]: "Thunder Thighs",
    [isaac_typescript_definitions_1.CollectibleType.STRANGE_ATTRACTOR]: "Strange Attractor",
    [isaac_typescript_definitions_1.CollectibleType.CURSED_EYE]: "Cursed Eye",
    [isaac_typescript_definitions_1.CollectibleType.MYSTERIOUS_LIQUID]: "Mysterious Liquid",
    [isaac_typescript_definitions_1.CollectibleType.GEMINI]: "Gemini",
    [isaac_typescript_definitions_1.CollectibleType.CAINS_OTHER_EYE]: "Cain's Other Eye",
    [isaac_typescript_definitions_1.CollectibleType.BLUE_BABYS_ONLY_FRIEND]: "???'s Only Friend",
    [isaac_typescript_definitions_1.CollectibleType.SAMSONS_CHAINS]: "Samson's Chains",
    [isaac_typescript_definitions_1.CollectibleType.MONGO_BABY]: "Mongo Baby",
    [isaac_typescript_definitions_1.CollectibleType.ISAACS_TEARS]: "Isaac's Tears",
    [isaac_typescript_definitions_1.CollectibleType.UNDEFINED]: "Undefined",
    [isaac_typescript_definitions_1.CollectibleType.SCISSORS]: "Scissors",
    [isaac_typescript_definitions_1.CollectibleType.BREATH_OF_LIFE]: "Breath of Life",
    [isaac_typescript_definitions_1.CollectibleType.POLAROID]: "The Polaroid",
    [isaac_typescript_definitions_1.CollectibleType.NEGATIVE]: "The Negative",
    [isaac_typescript_definitions_1.CollectibleType.LUDOVICO_TECHNIQUE]: "The Ludovico Technique",
    [isaac_typescript_definitions_1.CollectibleType.SOY_MILK]: "Soy Milk",
    [isaac_typescript_definitions_1.CollectibleType.GODHEAD]: "Godhead",
    [isaac_typescript_definitions_1.CollectibleType.LAZARUS_RAGS]: "Lazarus' Rags",
    [isaac_typescript_definitions_1.CollectibleType.MIND]: "The Mind",
    [isaac_typescript_definitions_1.CollectibleType.BODY]: "The Body",
    [isaac_typescript_definitions_1.CollectibleType.SOUL]: "The Soul",
    [isaac_typescript_definitions_1.CollectibleType.DEAD_ONION]: "Dead Onion",
    [isaac_typescript_definitions_1.CollectibleType.BROKEN_WATCH]: "Broken Watch",
    [isaac_typescript_definitions_1.CollectibleType.BOOMERANG]: "The Boomerang",
    [isaac_typescript_definitions_1.CollectibleType.SAFETY_PIN]: "Safety Pin",
    [isaac_typescript_definitions_1.CollectibleType.CAFFEINE_PILL]: "Caffeine Pill",
    [isaac_typescript_definitions_1.CollectibleType.TORN_PHOTO]: "Torn Photo",
    [isaac_typescript_definitions_1.CollectibleType.BLUE_CAP]: "Blue Cap",
    [isaac_typescript_definitions_1.CollectibleType.LATCH_KEY]: "Latch Key",
    [isaac_typescript_definitions_1.CollectibleType.MATCH_BOOK]: "Match Book",
    [isaac_typescript_definitions_1.CollectibleType.SYNTHOIL]: "Synthoil",
    [isaac_typescript_definitions_1.CollectibleType.SNACK]: "A Snack",
    [isaac_typescript_definitions_1.CollectibleType.DIPLOPIA]: "Diplopia",
    [isaac_typescript_definitions_1.CollectibleType.PLACEBO]: "Placebo",
    [isaac_typescript_definitions_1.CollectibleType.WOODEN_NICKEL]: "Wooden Nickel",
    [isaac_typescript_definitions_1.CollectibleType.TOXIC_SHOCK]: "Toxic Shock",
    [isaac_typescript_definitions_1.CollectibleType.MEGA_BEAN]: "Mega Bean",
    [isaac_typescript_definitions_1.CollectibleType.GLASS_CANNON]: "Glass Cannon",
    [isaac_typescript_definitions_1.CollectibleType.BOMBER_BOY]: "Bomber Boy",
    [isaac_typescript_definitions_1.CollectibleType.CRACK_JACKS]: "Crack Jacks",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_PEARLS]: "Mom's Pearls",
    [isaac_typescript_definitions_1.CollectibleType.CAR_BATTERY]: "Car Battery",
    [isaac_typescript_definitions_1.CollectibleType.BOX_OF_FRIENDS]: "Box of Friends",
    [isaac_typescript_definitions_1.CollectibleType.WIZ]: "The Wiz",
    [isaac_typescript_definitions_1.CollectibleType.EIGHT_INCH_NAILS]: "8 Inch Nails",
    [isaac_typescript_definitions_1.CollectibleType.INCUBUS]: "Incubus",
    [isaac_typescript_definitions_1.CollectibleType.FATES_REWARD]: "Fate's Reward",
    [isaac_typescript_definitions_1.CollectibleType.LIL_CHEST]: "Lil Chest",
    [isaac_typescript_definitions_1.CollectibleType.SWORN_PROTECTOR]: "Sworn Protector",
    [isaac_typescript_definitions_1.CollectibleType.FRIEND_ZONE]: "Friend Zone",
    [isaac_typescript_definitions_1.CollectibleType.LOST_FLY]: "Lost Fly",
    [isaac_typescript_definitions_1.CollectibleType.SCATTER_BOMBS]: "Scatter Bombs",
    [isaac_typescript_definitions_1.CollectibleType.STICKY_BOMBS]: "Sticky Bombs",
    [isaac_typescript_definitions_1.CollectibleType.EPIPHORA]: "Epiphora",
    [isaac_typescript_definitions_1.CollectibleType.CONTINUUM]: "Continuum",
    [isaac_typescript_definitions_1.CollectibleType.MR_DOLLY]: "Mr. Dolly",
    [isaac_typescript_definitions_1.CollectibleType.CURSE_OF_THE_TOWER]: "Curse of the Tower",
    [isaac_typescript_definitions_1.CollectibleType.CHARGED_BABY]: "Charged Baby",
    [isaac_typescript_definitions_1.CollectibleType.DEAD_EYE]: "Dead Eye",
    [isaac_typescript_definitions_1.CollectibleType.HOLY_LIGHT]: "Holy Light",
    [isaac_typescript_definitions_1.CollectibleType.HOST_HAT]: "Host Hat",
    [isaac_typescript_definitions_1.CollectibleType.RESTOCK]: "Restock",
    [isaac_typescript_definitions_1.CollectibleType.BURSTING_SACK]: "Bursting Sack",
    [isaac_typescript_definitions_1.CollectibleType.NUMBER_TWO]: "Number Two",
    [isaac_typescript_definitions_1.CollectibleType.PUPULA_DUPLEX]: "Pupula Duplex",
    [isaac_typescript_definitions_1.CollectibleType.PAY_TO_PLAY]: "Pay To Play",
    [isaac_typescript_definitions_1.CollectibleType.EDENS_BLESSING]: "Eden's Blessing",
    [isaac_typescript_definitions_1.CollectibleType.FRIEND_BALL]: "Friendly Ball",
    [isaac_typescript_definitions_1.CollectibleType.TEAR_DETONATOR]: "Tear Detonator",
    [isaac_typescript_definitions_1.CollectibleType.LIL_GURDY]: "Lil Gurdy",
    [isaac_typescript_definitions_1.CollectibleType.BUMBO]: "Bumbo",
    [isaac_typescript_definitions_1.CollectibleType.D12]: "D12",
    [isaac_typescript_definitions_1.CollectibleType.CENSER]: "Censer",
    [isaac_typescript_definitions_1.CollectibleType.KEY_BUM]: "Key Bum",
    [isaac_typescript_definitions_1.CollectibleType.RUNE_BAG]: "Rune Bag",
    [isaac_typescript_definitions_1.CollectibleType.SERAPHIM]: "Seraphim",
    [isaac_typescript_definitions_1.CollectibleType.BETRAYAL]: "Betrayal",
    [isaac_typescript_definitions_1.CollectibleType.ZODIAC]: "Zodiac",
    [isaac_typescript_definitions_1.CollectibleType.SERPENTS_KISS]: "Serpent's Kiss",
    [isaac_typescript_definitions_1.CollectibleType.MARKED]: "Marked",
    [isaac_typescript_definitions_1.CollectibleType.TECH_X]: "Tech X",
    [isaac_typescript_definitions_1.CollectibleType.VENTRICLE_RAZOR]: "Ventricle Razor",
    [isaac_typescript_definitions_1.CollectibleType.TRACTOR_BEAM]: "Tractor Beam",
    [isaac_typescript_definitions_1.CollectibleType.GODS_FLESH]: "God's Flesh",
    [isaac_typescript_definitions_1.CollectibleType.MAW_OF_THE_VOID]: "Maw of the Void",
    [isaac_typescript_definitions_1.CollectibleType.SPEAR_OF_DESTINY]: "Spear of Destiny",
    [isaac_typescript_definitions_1.CollectibleType.EXPLOSIVO]: "Explosivo",
    [isaac_typescript_definitions_1.CollectibleType.CHAOS]: "Chaos",
    [isaac_typescript_definitions_1.CollectibleType.SPIDER_MOD]: "Spider Mod",
    [isaac_typescript_definitions_1.CollectibleType.FARTING_BABY]: "Farting Baby",
    [isaac_typescript_definitions_1.CollectibleType.GB_BUG]: "GB Bug",
    [isaac_typescript_definitions_1.CollectibleType.D8]: "D8",
    [isaac_typescript_definitions_1.CollectibleType.PURITY]: "Purity",
    [isaac_typescript_definitions_1.CollectibleType.ATHAME]: "Athame",
    [isaac_typescript_definitions_1.CollectibleType.EMPTY_VESSEL]: "Empty Vessel",
    [isaac_typescript_definitions_1.CollectibleType.EVIL_EYE]: "Evil Eye",
    [isaac_typescript_definitions_1.CollectibleType.LUSTY_BLOOD]: "Lusty Blood",
    [isaac_typescript_definitions_1.CollectibleType.CAMBION_CONCEPTION]: "Cambion Conception",
    [isaac_typescript_definitions_1.CollectibleType.IMMACULATE_CONCEPTION]: "Immaculate Conception",
    [isaac_typescript_definitions_1.CollectibleType.MORE_OPTIONS]: "More Options",
    [isaac_typescript_definitions_1.CollectibleType.CROWN_OF_LIGHT]: "Crown of Light",
    [isaac_typescript_definitions_1.CollectibleType.DEEP_POCKETS]: "Deep Pockets",
    [isaac_typescript_definitions_1.CollectibleType.SUCCUBUS]: "Succubus",
    [isaac_typescript_definitions_1.CollectibleType.FRUIT_CAKE]: "Fruit Cake",
    [isaac_typescript_definitions_1.CollectibleType.TELEPORT_2]: "Teleport 2.0",
    [isaac_typescript_definitions_1.CollectibleType.BLACK_POWDER]: "Black Powder",
    [isaac_typescript_definitions_1.CollectibleType.KIDNEY_BEAN]: "Kidney Bean",
    [isaac_typescript_definitions_1.CollectibleType.GLOWING_HOUR_GLASS]: "Glowing Hourglass",
    [isaac_typescript_definitions_1.CollectibleType.CIRCLE_OF_PROTECTION]: "Circle of Protection",
    [isaac_typescript_definitions_1.CollectibleType.SACK_HEAD]: "Sack Head",
    [isaac_typescript_definitions_1.CollectibleType.NIGHT_LIGHT]: "Night Light",
    [isaac_typescript_definitions_1.CollectibleType.OBSESSED_FAN]: "Obsessed Fan",
    [isaac_typescript_definitions_1.CollectibleType.MINE_CRAFTER]: "Mine Crafter",
    [isaac_typescript_definitions_1.CollectibleType.PJS]: "PJs",
    [isaac_typescript_definitions_1.CollectibleType.HEAD_OF_THE_KEEPER]: "Head of the Keeper",
    [isaac_typescript_definitions_1.CollectibleType.PAPA_FLY]: "Papa Fly",
    [isaac_typescript_definitions_1.CollectibleType.MULTIDIMENSIONAL_BABY]: "Multidimensional Baby",
    [isaac_typescript_definitions_1.CollectibleType.GLITTER_BOMBS]: "Glitter Bombs",
    [isaac_typescript_definitions_1.CollectibleType.MY_SHADOW]: "My Shadow",
    [isaac_typescript_definitions_1.CollectibleType.JAR_OF_FLIES]: "Jar of Flies",
    [isaac_typescript_definitions_1.CollectibleType.LIL_LOKI]: "Lil Loki",
    [isaac_typescript_definitions_1.CollectibleType.MILK]: "Milk!",
    [isaac_typescript_definitions_1.CollectibleType.D7]: "D7",
    [isaac_typescript_definitions_1.CollectibleType.BINKY]: "Binky",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_BOX]: "Mom's Box",
    [isaac_typescript_definitions_1.CollectibleType.KIDNEY_STONE]: "Kidney Stone",
    [isaac_typescript_definitions_1.CollectibleType.MEGA_BLAST]: "Mega Blast",
    [isaac_typescript_definitions_1.CollectibleType.DARK_PRINCES_CROWN]: "Dark Prince's Crown",
    [isaac_typescript_definitions_1.CollectibleType.APPLE]: "Apple!",
    [isaac_typescript_definitions_1.CollectibleType.LEAD_PENCIL]: "Lead Pencil",
    [isaac_typescript_definitions_1.CollectibleType.DOG_TOOTH]: "Dog Tooth",
    [isaac_typescript_definitions_1.CollectibleType.DEAD_TOOTH]: "Dead Tooth",
    [isaac_typescript_definitions_1.CollectibleType.LINGER_BEAN]: "Linger Bean",
    [isaac_typescript_definitions_1.CollectibleType.SHARD_OF_GLASS]: "Shard of Glass",
    [isaac_typescript_definitions_1.CollectibleType.METAL_PLATE]: "Metal Plate",
    [isaac_typescript_definitions_1.CollectibleType.EYE_OF_GREED]: "Eye of Greed",
    [isaac_typescript_definitions_1.CollectibleType.TAROT_CLOTH]: "Tarot Cloth",
    [isaac_typescript_definitions_1.CollectibleType.VARICOSE_VEINS]: "Varicose Veins",
    [isaac_typescript_definitions_1.CollectibleType.COMPOUND_FRACTURE]: "Compound Fracture",
    [isaac_typescript_definitions_1.CollectibleType.POLYDACTYLY]: "Polydactyly",
    [isaac_typescript_definitions_1.CollectibleType.DADS_LOST_COIN]: "Dad's Lost Coin",
    [isaac_typescript_definitions_1.CollectibleType.MIDNIGHT_SNACK]: "Midnight Snack",
    [isaac_typescript_definitions_1.CollectibleType.CONE_HEAD]: "Cone Head",
    [isaac_typescript_definitions_1.CollectibleType.BELLY_BUTTON]: "Belly Button",
    [isaac_typescript_definitions_1.CollectibleType.SINUS_INFECTION]: "Sinus Infection",
    [isaac_typescript_definitions_1.CollectibleType.GLAUCOMA]: "Glaucoma",
    [isaac_typescript_definitions_1.CollectibleType.PARASITOID]: "Parasitoid",
    [isaac_typescript_definitions_1.CollectibleType.EYE_OF_BELIAL]: "Eye of Belial",
    [isaac_typescript_definitions_1.CollectibleType.SULFURIC_ACID]: "Sulfuric Acid",
    [isaac_typescript_definitions_1.CollectibleType.GLYPH_OF_BALANCE]: "Glyph of Balance",
    [isaac_typescript_definitions_1.CollectibleType.ANALOG_STICK]: "Analog Stick",
    [isaac_typescript_definitions_1.CollectibleType.CONTAGION]: "Contagion",
    [isaac_typescript_definitions_1.CollectibleType.FINGER]: "Finger!",
    [isaac_typescript_definitions_1.CollectibleType.SHADE]: "Shade",
    [isaac_typescript_definitions_1.CollectibleType.DEPRESSION]: "Depression",
    [isaac_typescript_definitions_1.CollectibleType.HUSHY]: "Hushy",
    [isaac_typescript_definitions_1.CollectibleType.LIL_MONSTRO]: "Lil Monstro",
    [isaac_typescript_definitions_1.CollectibleType.KING_BABY]: "King Baby",
    [isaac_typescript_definitions_1.CollectibleType.BIG_CHUBBY]: "Big Chubby",
    [isaac_typescript_definitions_1.CollectibleType.BROKEN_GLASS_CANNON]: "Broken Glass Cannon",
    [isaac_typescript_definitions_1.CollectibleType.PLAN_C]: "Plan C",
    [isaac_typescript_definitions_1.CollectibleType.D1]: "D1",
    [isaac_typescript_definitions_1.CollectibleType.VOID]: "Void",
    [isaac_typescript_definitions_1.CollectibleType.PAUSE]: "Pause",
    [isaac_typescript_definitions_1.CollectibleType.SMELTER]: "Smelter",
    [isaac_typescript_definitions_1.CollectibleType.COMPOST]: "Compost",
    [isaac_typescript_definitions_1.CollectibleType.DATAMINER]: "Dataminer",
    [isaac_typescript_definitions_1.CollectibleType.CLICKER]: "Clicker",
    [isaac_typescript_definitions_1.CollectibleType.MAMA_MEGA]: "Mama Mega!",
    [isaac_typescript_definitions_1.CollectibleType.WAIT_WHAT]: "Wait What?",
    [isaac_typescript_definitions_1.CollectibleType.CROOKED_PENNY]: "Crooked Penny",
    [isaac_typescript_definitions_1.CollectibleType.DULL_RAZOR]: "Dull Razor",
    [isaac_typescript_definitions_1.CollectibleType.POTATO_PEELER]: "Potato Peeler",
    [isaac_typescript_definitions_1.CollectibleType.METRONOME]: "Metronome",
    [isaac_typescript_definitions_1.CollectibleType.D_INFINITY]: "D infinity",
    [isaac_typescript_definitions_1.CollectibleType.EDENS_SOUL]: "Eden's Soul",
    [isaac_typescript_definitions_1.CollectibleType.ACID_BABY]: "Acid Baby",
    [isaac_typescript_definitions_1.CollectibleType.YO_LISTEN]: "YO LISTEN!",
    [isaac_typescript_definitions_1.CollectibleType.ADRENALINE]: "Adrenaline",
    [isaac_typescript_definitions_1.CollectibleType.JACOBS_LADDER]: "Jacob's Ladder",
    [isaac_typescript_definitions_1.CollectibleType.GHOST_PEPPER]: "Ghost Pepper",
    [isaac_typescript_definitions_1.CollectibleType.EUTHANASIA]: "Euthanasia",
    [isaac_typescript_definitions_1.CollectibleType.CAMO_UNDIES]: "Camo Undies",
    [isaac_typescript_definitions_1.CollectibleType.DUALITY]: "Duality",
    [isaac_typescript_definitions_1.CollectibleType.EUCHARIST]: "Eucharist",
    [isaac_typescript_definitions_1.CollectibleType.SACK_OF_SACKS]: "Sack of Sacks",
    [isaac_typescript_definitions_1.CollectibleType.GREEDS_GULLET]: "Greed's Gullet",
    [isaac_typescript_definitions_1.CollectibleType.LARGE_ZIT]: "Large Zit",
    [isaac_typescript_definitions_1.CollectibleType.LITTLE_HORN]: "Little Horn",
    [isaac_typescript_definitions_1.CollectibleType.BROWN_NUGGET]: "Brown Nugget",
    [isaac_typescript_definitions_1.CollectibleType.POKE_GO]: "Poke Go",
    [isaac_typescript_definitions_1.CollectibleType.BACKSTABBER]: "Backstabber",
    [isaac_typescript_definitions_1.CollectibleType.SHARP_STRAW]: "Sharp Straw",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_RAZOR]: "Mom's Razor",
    [isaac_typescript_definitions_1.CollectibleType.BLOODSHOT_EYE]: "Bloodshot Eye",
    [isaac_typescript_definitions_1.CollectibleType.DELIRIOUS]: "Delirious",
    [isaac_typescript_definitions_1.CollectibleType.ANGRY_FLY]: "Angry Fly",
    [isaac_typescript_definitions_1.CollectibleType.BLACK_HOLE]: "Black Hole",
    [isaac_typescript_definitions_1.CollectibleType.BOZO]: "Bozo",
    [isaac_typescript_definitions_1.CollectibleType.BROKEN_MODEM]: "Broken Modem",
    [isaac_typescript_definitions_1.CollectibleType.MYSTERY_GIFT]: "Mystery Gift",
    [isaac_typescript_definitions_1.CollectibleType.SPRINKLER]: "Sprinkler",
    [isaac_typescript_definitions_1.CollectibleType.FAST_BOMBS]: "Fast Bombs",
    [isaac_typescript_definitions_1.CollectibleType.BUDDY_IN_A_BOX]: "Buddy in a Box",
    [isaac_typescript_definitions_1.CollectibleType.LIL_DELIRIUM]: "Lil Delirium",
    [isaac_typescript_definitions_1.CollectibleType.JUMPER_CABLES]: "Jumper Cables",
    [isaac_typescript_definitions_1.CollectibleType.COUPON]: "Coupon",
    [isaac_typescript_definitions_1.CollectibleType.TELEKINESIS]: "Telekinesis",
    [isaac_typescript_definitions_1.CollectibleType.MOVING_BOX]: "Moving Box",
    [isaac_typescript_definitions_1.CollectibleType.TECHNOLOGY_ZERO]: "Technology Zero",
    [isaac_typescript_definitions_1.CollectibleType.LEPROSY]: "Leprosy",
    [isaac_typescript_definitions_1.CollectibleType.SEVEN_SEALS]: "7 Seals",
    [isaac_typescript_definitions_1.CollectibleType.MR_ME]: "Mr. ME!",
    [isaac_typescript_definitions_1.CollectibleType.ANGELIC_PRISM]: "Angelic Prism",
    [isaac_typescript_definitions_1.CollectibleType.POP]: "Pop!",
    [isaac_typescript_definitions_1.CollectibleType.DEATHS_LIST]: "Death's List",
    [isaac_typescript_definitions_1.CollectibleType.HAEMOLACRIA]: "Haemolacria",
    [isaac_typescript_definitions_1.CollectibleType.LACHRYPHAGY]: "Lachryphagy",
    [isaac_typescript_definitions_1.CollectibleType.TRISAGION]: "Trisagion",
    [isaac_typescript_definitions_1.CollectibleType.SCHOOLBAG]: "Schoolbag",
    [isaac_typescript_definitions_1.CollectibleType.BLANKET]: "Blanket",
    [isaac_typescript_definitions_1.CollectibleType.SACRIFICIAL_ALTAR]: "Sacrificial Altar",
    [isaac_typescript_definitions_1.CollectibleType.LIL_SPEWER]: "Lil Spewer",
    [isaac_typescript_definitions_1.CollectibleType.MARBLES]: "Marbles",
    [isaac_typescript_definitions_1.CollectibleType.MYSTERY_EGG]: "Mystery Egg",
    [isaac_typescript_definitions_1.CollectibleType.FLAT_STONE]: "Flat Stone",
    [isaac_typescript_definitions_1.CollectibleType.MARROW]: "Marrow",
    [isaac_typescript_definitions_1.CollectibleType.SLIPPED_RIB]: "Slipped Rib",
    [isaac_typescript_definitions_1.CollectibleType.HALLOWED_GROUND]: "Hallowed Ground",
    [isaac_typescript_definitions_1.CollectibleType.POINTY_RIB]: "Pointy Rib",
    [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_THE_DEAD]: "Book of the Dead",
    [isaac_typescript_definitions_1.CollectibleType.DADS_RING]: "Dad's Ring",
    [isaac_typescript_definitions_1.CollectibleType.DIVORCE_PAPERS]: "Divorce Papers",
    [isaac_typescript_definitions_1.CollectibleType.JAW_BONE]: "Jaw Bone",
    [isaac_typescript_definitions_1.CollectibleType.BRITTLE_BONES]: "Brittle Bones",
    [isaac_typescript_definitions_1.CollectibleType.BROKEN_SHOVEL_1]: "Broken Shovel",
    [isaac_typescript_definitions_1.CollectibleType.BROKEN_SHOVEL_2]: "Broken Shovel",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_SHOVEL]: "Mom's Shovel",
    [isaac_typescript_definitions_1.CollectibleType.MUCORMYCOSIS]: "Mucormycosis",
    [isaac_typescript_definitions_1.CollectibleType.TWO_SPOOKY]: "2Spooky",
    [isaac_typescript_definitions_1.CollectibleType.GOLDEN_RAZOR]: "Golden Razor",
    [isaac_typescript_definitions_1.CollectibleType.SULFUR]: "Sulfur",
    [isaac_typescript_definitions_1.CollectibleType.FORTUNE_COOKIE]: "Fortune Cookie",
    [isaac_typescript_definitions_1.CollectibleType.EYE_SORE]: "Eye Sore",
    [isaac_typescript_definitions_1.CollectibleType.ONE_HUNDRED_TWENTY_VOLT]: "120 Volt",
    [isaac_typescript_definitions_1.CollectibleType.IT_HURTS]: "It Hurts",
    [isaac_typescript_definitions_1.CollectibleType.ALMOND_MILK]: "Almond Milk",
    [isaac_typescript_definitions_1.CollectibleType.ROCK_BOTTOM]: "Rock Bottom",
    [isaac_typescript_definitions_1.CollectibleType.NANCY_BOMBS]: "Nancy Bombs",
    [isaac_typescript_definitions_1.CollectibleType.BAR_OF_SOAP]: "A Bar of Soap",
    [isaac_typescript_definitions_1.CollectibleType.BLOOD_PUPPY]: "Blood Puppy",
    [isaac_typescript_definitions_1.CollectibleType.DREAM_CATCHER]: "Dream Catcher",
    [isaac_typescript_definitions_1.CollectibleType.PASCHAL_CANDLE]: "Paschal Candle",
    [isaac_typescript_definitions_1.CollectibleType.DIVINE_INTERVENTION]: "Divine Intervention",
    [isaac_typescript_definitions_1.CollectibleType.BLOOD_OATH]: "Blood Oath",
    [isaac_typescript_definitions_1.CollectibleType.PLAYDOUGH_COOKIE]: "Playdough Cookie",
    [isaac_typescript_definitions_1.CollectibleType.ORPHAN_SOCKS]: "Orphan Socks",
    [isaac_typescript_definitions_1.CollectibleType.EYE_OF_THE_OCCULT]: "Eye of the Occult",
    [isaac_typescript_definitions_1.CollectibleType.IMMACULATE_HEART]: "Immaculate Heart",
    [isaac_typescript_definitions_1.CollectibleType.MONSTRANCE]: "Monstrance",
    [isaac_typescript_definitions_1.CollectibleType.INTRUDER]: "The Intruder",
    [isaac_typescript_definitions_1.CollectibleType.DIRTY_MIND]: "Dirty Mind",
    [isaac_typescript_definitions_1.CollectibleType.DAMOCLES]: "Damocles",
    [isaac_typescript_definitions_1.CollectibleType.FREE_LEMONADE]: "Free Lemonade",
    [isaac_typescript_definitions_1.CollectibleType.SPIRIT_SWORD]: "Spirit Sword",
    [isaac_typescript_definitions_1.CollectibleType.RED_KEY]: "Red Key",
    [isaac_typescript_definitions_1.CollectibleType.PSY_FLY]: "Psy Fly",
    [isaac_typescript_definitions_1.CollectibleType.WAVY_CAP]: "Wavy Cap",
    [isaac_typescript_definitions_1.CollectibleType.ROCKET_IN_A_JAR]: "Rocket in a Jar",
    [isaac_typescript_definitions_1.CollectibleType.BOOK_OF_VIRTUES]: "Book of Virtues",
    [isaac_typescript_definitions_1.CollectibleType.ALABASTER_BOX]: "Alabaster Box",
    [isaac_typescript_definitions_1.CollectibleType.STAIRWAY]: "The Stairway",
    // There is no `CollectibleType` with a value of 587.
    [isaac_typescript_definitions_1.CollectibleType.SOL]: "Sol",
    [isaac_typescript_definitions_1.CollectibleType.LUNA]: "Luna",
    [isaac_typescript_definitions_1.CollectibleType.MERCURIUS]: "Mercurius",
    [isaac_typescript_definitions_1.CollectibleType.VENUS]: "Venus",
    [isaac_typescript_definitions_1.CollectibleType.TERRA]: "Terra",
    [isaac_typescript_definitions_1.CollectibleType.MARS]: "Mars",
    [isaac_typescript_definitions_1.CollectibleType.JUPITER]: "Jupiter",
    [isaac_typescript_definitions_1.CollectibleType.SATURNUS]: "Saturnus",
    [isaac_typescript_definitions_1.CollectibleType.URANUS]: "Uranus",
    [isaac_typescript_definitions_1.CollectibleType.NEPTUNUS]: "Neptunus",
    [isaac_typescript_definitions_1.CollectibleType.PLUTO]: "Pluto",
    [isaac_typescript_definitions_1.CollectibleType.VOODOO_HEAD]: "Voodoo Head",
    [isaac_typescript_definitions_1.CollectibleType.EYE_DROPS]: "Eye Drops",
    [isaac_typescript_definitions_1.CollectibleType.ACT_OF_CONTRITION]: "Act of Contrition",
    [isaac_typescript_definitions_1.CollectibleType.MEMBER_CARD]: "Member Card",
    [isaac_typescript_definitions_1.CollectibleType.BATTERY_PACK]: "Battery Pack",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_BRACELET]: "Mom's Bracelet",
    [isaac_typescript_definitions_1.CollectibleType.SCOOPER]: "The Scooper",
    [isaac_typescript_definitions_1.CollectibleType.OCULAR_RIFT]: "Ocular Rift",
    [isaac_typescript_definitions_1.CollectibleType.BOILED_BABY]: "Boiled Baby",
    [isaac_typescript_definitions_1.CollectibleType.FREEZER_BABY]: "Freezer Baby",
    [isaac_typescript_definitions_1.CollectibleType.ETERNAL_D6]: "Eternal D6",
    [isaac_typescript_definitions_1.CollectibleType.BIRD_CAGE]: "Bird Cage",
    [isaac_typescript_definitions_1.CollectibleType.LARYNX]: "Larynx",
    [isaac_typescript_definitions_1.CollectibleType.LOST_SOUL]: "Lost Soul",
    // There is no `CollectibleType` with a value of 613.
    [isaac_typescript_definitions_1.CollectibleType.BLOOD_BOMBS]: "Blood Bombs",
    [isaac_typescript_definitions_1.CollectibleType.LIL_DUMPY]: "Lil Dumpy",
    [isaac_typescript_definitions_1.CollectibleType.BIRDS_EYE]: "Bird's Eye",
    [isaac_typescript_definitions_1.CollectibleType.LODESTONE]: "Lodestone",
    [isaac_typescript_definitions_1.CollectibleType.ROTTEN_TOMATO]: "Rotten Tomato",
    [isaac_typescript_definitions_1.CollectibleType.BIRTHRIGHT]: "Birthright",
    // There is no `CollectibleType` with a value of 620.
    [isaac_typescript_definitions_1.CollectibleType.RED_STEW]: "Red Stew",
    [isaac_typescript_definitions_1.CollectibleType.GENESIS]: "Genesis",
    [isaac_typescript_definitions_1.CollectibleType.SHARP_KEY]: "Sharp Key",
    [isaac_typescript_definitions_1.CollectibleType.BOOSTER_PACK]: "Booster Pack",
    [isaac_typescript_definitions_1.CollectibleType.MEGA_MUSH]: "Mega Mush",
    [isaac_typescript_definitions_1.CollectibleType.KNIFE_PIECE_1]: "Knife Piece 1",
    [isaac_typescript_definitions_1.CollectibleType.KNIFE_PIECE_2]: "Knife Piece 2",
    [isaac_typescript_definitions_1.CollectibleType.DEATH_CERTIFICATE]: "Death Certificate",
    [isaac_typescript_definitions_1.CollectibleType.BOT_FLY]: "Bot Fly",
    // There is no `CollectibleType` with a value of 630.
    [isaac_typescript_definitions_1.CollectibleType.MEAT_CLEAVER]: "Meat Cleaver",
    [isaac_typescript_definitions_1.CollectibleType.EVIL_CHARM]: "Evil Charm",
    [isaac_typescript_definitions_1.CollectibleType.DOGMA]: "Dogma",
    [isaac_typescript_definitions_1.CollectibleType.PURGATORY]: "Purgatory",
    [isaac_typescript_definitions_1.CollectibleType.STITCHES]: "Stitches",
    [isaac_typescript_definitions_1.CollectibleType.R_KEY]: "R Key",
    [isaac_typescript_definitions_1.CollectibleType.KNOCKOUT_DROPS]: "Knockout Drops",
    [isaac_typescript_definitions_1.CollectibleType.ERASER]: "Eraser",
    [isaac_typescript_definitions_1.CollectibleType.YUCK_HEART]: "Yuck Heart",
    [isaac_typescript_definitions_1.CollectibleType.URN_OF_SOULS]: "Urn of Souls",
    [isaac_typescript_definitions_1.CollectibleType.AKELDAMA]: "Akeldama",
    [isaac_typescript_definitions_1.CollectibleType.MAGIC_SKIN]: "Magic Skin",
    [isaac_typescript_definitions_1.CollectibleType.REVELATION]: "Revelation",
    [isaac_typescript_definitions_1.CollectibleType.CONSOLATION_PRIZE]: "Consolation Prize",
    [isaac_typescript_definitions_1.CollectibleType.TINYTOMA]: "Tinytoma",
    [isaac_typescript_definitions_1.CollectibleType.BRIMSTONE_BOMBS]: "Brimstone Bombs",
    [isaac_typescript_definitions_1.CollectibleType.FOUR_FIVE_VOLT]: "4.5 Volt",
    // There is no `CollectibleType` with a value of 648.
    [isaac_typescript_definitions_1.CollectibleType.FRUITY_PLUM]: "Fruity Plum",
    [isaac_typescript_definitions_1.CollectibleType.PLUM_FLUTE]: "Plum Flute",
    [isaac_typescript_definitions_1.CollectibleType.STAR_OF_BETHLEHEM]: "Star of Bethlehem",
    [isaac_typescript_definitions_1.CollectibleType.CUBE_BABY]: "Cube Baby",
    [isaac_typescript_definitions_1.CollectibleType.VADE_RETRO]: "Vade Retro",
    [isaac_typescript_definitions_1.CollectibleType.FALSE_PHD]: "False PHD",
    [isaac_typescript_definitions_1.CollectibleType.SPIN_TO_WIN]: "Spin to Win",
    [isaac_typescript_definitions_1.CollectibleType.DAMOCLES_PASSIVE]: "Damocles (Passive)",
    [isaac_typescript_definitions_1.CollectibleType.VASCULITIS]: "Vasculitis",
    [isaac_typescript_definitions_1.CollectibleType.GIANT_CELL]: "Giant Cell",
    [isaac_typescript_definitions_1.CollectibleType.TROPICAMIDE]: "Tropicamide",
    [isaac_typescript_definitions_1.CollectibleType.CARD_READING]: "Card Reading",
    [isaac_typescript_definitions_1.CollectibleType.QUINTS]: "Quints",
    // There is no `CollectibleType` with a value of 662.
    [isaac_typescript_definitions_1.CollectibleType.TOOTH_AND_NAIL]: "Tooth and Nail",
    [isaac_typescript_definitions_1.CollectibleType.BINGE_EATER]: "Binge Eater",
    [isaac_typescript_definitions_1.CollectibleType.GUPPYS_EYE]: "Guppy's Eye",
    // There is no `CollectibleType` with a value of 666.
    [isaac_typescript_definitions_1.CollectibleType.STRAWMAN]: "Strawman",
    [isaac_typescript_definitions_1.CollectibleType.DADS_NOTE]: "Dad's Note",
    [isaac_typescript_definitions_1.CollectibleType.SAUSAGE]: "Sausage",
    [isaac_typescript_definitions_1.CollectibleType.OPTIONS]: "Options?",
    [isaac_typescript_definitions_1.CollectibleType.CANDY_HEART]: "Candy Heart",
    [isaac_typescript_definitions_1.CollectibleType.POUND_OF_FLESH]: "A Pound of Flesh",
    [isaac_typescript_definitions_1.CollectibleType.REDEMPTION]: "Redemption",
    [isaac_typescript_definitions_1.CollectibleType.SPIRIT_SHACKLES]: "Spirit Shackles",
    [isaac_typescript_definitions_1.CollectibleType.CRACKED_ORB]: "Cracked Orb",
    [isaac_typescript_definitions_1.CollectibleType.EMPTY_HEART]: "Empty Heart",
    [isaac_typescript_definitions_1.CollectibleType.ASTRAL_PROJECTION]: "Astral Projection",
    [isaac_typescript_definitions_1.CollectibleType.C_SECTION]: "C Section",
    [isaac_typescript_definitions_1.CollectibleType.LIL_ABADDON]: "Lil Abaddon",
    [isaac_typescript_definitions_1.CollectibleType.MONTEZUMAS_REVENGE]: "Montezuma's Revenge",
    [isaac_typescript_definitions_1.CollectibleType.LIL_PORTAL]: "Lil Portal",
    [isaac_typescript_definitions_1.CollectibleType.WORM_FRIEND]: "Worm Friend",
    [isaac_typescript_definitions_1.CollectibleType.BONE_SPURS]: "Bone Spurs",
    [isaac_typescript_definitions_1.CollectibleType.HUNGRY_SOUL]: "Hungry Soul",
    [isaac_typescript_definitions_1.CollectibleType.JAR_OF_WISPS]: "Jar of Wisps",
    [isaac_typescript_definitions_1.CollectibleType.SOUL_LOCKET]: "Soul Locket",
    [isaac_typescript_definitions_1.CollectibleType.FRIEND_FINDER]: "Friend Finder",
    [isaac_typescript_definitions_1.CollectibleType.INNER_CHILD]: "Inner Child",
    [isaac_typescript_definitions_1.CollectibleType.GLITCHED_CROWN]: "Glitched Crown",
    [isaac_typescript_definitions_1.CollectibleType.JELLY_BELLY]: "Belly Jelly",
    [isaac_typescript_definitions_1.CollectibleType.SACRED_ORB]: "Sacred Orb",
    [isaac_typescript_definitions_1.CollectibleType.SANGUINE_BOND]: "Sanguine Bond",
    [isaac_typescript_definitions_1.CollectibleType.SWARM]: "The Swarm",
    [isaac_typescript_definitions_1.CollectibleType.HEARTBREAK]: "Heartbreak",
    [isaac_typescript_definitions_1.CollectibleType.BLOODY_GUST]: "Bloody Gust",
    [isaac_typescript_definitions_1.CollectibleType.SALVATION]: "Salvation",
    [isaac_typescript_definitions_1.CollectibleType.VANISHING_TWIN]: "Vanishing Twin",
    [isaac_typescript_definitions_1.CollectibleType.TWISTED_PAIR]: "Twisted Pair",
    [isaac_typescript_definitions_1.CollectibleType.AZAZELS_RAGE]: "Azazel's Rage",
    [isaac_typescript_definitions_1.CollectibleType.ECHO_CHAMBER]: "Echo Chamber",
    [isaac_typescript_definitions_1.CollectibleType.ISAACS_TOMB]: "Isaac's Tomb",
    [isaac_typescript_definitions_1.CollectibleType.VENGEFUL_SPIRIT]: "Vengeful Spirit",
    [isaac_typescript_definitions_1.CollectibleType.ESAU_JR]: "Esau Jr.",
    [isaac_typescript_definitions_1.CollectibleType.BERSERK]: "Berserk!",
    [isaac_typescript_definitions_1.CollectibleType.DARK_ARTS]: "Dark Arts",
    [isaac_typescript_definitions_1.CollectibleType.ABYSS]: "Abyss",
    [isaac_typescript_definitions_1.CollectibleType.SUPPER]: "Supper",
    [isaac_typescript_definitions_1.CollectibleType.STAPLER]: "Stapler",
    [isaac_typescript_definitions_1.CollectibleType.SUPLEX]: "Suplex!",
    [isaac_typescript_definitions_1.CollectibleType.BAG_OF_CRAFTING]: "Bag of Crafting",
    [isaac_typescript_definitions_1.CollectibleType.FLIP]: "Flip",
    [isaac_typescript_definitions_1.CollectibleType.LEMEGETON]: "Lemegeton",
    [isaac_typescript_definitions_1.CollectibleType.SUMPTORIUM]: "Sumptorium",
    [isaac_typescript_definitions_1.CollectibleType.RECALL]: "Recall",
    [isaac_typescript_definitions_1.CollectibleType.HOLD]: "Hold",
    [isaac_typescript_definitions_1.CollectibleType.KEEPERS_SACK]: "Keeper's Sack",
    [isaac_typescript_definitions_1.CollectibleType.KEEPERS_KIN]: "Keeper's Kin",
    // There is no `CollectibleType` with a value of 718.
    [isaac_typescript_definitions_1.CollectibleType.KEEPERS_BOX]: "Keeper's Box",
    [isaac_typescript_definitions_1.CollectibleType.EVERYTHING_JAR]: "Everything Jar",
    [isaac_typescript_definitions_1.CollectibleType.TMTRAINER]: "TMTRAINER",
    [isaac_typescript_definitions_1.CollectibleType.ANIMA_SOLA]: "Anima Sola",
    [isaac_typescript_definitions_1.CollectibleType.SPINDOWN_DICE]: "Spindown Dice",
    [isaac_typescript_definitions_1.CollectibleType.HYPERCOAGULATION]: "Hypercoagulation",
    [isaac_typescript_definitions_1.CollectibleType.IBS]: "IBS",
    [isaac_typescript_definitions_1.CollectibleType.HEMOPTYSIS]: "Hemoptysis",
    [isaac_typescript_definitions_1.CollectibleType.GHOST_BOMBS]: "Ghost Bombs",
    [isaac_typescript_definitions_1.CollectibleType.GELLO]: "Gello",
    [isaac_typescript_definitions_1.CollectibleType.DECAP_ATTACK]: "Decap Attack",
    [isaac_typescript_definitions_1.CollectibleType.GLASS_EYE]: "Glass Eye",
    [isaac_typescript_definitions_1.CollectibleType.STYE]: "Stye",
    [isaac_typescript_definitions_1.CollectibleType.MOMS_RING]: "Mom's Ring", // 732
};
