"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ROOM_SHAPE_BOUNDS = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const roomShapeVolumes_1 = require("./roomShapeVolumes");
const TWO_BY_TWO_BOUNDS = [
    roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_WIDTH * 2,
    roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_HEIGHT * 2,
];
/**
 * The size of a room shape's contents. This does not include the tiles that the walls are on. L
 * rooms use the same bounds as a 2x2 room.
 */
exports.ROOM_SHAPE_BOUNDS = {
    // 1
    [isaac_typescript_definitions_1.RoomShape.SHAPE_1x1]: [
        roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_WIDTH,
        roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_HEIGHT,
    ],
    // 2
    [isaac_typescript_definitions_1.RoomShape.IH]: [roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_WIDTH, roomShapeVolumes_1.NARROW_CONTENTS_HEIGHT],
    // 3
    [isaac_typescript_definitions_1.RoomShape.IV]: [roomShapeVolumes_1.NARROW_CONTENTS_WIDTH, roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_HEIGHT],
    // 4
    [isaac_typescript_definitions_1.RoomShape.SHAPE_1x2]: [
        roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_WIDTH,
        roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_HEIGHT * 2,
    ],
    // 5
    [isaac_typescript_definitions_1.RoomShape.IIV]: [roomShapeVolumes_1.NARROW_CONTENTS_WIDTH, roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_HEIGHT * 2],
    // 6
    [isaac_typescript_definitions_1.RoomShape.SHAPE_2x1]: [
        roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_WIDTH * 2,
        roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_HEIGHT,
    ],
    // 7
    [isaac_typescript_definitions_1.RoomShape.IIH]: [roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_WIDTH * 2, roomShapeVolumes_1.NARROW_CONTENTS_HEIGHT],
    // 8
    [isaac_typescript_definitions_1.RoomShape.SHAPE_2x2]: TWO_BY_TWO_BOUNDS,
    // 9
    [isaac_typescript_definitions_1.RoomShape.LTL]: TWO_BY_TWO_BOUNDS,
    // 10
    [isaac_typescript_definitions_1.RoomShape.LTR]: TWO_BY_TWO_BOUNDS,
    // 11
    [isaac_typescript_definitions_1.RoomShape.LBL]: TWO_BY_TWO_BOUNDS,
    // 12
    [isaac_typescript_definitions_1.RoomShape.LBR]: TWO_BY_TWO_BOUNDS,
};
