"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ROOM_SHAPE_LAYOUT_SIZES = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const roomShapeVolumes_1 = require("./roomShapeVolumes");
const ONE_BY_ONE_LAYOUT_SIZE = [
    roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_WIDTH,
    roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_HEIGHT,
];
const TWO_BY_ONE_VERTICAL_LAYOUT_SIZE = [
    roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_WIDTH,
    roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_HEIGHT * 2,
];
const TWO_BY_ONE_HORIZONTAL_LAYOUT_SIZE = [
    roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_WIDTH * 2,
    roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_HEIGHT,
];
const TWO_BY_TWO_LAYOUT_SIZE = [
    roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_WIDTH * 2,
    roomShapeVolumes_1.ONE_BY_ONE_CONTENTS_HEIGHT * 2,
];
/**
 * The dimensions of a room shape's layout. This is NOT the size of the room's actual contents! For
 * that, use `ROOM_SHAPE_BOUNDS`.
 *
 * For example, a horizontal narrow room has a layout size of equal to that of a 1x1 room.
 */
exports.ROOM_SHAPE_LAYOUT_SIZES = {
    [isaac_typescript_definitions_1.RoomShape.SHAPE_1x1]: ONE_BY_ONE_LAYOUT_SIZE,
    [isaac_typescript_definitions_1.RoomShape.IH]: ONE_BY_ONE_LAYOUT_SIZE,
    [isaac_typescript_definitions_1.RoomShape.IV]: ONE_BY_ONE_LAYOUT_SIZE,
    [isaac_typescript_definitions_1.RoomShape.SHAPE_1x2]: TWO_BY_ONE_VERTICAL_LAYOUT_SIZE,
    [isaac_typescript_definitions_1.RoomShape.IIV]: TWO_BY_ONE_VERTICAL_LAYOUT_SIZE,
    [isaac_typescript_definitions_1.RoomShape.SHAPE_2x1]: TWO_BY_ONE_HORIZONTAL_LAYOUT_SIZE,
    [isaac_typescript_definitions_1.RoomShape.IIH]: TWO_BY_ONE_HORIZONTAL_LAYOUT_SIZE,
    [isaac_typescript_definitions_1.RoomShape.SHAPE_2x2]: TWO_BY_TWO_LAYOUT_SIZE,
    [isaac_typescript_definitions_1.RoomShape.LTL]: TWO_BY_TWO_LAYOUT_SIZE,
    [isaac_typescript_definitions_1.RoomShape.LTR]: TWO_BY_TWO_LAYOUT_SIZE,
    [isaac_typescript_definitions_1.RoomShape.LBL]: TWO_BY_TWO_LAYOUT_SIZE,
    [isaac_typescript_definitions_1.RoomShape.LBR]: TWO_BY_TWO_LAYOUT_SIZE, // 12
};
