"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ROOM_SHAPE_TO_BOTTOM_RIGHT_POSITION = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const readOnly_1 = require("../functions/readOnly");
const TWO_BY_TWO_BOTTOM_RIGHT_POSITION = (0, readOnly_1.newReadonlyVector)(25, 13);
const ONE_BY_TWO_VERTICAL_BOTTOM_RIGHT_POSITION = (0, readOnly_1.newReadonlyVector)(12, 13);
/**
 * "Vector(0, 0)" corresponds to the top left tile of a room, not including the walls. (The top-left
 * wall would be at "Vector(-1, -1)".)
 */
exports.ROOM_SHAPE_TO_BOTTOM_RIGHT_POSITION = {
    [isaac_typescript_definitions_1.RoomShape.SHAPE_1x1]: (0, readOnly_1.newReadonlyVector)(12, 6),
    [isaac_typescript_definitions_1.RoomShape.IH]: (0, readOnly_1.newReadonlyVector)(12, 4),
    [isaac_typescript_definitions_1.RoomShape.IV]: (0, readOnly_1.newReadonlyVector)(8, 6),
    [isaac_typescript_definitions_1.RoomShape.SHAPE_1x2]: ONE_BY_TWO_VERTICAL_BOTTOM_RIGHT_POSITION,
    [isaac_typescript_definitions_1.RoomShape.IIV]: (0, readOnly_1.newReadonlyVector)(8, 13),
    [isaac_typescript_definitions_1.RoomShape.SHAPE_2x1]: (0, readOnly_1.newReadonlyVector)(25, 6),
    [isaac_typescript_definitions_1.RoomShape.IIH]: (0, readOnly_1.newReadonlyVector)(25, 4),
    [isaac_typescript_definitions_1.RoomShape.SHAPE_2x2]: TWO_BY_TWO_BOTTOM_RIGHT_POSITION,
    [isaac_typescript_definitions_1.RoomShape.LTL]: TWO_BY_TWO_BOTTOM_RIGHT_POSITION,
    [isaac_typescript_definitions_1.RoomShape.LTR]: TWO_BY_TWO_BOTTOM_RIGHT_POSITION,
    [isaac_typescript_definitions_1.RoomShape.LBL]: TWO_BY_TWO_BOTTOM_RIGHT_POSITION,
    [isaac_typescript_definitions_1.RoomShape.LBR]: ONE_BY_TWO_VERTICAL_BOTTOM_RIGHT_POSITION, // 12
};
