"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.STAGE_TO_MUSIC = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const BASEMENT_TO_MUSIC = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.Music.BASEMENT,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.Music.CELLAR,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.Music.BURNING_BASEMENT,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.Music.BASEMENT,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.Music.DOWNPOUR,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.Music.DROSS, // 5
};
const CAVES_TO_MUSIC = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.Music.CAVES,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.Music.CATACOMBS,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.Music.FLOODED_CAVES,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.Music.CAVES,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.Music.MINES,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.Music.ASHPIT, // 5
};
const DEPTHS_TO_MUSIC = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.Music.DEPTHS,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.Music.NECROPOLIS,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.Music.DANK_DEPTHS,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.Music.DEPTHS,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.Music.MAUSOLEUM,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.Music.GEHENNA, // 5
};
const WOMB_TO_MUSIC = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.Music.WOMB,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.Music.UTERO,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.Music.SCARRED_WOMB,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.Music.WOMB,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.Music.CORPSE,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.Music.MORTIS, // 5
};
const BLUE_WOMB_TO_MUSIC = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.Music.BLUE_WOMB,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.Music.BLUE_WOMB,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.Music.BLUE_WOMB,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.Music.BLUE_WOMB,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.Music.BLUE_WOMB,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.Music.BLUE_WOMB, // 5
};
const SHEOL_CATHEDRAL_TO_MUSIC = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.Music.SHEOL,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.Music.CATHEDRAL,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.Music.SHEOL,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.Music.SHEOL,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.Music.SHEOL,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.Music.SHEOL, // 5
};
const DARK_ROOM_CHEST_TO_MUSIC = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.Music.DARK_ROOM,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.Music.CHEST,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.Music.DARK_ROOM,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.Music.DARK_ROOM,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.Music.DARK_ROOM,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.Music.DARK_ROOM, // 5
};
const VOID_TO_MUSIC = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.Music.VOID,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.Music.VOID,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.Music.VOID,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.Music.VOID,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.Music.VOID,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.Music.VOID, // 5
};
const HOME_TO_MUSIC = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.Music.ISAACS_HOUSE,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.Music.ISAACS_HOUSE,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.Music.ISAACS_HOUSE,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.Music.ISAACS_HOUSE,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.Music.ISAACS_HOUSE,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.Music.ISAACS_HOUSE, // 5
};
exports.STAGE_TO_MUSIC = {
    [isaac_typescript_definitions_1.LevelStage.BASEMENT_1]: BASEMENT_TO_MUSIC,
    [isaac_typescript_definitions_1.LevelStage.BASEMENT_2]: BASEMENT_TO_MUSIC,
    [isaac_typescript_definitions_1.LevelStage.CAVES_1]: CAVES_TO_MUSIC,
    [isaac_typescript_definitions_1.LevelStage.CAVES_2]: CAVES_TO_MUSIC,
    [isaac_typescript_definitions_1.LevelStage.DEPTHS_1]: DEPTHS_TO_MUSIC,
    [isaac_typescript_definitions_1.LevelStage.DEPTHS_2]: DEPTHS_TO_MUSIC,
    [isaac_typescript_definitions_1.LevelStage.WOMB_1]: WOMB_TO_MUSIC,
    [isaac_typescript_definitions_1.LevelStage.WOMB_2]: WOMB_TO_MUSIC,
    [isaac_typescript_definitions_1.LevelStage.BLUE_WOMB]: BLUE_WOMB_TO_MUSIC,
    [isaac_typescript_definitions_1.LevelStage.SHEOL_CATHEDRAL]: SHEOL_CATHEDRAL_TO_MUSIC,
    [isaac_typescript_definitions_1.LevelStage.DARK_ROOM_CHEST]: DARK_ROOM_CHEST_TO_MUSIC,
    [isaac_typescript_definitions_1.LevelStage.VOID]: VOID_TO_MUSIC,
    [isaac_typescript_definitions_1.LevelStage.HOME]: HOME_TO_MUSIC, // 13
};
