"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.STAGE_TO_STAGE_ID_GREED_MODE = exports.STAGE_TO_STAGE_ID = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const ReadonlyMap_1 = require("../types/ReadonlyMap");
const BASEMENT_TO_STAGE_ID = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.StageID.BASEMENT,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.StageID.CELLAR,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.StageID.BURNING_BASEMENT,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.StageID.BASEMENT,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.StageID.DOWNPOUR,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.StageID.DROSS, // 5
};
const CAVES_TO_STAGE_ID = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.StageID.CAVES,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.StageID.CATACOMBS,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.StageID.FLOODED_CAVES,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.StageID.CAVES,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.StageID.MINES,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.StageID.ASHPIT, // 5
};
const DEPTHS_TO_STAGE_ID = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.StageID.DEPTHS,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.StageID.NECROPOLIS,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.StageID.DANK_DEPTHS,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.StageID.DEPTHS,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.StageID.MAUSOLEUM,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.StageID.GEHENNA, // 5
};
const WOMB_TO_STAGE_ID = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.StageID.WOMB,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.StageID.UTERO,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.StageID.SCARRED_WOMB,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.StageID.WOMB,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.StageID.CORPSE,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.StageID.MORTIS, // 5
};
const BLUE_WOMB_TO_STAGE_ID = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.StageID.BLUE_WOMB,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.StageID.BLUE_WOMB,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.StageID.BLUE_WOMB,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.StageID.BLUE_WOMB,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.StageID.BLUE_WOMB,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.StageID.BLUE_WOMB, // 5
};
const SHEOL_CATHEDRAL_TO_STAGE_ID = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.StageID.SHEOL,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.StageID.CATHEDRAL,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.StageID.SHEOL,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.StageID.SHEOL,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.StageID.SHEOL,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.StageID.SHEOL, // 5
};
const DARK_ROOM_CHEST_TO_STAGE_ID = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.StageID.DARK_ROOM,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.StageID.CHEST,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.StageID.DARK_ROOM,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.StageID.DARK_ROOM,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.StageID.DARK_ROOM,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.StageID.DARK_ROOM, // 5
};
const VOID_TO_STAGE_ID = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.StageID.VOID,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.StageID.VOID,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.StageID.VOID,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.StageID.VOID,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.StageID.VOID,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.StageID.VOID, // 5
};
const HOME_TO_STAGE_ID = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.StageID.HOME,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.StageID.HOME,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.StageID.HOME,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.StageID.HOME,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.StageID.HOME,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.StageID.HOME, // 5
};
exports.STAGE_TO_STAGE_ID = {
    [isaac_typescript_definitions_1.LevelStage.BASEMENT_1]: BASEMENT_TO_STAGE_ID,
    [isaac_typescript_definitions_1.LevelStage.BASEMENT_2]: BASEMENT_TO_STAGE_ID,
    [isaac_typescript_definitions_1.LevelStage.CAVES_1]: CAVES_TO_STAGE_ID,
    [isaac_typescript_definitions_1.LevelStage.CAVES_2]: CAVES_TO_STAGE_ID,
    [isaac_typescript_definitions_1.LevelStage.DEPTHS_1]: DEPTHS_TO_STAGE_ID,
    [isaac_typescript_definitions_1.LevelStage.DEPTHS_2]: DEPTHS_TO_STAGE_ID,
    [isaac_typescript_definitions_1.LevelStage.WOMB_1]: WOMB_TO_STAGE_ID,
    [isaac_typescript_definitions_1.LevelStage.WOMB_2]: WOMB_TO_STAGE_ID,
    [isaac_typescript_definitions_1.LevelStage.BLUE_WOMB]: BLUE_WOMB_TO_STAGE_ID,
    [isaac_typescript_definitions_1.LevelStage.SHEOL_CATHEDRAL]: SHEOL_CATHEDRAL_TO_STAGE_ID,
    [isaac_typescript_definitions_1.LevelStage.DARK_ROOM_CHEST]: DARK_ROOM_CHEST_TO_STAGE_ID,
    [isaac_typescript_definitions_1.LevelStage.VOID]: VOID_TO_STAGE_ID,
    [isaac_typescript_definitions_1.LevelStage.HOME]: HOME_TO_STAGE_ID, // 13
};
const SHOP_TO_STAGE_ID = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.StageID.SHOP,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.StageID.SHOP,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.StageID.SHOP,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.StageID.SHOP,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.StageID.SHOP,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.StageID.SHOP, // 5
};
const ULTRA_GREED_TO_STAGE_ID = {
    [isaac_typescript_definitions_1.StageType.ORIGINAL]: isaac_typescript_definitions_1.StageID.ULTRA_GREED,
    [isaac_typescript_definitions_1.StageType.WRATH_OF_THE_LAMB]: isaac_typescript_definitions_1.StageID.ULTRA_GREED,
    [isaac_typescript_definitions_1.StageType.AFTERBIRTH]: isaac_typescript_definitions_1.StageID.ULTRA_GREED,
    [isaac_typescript_definitions_1.StageType.GREED_MODE]: isaac_typescript_definitions_1.StageID.ULTRA_GREED,
    [isaac_typescript_definitions_1.StageType.REPENTANCE]: isaac_typescript_definitions_1.StageID.ULTRA_GREED,
    [isaac_typescript_definitions_1.StageType.REPENTANCE_B]: isaac_typescript_definitions_1.StageID.ULTRA_GREED, // 5
};
exports.STAGE_TO_STAGE_ID_GREED_MODE = new ReadonlyMap_1.ReadonlyMap([
    [isaac_typescript_definitions_1.LevelStage.BASEMENT_GREED_MODE, BASEMENT_TO_STAGE_ID],
    [isaac_typescript_definitions_1.LevelStage.CAVES_GREED_MODE, CAVES_TO_STAGE_ID],
    [isaac_typescript_definitions_1.LevelStage.DEPTHS_GREED_MODE, DEPTHS_TO_STAGE_ID],
    [isaac_typescript_definitions_1.LevelStage.WOMB_GREED_MODE, WOMB_TO_STAGE_ID],
    [isaac_typescript_definitions_1.LevelStage.SHEOL_GREED_MODE, SHEOL_CATHEDRAL_TO_STAGE_ID],
    [isaac_typescript_definitions_1.LevelStage.SHOP_GREED_MODE, SHOP_TO_STAGE_ID],
    [isaac_typescript_definitions_1.LevelStage.ULTRA_GREED_GREED_MODE, ULTRA_GREED_TO_STAGE_ID], // 7
]);
