"use strict";
/* cspell:disable */
Object.defineProperty(exports, "__esModule", { value: true });
exports.TRINKET_DESCRIPTIONS = exports.DEFAULT_TRINKET_DESCRIPTION = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
exports.DEFAULT_TRINKET_DESCRIPTION = "Unknown";
/** Maps trinket types to the real English descriptions from the "stringtable.sta" file. */
exports.TRINKET_DESCRIPTIONS = {
    [isaac_typescript_definitions_1.TrinketType.NULL]: exports.DEFAULT_TRINKET_DESCRIPTION,
    [isaac_typescript_definitions_1.TrinketType.SWALLOWED_PENNY]: "Gulp!",
    [isaac_typescript_definitions_1.TrinketType.PETRIFIED_POOP]: "It feels lucky?",
    [isaac_typescript_definitions_1.TrinketType.AAA_BATTERY]: "Trickle charge",
    [isaac_typescript_definitions_1.TrinketType.BROKEN_REMOTE]: "It's broken",
    [isaac_typescript_definitions_1.TrinketType.PURPLE_HEART]: "Challenge up",
    [isaac_typescript_definitions_1.TrinketType.BROKEN_MAGNET]: "It kinda works",
    [isaac_typescript_definitions_1.TrinketType.ROSARY_BEAD]: "Faith up",
    [isaac_typescript_definitions_1.TrinketType.CARTRIDGE]: "I remember these",
    [isaac_typescript_definitions_1.TrinketType.PULSE_WORM]: "Wub wub!",
    [isaac_typescript_definitions_1.TrinketType.WIGGLE_WORM]: "Wiggle waggle!",
    [isaac_typescript_definitions_1.TrinketType.RING_WORM]: "Woop woop!",
    [isaac_typescript_definitions_1.TrinketType.FLAT_WORM]: "Blub blub!",
    [isaac_typescript_definitions_1.TrinketType.STORE_CREDIT]: "YES!",
    [isaac_typescript_definitions_1.TrinketType.CALLUS]: "Your feet feel stronger",
    [isaac_typescript_definitions_1.TrinketType.LUCKY_ROCK]: "There's something inside it",
    [isaac_typescript_definitions_1.TrinketType.MOMS_TOENAIL]: "???",
    [isaac_typescript_definitions_1.TrinketType.BLACK_LIPSTICK]: "Evil up",
    [isaac_typescript_definitions_1.TrinketType.BIBLE_TRACT]: "Faith up",
    [isaac_typescript_definitions_1.TrinketType.PAPER_CLIP]: "Master of lockpicking",
    [isaac_typescript_definitions_1.TrinketType.MONKEY_PAW]: "Wish granted",
    [isaac_typescript_definitions_1.TrinketType.MYSTERIOUS_PAPER]: "???",
    [isaac_typescript_definitions_1.TrinketType.DAEMONS_TAIL]: "Evil up",
    [isaac_typescript_definitions_1.TrinketType.MISSING_POSTER]: "???",
    [isaac_typescript_definitions_1.TrinketType.BUTT_PENNY]: "Wealth of gas",
    [isaac_typescript_definitions_1.TrinketType.MYSTERIOUS_CANDY]: "Uh-oh!",
    [isaac_typescript_definitions_1.TrinketType.HOOK_WORM]: "Zip zoop!",
    [isaac_typescript_definitions_1.TrinketType.WHIP_WORM]: "Wooosh!",
    [isaac_typescript_definitions_1.TrinketType.BROKEN_ANKH]: "Eternal life?",
    [isaac_typescript_definitions_1.TrinketType.FISH_HEAD]: "It stinks",
    [isaac_typescript_definitions_1.TrinketType.PINKY_EYE]: "Poison shots",
    [isaac_typescript_definitions_1.TrinketType.PUSH_PIN]: "Piercing shots",
    [isaac_typescript_definitions_1.TrinketType.LIBERTY_CAP]: "Touch fuzzy, get dizzy",
    [isaac_typescript_definitions_1.TrinketType.UMBILICAL_CORD]: "Fetal protection",
    [isaac_typescript_definitions_1.TrinketType.CHILDS_HEART]: "It calls out to its brothers",
    [isaac_typescript_definitions_1.TrinketType.CURVED_HORN]: "DMG up",
    [isaac_typescript_definitions_1.TrinketType.RUSTED_KEY]: "It feels lucky?",
    [isaac_typescript_definitions_1.TrinketType.GOAT_HOOF]: "Speed up",
    [isaac_typescript_definitions_1.TrinketType.MOMS_PEARL]: "It emanates purity ",
    [isaac_typescript_definitions_1.TrinketType.CANCER]: "Yay, cancer!",
    [isaac_typescript_definitions_1.TrinketType.RED_PATCH]: "Your rage grows",
    [isaac_typescript_definitions_1.TrinketType.MATCH_STICK]: "Tastes like burning",
    [isaac_typescript_definitions_1.TrinketType.LUCKY_TOE]: "Luck up!",
    [isaac_typescript_definitions_1.TrinketType.CURSED_SKULL]: "Cursed?",
    [isaac_typescript_definitions_1.TrinketType.SAFETY_CAP]: "Don't swallow it",
    [isaac_typescript_definitions_1.TrinketType.ACE_OF_SPADES]: "Luck of the draw",
    [isaac_typescript_definitions_1.TrinketType.ISAACS_FORK]: "Consume thy enemy",
    // There is no `TrinketType` with a value of 47.
    [isaac_typescript_definitions_1.TrinketType.MISSING_PAGE]: "It glows with power",
    [isaac_typescript_definitions_1.TrinketType.BLOODY_PENNY]: "Wealth of health",
    [isaac_typescript_definitions_1.TrinketType.BURNT_PENNY]: "Wealth of chaos",
    [isaac_typescript_definitions_1.TrinketType.FLAT_PENNY]: "Wealth of answers",
    [isaac_typescript_definitions_1.TrinketType.COUNTERFEIT_PENNY]: "Wealth of wealth",
    [isaac_typescript_definitions_1.TrinketType.TICK]: "Well, that's not coming off",
    [isaac_typescript_definitions_1.TrinketType.ISAACS_HEAD]: "Dead friend",
    [isaac_typescript_definitions_1.TrinketType.MAGGYS_FAITH]: "Faith's reward",
    [isaac_typescript_definitions_1.TrinketType.JUDAS_TONGUE]: "Payment received ",
    [isaac_typescript_definitions_1.TrinketType.BLUE_BABYS_SOUL]: "Imaginary friend",
    [isaac_typescript_definitions_1.TrinketType.SAMSONS_LOCK]: "Your rage grows",
    [isaac_typescript_definitions_1.TrinketType.CAINS_EYE]: "May you see your destination",
    [isaac_typescript_definitions_1.TrinketType.EVES_BIRD_FOOT]: "Revenge from beyond",
    [isaac_typescript_definitions_1.TrinketType.LEFT_HAND]: "The left-hand path reaps dark rewards",
    [isaac_typescript_definitions_1.TrinketType.SHINY_ROCK]: "It shines for its brothers",
    [isaac_typescript_definitions_1.TrinketType.SAFETY_SCISSORS]: "Fuse cutter",
    [isaac_typescript_definitions_1.TrinketType.RAINBOW_WORM]: "Bleep bloop blop",
    [isaac_typescript_definitions_1.TrinketType.TAPE_WORM]: "Floooooooooop!",
    [isaac_typescript_definitions_1.TrinketType.LAZY_WORM]: "Pft",
    [isaac_typescript_definitions_1.TrinketType.CRACKED_DICE]: "You feel cursed... kinda.",
    [isaac_typescript_definitions_1.TrinketType.SUPER_MAGNET]: "It pulls",
    [isaac_typescript_definitions_1.TrinketType.FADED_POLAROID]: "You feel faded",
    [isaac_typescript_definitions_1.TrinketType.LOUSE]: "Itchy, tasty...",
    [isaac_typescript_definitions_1.TrinketType.BOBS_BLADDER]: "Creepy bombs",
    [isaac_typescript_definitions_1.TrinketType.WATCH_BATTERY]: "Lil charge",
    [isaac_typescript_definitions_1.TrinketType.BLASTING_CAP]: "Pop! Pop!",
    [isaac_typescript_definitions_1.TrinketType.STUD_FINDER]: "The ground below feels hollow...",
    [isaac_typescript_definitions_1.TrinketType.ERROR]: "Effect not found?",
    [isaac_typescript_definitions_1.TrinketType.POKER_CHIP]: "It's double down time!",
    [isaac_typescript_definitions_1.TrinketType.BLISTER]: "Bounce back!",
    [isaac_typescript_definitions_1.TrinketType.SECOND_HAND]: "Extended stat effect time!",
    [isaac_typescript_definitions_1.TrinketType.ENDLESS_NAMELESS]: "I'm stuck in a loop...",
    [isaac_typescript_definitions_1.TrinketType.BLACK_FEATHER]: "With darkness comes power",
    [isaac_typescript_definitions_1.TrinketType.BLIND_RAGE]: "Blind to damage",
    [isaac_typescript_definitions_1.TrinketType.GOLDEN_HORSE_SHOE]: "Feel lucky?",
    [isaac_typescript_definitions_1.TrinketType.STORE_KEY]: "Stores are open",
    [isaac_typescript_definitions_1.TrinketType.RIB_OF_GREED]: "Feels greedy",
    [isaac_typescript_definitions_1.TrinketType.KARMA]: "Karma up",
    [isaac_typescript_definitions_1.TrinketType.LIL_LARVA]: "The poop is moving...",
    [isaac_typescript_definitions_1.TrinketType.MOMS_LOCKET]: "You feel her love",
    [isaac_typescript_definitions_1.TrinketType.NO]: "Never again!",
    [isaac_typescript_definitions_1.TrinketType.CHILD_LEASH]: "Keep your friends close...",
    [isaac_typescript_definitions_1.TrinketType.BROWN_CAP]: "Fartoom!",
    [isaac_typescript_definitions_1.TrinketType.MECONIUM]: "Eww",
    [isaac_typescript_definitions_1.TrinketType.CRACKED_CROWN]: "Stat booster",
    [isaac_typescript_definitions_1.TrinketType.USED_DIAPER]: "You stink",
    [isaac_typescript_definitions_1.TrinketType.FISH_TAIL]: "It also stinks!",
    [isaac_typescript_definitions_1.TrinketType.BLACK_TOOTH]: "It looks dead",
    [isaac_typescript_definitions_1.TrinketType.OUROBOROS_WORM]: "Foop foop!",
    [isaac_typescript_definitions_1.TrinketType.TONSIL]: "Sick...",
    [isaac_typescript_definitions_1.TrinketType.NOSE_GOBLIN]: "Seems magic...",
    [isaac_typescript_definitions_1.TrinketType.SUPER_BALL]: "Boing!",
    [isaac_typescript_definitions_1.TrinketType.VIBRANT_BULB]: "It needs power",
    [isaac_typescript_definitions_1.TrinketType.DIM_BULB]: "I think it's broken",
    [isaac_typescript_definitions_1.TrinketType.FRAGMENTED_CARD]: "Double moon",
    [isaac_typescript_definitions_1.TrinketType.EQUALITY]: "=",
    [isaac_typescript_definitions_1.TrinketType.WISH_BONE]: "Make a wish",
    [isaac_typescript_definitions_1.TrinketType.BAG_LUNCH]: "I wonder what it is",
    [isaac_typescript_definitions_1.TrinketType.LOST_CORK]: "Uncorked",
    [isaac_typescript_definitions_1.TrinketType.CROW_HEART]: "Drain me",
    [isaac_typescript_definitions_1.TrinketType.WALNUT]: "That's a hard nut to crack!",
    [isaac_typescript_definitions_1.TrinketType.DUCT_TAPE]: "Stuck!",
    [isaac_typescript_definitions_1.TrinketType.SILVER_DOLLAR]: "Feels lucky...",
    [isaac_typescript_definitions_1.TrinketType.BLOODY_CROWN]: "Drips with blood...",
    [isaac_typescript_definitions_1.TrinketType.PAY_TO_WIN]: "...",
    [isaac_typescript_definitions_1.TrinketType.LOCUST_OF_WRATH]: "I bring War",
    [isaac_typescript_definitions_1.TrinketType.LOCUST_OF_PESTILENCE]: "I bring Pestilence",
    [isaac_typescript_definitions_1.TrinketType.LOCUST_OF_FAMINE]: "I bring Famine",
    [isaac_typescript_definitions_1.TrinketType.LOCUST_OF_DEATH]: "I bring Death",
    [isaac_typescript_definitions_1.TrinketType.LOCUST_OF_CONQUEST]: "I bring Conquest",
    [isaac_typescript_definitions_1.TrinketType.BAT_WING]: "They are growing...",
    [isaac_typescript_definitions_1.TrinketType.STEM_CELL]: "Regen!",
    [isaac_typescript_definitions_1.TrinketType.HAIRPIN]: "Danger charge",
    [isaac_typescript_definitions_1.TrinketType.WOODEN_CROSS]: "My faith protects me",
    [isaac_typescript_definitions_1.TrinketType.BUTTER]: "Can't hold it!",
    [isaac_typescript_definitions_1.TrinketType.FILIGREE_FEATHERS]: "Angelic spoils",
    [isaac_typescript_definitions_1.TrinketType.DOOR_STOP]: "Hold the door",
    [isaac_typescript_definitions_1.TrinketType.EXTENSION_CORD]: "Charged friends",
    [isaac_typescript_definitions_1.TrinketType.ROTTEN_PENNY]: "Wealth of flies",
    [isaac_typescript_definitions_1.TrinketType.BABY_BENDER]: "Feed them magic!",
    [isaac_typescript_definitions_1.TrinketType.FINGER_BONE]: "It looks brittle",
    [isaac_typescript_definitions_1.TrinketType.JAW_BREAKER]: "Don't chew on it",
    [isaac_typescript_definitions_1.TrinketType.CHEWED_PEN]: "It's leaking",
    [isaac_typescript_definitions_1.TrinketType.BLESSED_PENNY]: "Wealth of purity",
    [isaac_typescript_definitions_1.TrinketType.BROKEN_SYRINGE]: "Mystery medicine",
    [isaac_typescript_definitions_1.TrinketType.SHORT_FUSE]: "Faster explosions",
    [isaac_typescript_definitions_1.TrinketType.GIGANTE_BEAN]: "Mega farts",
    [isaac_typescript_definitions_1.TrinketType.LIGHTER]: "Watch the world burn",
    [isaac_typescript_definitions_1.TrinketType.BROKEN_PADLOCK]: "Bombs are key",
    [isaac_typescript_definitions_1.TrinketType.MYOSOTIS]: "Forget me not...",
    [isaac_typescript_definitions_1.TrinketType.M]: "t's broken9Reroll your dest       ",
    [isaac_typescript_definitions_1.TrinketType.TEARDROP_CHARM]: "It feels lucky",
    [isaac_typescript_definitions_1.TrinketType.APPLE_OF_SODOM]: "It feels empty",
    [isaac_typescript_definitions_1.TrinketType.FORGOTTEN_LULLABY]: "Sing for your friends",
    [isaac_typescript_definitions_1.TrinketType.BETHS_FAITH]: "My faith protects me",
    [isaac_typescript_definitions_1.TrinketType.OLD_CAPACITOR]: "Voltage starving",
    [isaac_typescript_definitions_1.TrinketType.BRAIN_WORM]: "Ding!",
    [isaac_typescript_definitions_1.TrinketType.PERFECTION]: "Luck way up. Don't lose it!",
    [isaac_typescript_definitions_1.TrinketType.DEVILS_CROWN]: "His special customer",
    [isaac_typescript_definitions_1.TrinketType.CHARGED_PENNY]: "Wealth of power",
    [isaac_typescript_definitions_1.TrinketType.FRIENDSHIP_NECKLACE]: "Gather round",
    [isaac_typescript_definitions_1.TrinketType.PANIC_BUTTON]: "Push in case of emergency",
    [isaac_typescript_definitions_1.TrinketType.BLUE_KEY]: "Look between the rooms",
    [isaac_typescript_definitions_1.TrinketType.FLAT_FILE]: "No more spikes",
    [isaac_typescript_definitions_1.TrinketType.TELESCOPE_LENS]: "Seek the stars",
    [isaac_typescript_definitions_1.TrinketType.MOMS_LOCK]: "A piece of her love",
    [isaac_typescript_definitions_1.TrinketType.DICE_BAG]: "Bonus roll",
    [isaac_typescript_definitions_1.TrinketType.HOLY_CROWN]: "Walk the path of the saint",
    [isaac_typescript_definitions_1.TrinketType.MOTHERS_KISS]: "HP up",
    [isaac_typescript_definitions_1.TrinketType.TORN_CARD]: "Death awaits",
    [isaac_typescript_definitions_1.TrinketType.TORN_POCKET]: "A hole in your pocket",
    [isaac_typescript_definitions_1.TrinketType.GILDED_KEY]: "Less is more",
    [isaac_typescript_definitions_1.TrinketType.LUCKY_SACK]: "Free goodies!",
    [isaac_typescript_definitions_1.TrinketType.WICKED_CROWN]: "Walk the path of the wicked",
    [isaac_typescript_definitions_1.TrinketType.AZAZELS_STUMP]: "Unleash your inner demon",
    [isaac_typescript_definitions_1.TrinketType.DINGLE_BERRY]: "Oops!",
    [isaac_typescript_definitions_1.TrinketType.RING_CAP]: "Twice the bang!",
    [isaac_typescript_definitions_1.TrinketType.NUH_UH]: "Don't want!",
    [isaac_typescript_definitions_1.TrinketType.MODELING_CLAY]: "???",
    [isaac_typescript_definitions_1.TrinketType.POLISHED_BONE]: "Friends from beyond",
    [isaac_typescript_definitions_1.TrinketType.HOLLOW_HEART]: "A brittle blessing",
    [isaac_typescript_definitions_1.TrinketType.KIDS_DRAWING]: "Looks familiar...",
    [isaac_typescript_definitions_1.TrinketType.CRYSTAL_KEY]: "Call to the other side",
    [isaac_typescript_definitions_1.TrinketType.KEEPERS_BARGAIN]: "Money talks",
    [isaac_typescript_definitions_1.TrinketType.CURSED_PENNY]: "Wealth of misery",
    [isaac_typescript_definitions_1.TrinketType.YOUR_SOUL]: "Give it to me",
    [isaac_typescript_definitions_1.TrinketType.NUMBER_MAGNET]: "6",
    [isaac_typescript_definitions_1.TrinketType.STRANGE_KEY]: "What could it open?",
    [isaac_typescript_definitions_1.TrinketType.LIL_CLOT]: "Mini friend",
    [isaac_typescript_definitions_1.TrinketType.TEMPORARY_TATTOO]: "You feel braver",
    [isaac_typescript_definitions_1.TrinketType.SWALLOWED_M80]: "Bang!",
    [isaac_typescript_definitions_1.TrinketType.RC_REMOTE]: "Controllable buddies!",
    [isaac_typescript_definitions_1.TrinketType.FOUND_SOUL]: "Finally!",
    [isaac_typescript_definitions_1.TrinketType.EXPANSION_PACK]: "Fun extras",
    [isaac_typescript_definitions_1.TrinketType.BETHS_ESSENCE]: "Virtue's reward",
    [isaac_typescript_definitions_1.TrinketType.TWINS]: "I'm seeing double...",
    [isaac_typescript_definitions_1.TrinketType.ADOPTION_PAPERS]: "Give them a home",
    [isaac_typescript_definitions_1.TrinketType.CRICKET_LEG]: "Infested",
    [isaac_typescript_definitions_1.TrinketType.APOLLYONS_BEST_FRIEND]: "Attack buddy",
    [isaac_typescript_definitions_1.TrinketType.BROKEN_GLASSES]: "Double vision?",
    [isaac_typescript_definitions_1.TrinketType.ICE_CUBE]: "Stay frosty",
    [isaac_typescript_definitions_1.TrinketType.SIGIL_OF_BAPHOMET]: "Revel in death", // 189
};
