"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TRINKET_NAMES = exports.DEFAULT_TRINKET_NAME = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
exports.DEFAULT_TRINKET_NAME = "Unknown";
/**
 * Maps trinket types to the real English names from the "stringtable.sta" file.
 *
 * For a mapping of name to `TrinketType`, see `TRINKET_NAME_TO_TYPE_MAP`.
 */
exports.TRINKET_NAMES = {
    [isaac_typescript_definitions_1.TrinketType.NULL]: exports.DEFAULT_TRINKET_NAME,
    [isaac_typescript_definitions_1.TrinketType.SWALLOWED_PENNY]: "Swallowed Penny",
    [isaac_typescript_definitions_1.TrinketType.PETRIFIED_POOP]: "Petrified Poop",
    [isaac_typescript_definitions_1.TrinketType.AAA_BATTERY]: "AAA Battery",
    [isaac_typescript_definitions_1.TrinketType.BROKEN_REMOTE]: "Broken Remote",
    [isaac_typescript_definitions_1.TrinketType.PURPLE_HEART]: "Purple Heart",
    [isaac_typescript_definitions_1.TrinketType.BROKEN_MAGNET]: "Broken Magnet",
    [isaac_typescript_definitions_1.TrinketType.ROSARY_BEAD]: "Rosary Bead",
    [isaac_typescript_definitions_1.TrinketType.CARTRIDGE]: "Cartridge",
    [isaac_typescript_definitions_1.TrinketType.PULSE_WORM]: "Pulse Worm",
    [isaac_typescript_definitions_1.TrinketType.WIGGLE_WORM]: "Wiggle Worm",
    [isaac_typescript_definitions_1.TrinketType.RING_WORM]: "Ring Worm",
    [isaac_typescript_definitions_1.TrinketType.FLAT_WORM]: "Flat Worm",
    [isaac_typescript_definitions_1.TrinketType.STORE_CREDIT]: "Store Credit",
    [isaac_typescript_definitions_1.TrinketType.CALLUS]: "Callus",
    [isaac_typescript_definitions_1.TrinketType.LUCKY_ROCK]: "Lucky Rock",
    [isaac_typescript_definitions_1.TrinketType.MOMS_TOENAIL]: "Mom's Toenail",
    [isaac_typescript_definitions_1.TrinketType.BLACK_LIPSTICK]: "Black Lipstick",
    [isaac_typescript_definitions_1.TrinketType.BIBLE_TRACT]: "Bible Tract",
    [isaac_typescript_definitions_1.TrinketType.PAPER_CLIP]: "Paper Clip",
    [isaac_typescript_definitions_1.TrinketType.MONKEY_PAW]: "Monkey Paw",
    [isaac_typescript_definitions_1.TrinketType.MYSTERIOUS_PAPER]: "Mysterious Paper",
    [isaac_typescript_definitions_1.TrinketType.DAEMONS_TAIL]: "Daemon's Tail",
    [isaac_typescript_definitions_1.TrinketType.MISSING_POSTER]: "Missing Poster",
    [isaac_typescript_definitions_1.TrinketType.BUTT_PENNY]: "Butt Penny",
    [isaac_typescript_definitions_1.TrinketType.MYSTERIOUS_CANDY]: "Mysterious Candy",
    [isaac_typescript_definitions_1.TrinketType.HOOK_WORM]: "Hook Worm",
    [isaac_typescript_definitions_1.TrinketType.WHIP_WORM]: "Whip Worm",
    [isaac_typescript_definitions_1.TrinketType.BROKEN_ANKH]: "Broken Ankh",
    [isaac_typescript_definitions_1.TrinketType.FISH_HEAD]: "Fish Head",
    [isaac_typescript_definitions_1.TrinketType.PINKY_EYE]: "Pinky Eye",
    [isaac_typescript_definitions_1.TrinketType.PUSH_PIN]: "Push Pin",
    [isaac_typescript_definitions_1.TrinketType.LIBERTY_CAP]: "Liberty Cap",
    [isaac_typescript_definitions_1.TrinketType.UMBILICAL_CORD]: "Umbilical Cord",
    [isaac_typescript_definitions_1.TrinketType.CHILDS_HEART]: "Child's Heart",
    [isaac_typescript_definitions_1.TrinketType.CURVED_HORN]: "Curved Horn",
    [isaac_typescript_definitions_1.TrinketType.RUSTED_KEY]: "Rusted Key",
    [isaac_typescript_definitions_1.TrinketType.GOAT_HOOF]: "Goat Hoof",
    [isaac_typescript_definitions_1.TrinketType.MOMS_PEARL]: "Mom's Pearl",
    [isaac_typescript_definitions_1.TrinketType.CANCER]: "Cancer",
    [isaac_typescript_definitions_1.TrinketType.RED_PATCH]: "Red Patch",
    [isaac_typescript_definitions_1.TrinketType.MATCH_STICK]: "Match Stick",
    [isaac_typescript_definitions_1.TrinketType.LUCKY_TOE]: "Lucky Toe",
    [isaac_typescript_definitions_1.TrinketType.CURSED_SKULL]: "Cursed Skull",
    [isaac_typescript_definitions_1.TrinketType.SAFETY_CAP]: "Safety Cap",
    [isaac_typescript_definitions_1.TrinketType.ACE_OF_SPADES]: "Ace of Spades",
    [isaac_typescript_definitions_1.TrinketType.ISAACS_FORK]: "Isaac's Fork",
    // There is no `TrinketType` with a value of 47.
    [isaac_typescript_definitions_1.TrinketType.MISSING_PAGE]: "A Missing Page",
    [isaac_typescript_definitions_1.TrinketType.BLOODY_PENNY]: "Bloody Penny",
    [isaac_typescript_definitions_1.TrinketType.BURNT_PENNY]: "Burnt Penny",
    [isaac_typescript_definitions_1.TrinketType.FLAT_PENNY]: "Flat Penny",
    [isaac_typescript_definitions_1.TrinketType.COUNTERFEIT_PENNY]: "Counterfeit Penny",
    [isaac_typescript_definitions_1.TrinketType.TICK]: "Tick",
    [isaac_typescript_definitions_1.TrinketType.ISAACS_HEAD]: "Isaac's Head",
    [isaac_typescript_definitions_1.TrinketType.MAGGYS_FAITH]: "Maggy's Faith",
    [isaac_typescript_definitions_1.TrinketType.JUDAS_TONGUE]: "Judas' Tongue",
    [isaac_typescript_definitions_1.TrinketType.BLUE_BABYS_SOUL]: "???'s Soul",
    [isaac_typescript_definitions_1.TrinketType.SAMSONS_LOCK]: "Samson's Lock",
    [isaac_typescript_definitions_1.TrinketType.CAINS_EYE]: "Cain's Eye",
    [isaac_typescript_definitions_1.TrinketType.EVES_BIRD_FOOT]: "Eve's Bird Foot",
    [isaac_typescript_definitions_1.TrinketType.LEFT_HAND]: "The Left Hand",
    [isaac_typescript_definitions_1.TrinketType.SHINY_ROCK]: "Shiny Rock",
    [isaac_typescript_definitions_1.TrinketType.SAFETY_SCISSORS]: "Safety Scissors",
    [isaac_typescript_definitions_1.TrinketType.RAINBOW_WORM]: "Rainbow Worm",
    [isaac_typescript_definitions_1.TrinketType.TAPE_WORM]: "Tape Worm",
    [isaac_typescript_definitions_1.TrinketType.LAZY_WORM]: "Lazy Worm",
    [isaac_typescript_definitions_1.TrinketType.CRACKED_DICE]: "Cracked Dice",
    [isaac_typescript_definitions_1.TrinketType.SUPER_MAGNET]: "Super Magnet",
    [isaac_typescript_definitions_1.TrinketType.FADED_POLAROID]: "Faded Polaroid",
    [isaac_typescript_definitions_1.TrinketType.LOUSE]: "Louse",
    [isaac_typescript_definitions_1.TrinketType.BOBS_BLADDER]: "Bob's Bladder",
    [isaac_typescript_definitions_1.TrinketType.WATCH_BATTERY]: "Watch Battery",
    [isaac_typescript_definitions_1.TrinketType.BLASTING_CAP]: "Blasting Cap",
    [isaac_typescript_definitions_1.TrinketType.STUD_FINDER]: "Stud Finder",
    [isaac_typescript_definitions_1.TrinketType.ERROR]: "Error",
    [isaac_typescript_definitions_1.TrinketType.POKER_CHIP]: "Poker Chip",
    [isaac_typescript_definitions_1.TrinketType.BLISTER]: "Blister",
    [isaac_typescript_definitions_1.TrinketType.SECOND_HAND]: "Second Hand",
    [isaac_typescript_definitions_1.TrinketType.ENDLESS_NAMELESS]: "Endless Nameless",
    [isaac_typescript_definitions_1.TrinketType.BLACK_FEATHER]: "Black Feather",
    [isaac_typescript_definitions_1.TrinketType.BLIND_RAGE]: "Blind Rage",
    [isaac_typescript_definitions_1.TrinketType.GOLDEN_HORSE_SHOE]: "Golden Horse Shoe",
    [isaac_typescript_definitions_1.TrinketType.STORE_KEY]: "Store Key",
    [isaac_typescript_definitions_1.TrinketType.RIB_OF_GREED]: "Rib of Greed",
    [isaac_typescript_definitions_1.TrinketType.KARMA]: "Karma",
    [isaac_typescript_definitions_1.TrinketType.LIL_LARVA]: "Lil Larva",
    [isaac_typescript_definitions_1.TrinketType.MOMS_LOCKET]: "Mom's Locket",
    [isaac_typescript_definitions_1.TrinketType.NO]: "NO!",
    [isaac_typescript_definitions_1.TrinketType.CHILD_LEASH]: "Child Leash",
    [isaac_typescript_definitions_1.TrinketType.BROWN_CAP]: "Brown Cap",
    [isaac_typescript_definitions_1.TrinketType.MECONIUM]: "Meconium",
    [isaac_typescript_definitions_1.TrinketType.CRACKED_CROWN]: "Cracked Crown",
    [isaac_typescript_definitions_1.TrinketType.USED_DIAPER]: "Used Diaper",
    [isaac_typescript_definitions_1.TrinketType.FISH_TAIL]: "Fish Tail",
    [isaac_typescript_definitions_1.TrinketType.BLACK_TOOTH]: "Black Tooth",
    [isaac_typescript_definitions_1.TrinketType.OUROBOROS_WORM]: "Ouroboros Worm",
    [isaac_typescript_definitions_1.TrinketType.TONSIL]: "Tonsil",
    [isaac_typescript_definitions_1.TrinketType.NOSE_GOBLIN]: "Nose Goblin",
    [isaac_typescript_definitions_1.TrinketType.SUPER_BALL]: "Super Ball",
    [isaac_typescript_definitions_1.TrinketType.VIBRANT_BULB]: "Vibrant Bulb",
    [isaac_typescript_definitions_1.TrinketType.DIM_BULB]: "Dim Bulb",
    [isaac_typescript_definitions_1.TrinketType.FRAGMENTED_CARD]: "Fragmented Card",
    [isaac_typescript_definitions_1.TrinketType.EQUALITY]: "Equality!",
    [isaac_typescript_definitions_1.TrinketType.WISH_BONE]: "Wish Bone",
    [isaac_typescript_definitions_1.TrinketType.BAG_LUNCH]: "Bag Lunch",
    [isaac_typescript_definitions_1.TrinketType.LOST_CORK]: "Lost Cork",
    [isaac_typescript_definitions_1.TrinketType.CROW_HEART]: "Crow Heart",
    [isaac_typescript_definitions_1.TrinketType.WALNUT]: "Walnut",
    [isaac_typescript_definitions_1.TrinketType.DUCT_TAPE]: "Duct Tape",
    [isaac_typescript_definitions_1.TrinketType.SILVER_DOLLAR]: "Silver Dollar",
    [isaac_typescript_definitions_1.TrinketType.BLOODY_CROWN]: "Bloody Crown",
    [isaac_typescript_definitions_1.TrinketType.PAY_TO_WIN]: "Pay To Win",
    [isaac_typescript_definitions_1.TrinketType.LOCUST_OF_WRATH]: "Locust of War",
    [isaac_typescript_definitions_1.TrinketType.LOCUST_OF_PESTILENCE]: "Locust of Pestilence",
    [isaac_typescript_definitions_1.TrinketType.LOCUST_OF_FAMINE]: "Locust of Famine",
    [isaac_typescript_definitions_1.TrinketType.LOCUST_OF_DEATH]: "Locust of Death",
    [isaac_typescript_definitions_1.TrinketType.LOCUST_OF_CONQUEST]: "Locust of Conquest",
    [isaac_typescript_definitions_1.TrinketType.BAT_WING]: "Bat Wing",
    [isaac_typescript_definitions_1.TrinketType.STEM_CELL]: "Stem Cell",
    [isaac_typescript_definitions_1.TrinketType.HAIRPIN]: "Hairpin",
    [isaac_typescript_definitions_1.TrinketType.WOODEN_CROSS]: "Wooden Cross",
    [isaac_typescript_definitions_1.TrinketType.BUTTER]: "Butter!",
    [isaac_typescript_definitions_1.TrinketType.FILIGREE_FEATHERS]: "Filigree Feather",
    [isaac_typescript_definitions_1.TrinketType.DOOR_STOP]: "Door Stop",
    [isaac_typescript_definitions_1.TrinketType.EXTENSION_CORD]: "Extension Cord",
    [isaac_typescript_definitions_1.TrinketType.ROTTEN_PENNY]: "Rotten Penny",
    [isaac_typescript_definitions_1.TrinketType.BABY_BENDER]: "Baby-Bender",
    [isaac_typescript_definitions_1.TrinketType.FINGER_BONE]: "Finger Bone",
    [isaac_typescript_definitions_1.TrinketType.JAW_BREAKER]: "Jawbreaker",
    [isaac_typescript_definitions_1.TrinketType.CHEWED_PEN]: "Chewed Pen",
    [isaac_typescript_definitions_1.TrinketType.BLESSED_PENNY]: "Blessed Penny",
    [isaac_typescript_definitions_1.TrinketType.BROKEN_SYRINGE]: "Broken Syringe",
    [isaac_typescript_definitions_1.TrinketType.SHORT_FUSE]: "Short Fuse",
    [isaac_typescript_definitions_1.TrinketType.GIGANTE_BEAN]: "Gigante Bean",
    [isaac_typescript_definitions_1.TrinketType.LIGHTER]: "A Lighter",
    [isaac_typescript_definitions_1.TrinketType.BROKEN_PADLOCK]: "Broken Padlock",
    [isaac_typescript_definitions_1.TrinketType.MYOSOTIS]: "Myosotis",
    [isaac_typescript_definitions_1.TrinketType.M]: " 'M",
    [isaac_typescript_definitions_1.TrinketType.TEARDROP_CHARM]: "Teardrop Charm",
    [isaac_typescript_definitions_1.TrinketType.APPLE_OF_SODOM]: "Apple of Sodom",
    [isaac_typescript_definitions_1.TrinketType.FORGOTTEN_LULLABY]: "Forgotten Lullaby",
    [isaac_typescript_definitions_1.TrinketType.BETHS_FAITH]: "Beth's Faith",
    [isaac_typescript_definitions_1.TrinketType.OLD_CAPACITOR]: "Old Capacitor",
    [isaac_typescript_definitions_1.TrinketType.BRAIN_WORM]: "Brain Worm",
    [isaac_typescript_definitions_1.TrinketType.PERFECTION]: "Perfection",
    [isaac_typescript_definitions_1.TrinketType.DEVILS_CROWN]: "Devil's Crown",
    [isaac_typescript_definitions_1.TrinketType.CHARGED_PENNY]: "Charged Penny",
    [isaac_typescript_definitions_1.TrinketType.FRIENDSHIP_NECKLACE]: "Friendship Necklace",
    [isaac_typescript_definitions_1.TrinketType.PANIC_BUTTON]: "Panic Button",
    [isaac_typescript_definitions_1.TrinketType.BLUE_KEY]: "Blue Key",
    [isaac_typescript_definitions_1.TrinketType.FLAT_FILE]: "Flat File",
    [isaac_typescript_definitions_1.TrinketType.TELESCOPE_LENS]: "Telescope Lens",
    [isaac_typescript_definitions_1.TrinketType.MOMS_LOCK]: "Mom's Lock",
    [isaac_typescript_definitions_1.TrinketType.DICE_BAG]: "Dice Bag",
    [isaac_typescript_definitions_1.TrinketType.HOLY_CROWN]: "Holy Crown",
    [isaac_typescript_definitions_1.TrinketType.MOTHERS_KISS]: "Mother's Kiss",
    [isaac_typescript_definitions_1.TrinketType.TORN_CARD]: "Torn Card",
    [isaac_typescript_definitions_1.TrinketType.TORN_POCKET]: "Torn Pocket",
    [isaac_typescript_definitions_1.TrinketType.GILDED_KEY]: "Gilded Key",
    [isaac_typescript_definitions_1.TrinketType.LUCKY_SACK]: "Lucky Sack",
    [isaac_typescript_definitions_1.TrinketType.WICKED_CROWN]: "Wicked Crown",
    [isaac_typescript_definitions_1.TrinketType.AZAZELS_STUMP]: "Azazel's Stump",
    [isaac_typescript_definitions_1.TrinketType.DINGLE_BERRY]: "Dingle Berry",
    [isaac_typescript_definitions_1.TrinketType.RING_CAP]: "Ring Cap",
    [isaac_typescript_definitions_1.TrinketType.NUH_UH]: "Nuh Uh!",
    [isaac_typescript_definitions_1.TrinketType.MODELING_CLAY]: "Modeling Clay",
    [isaac_typescript_definitions_1.TrinketType.POLISHED_BONE]: "Polished Bone",
    [isaac_typescript_definitions_1.TrinketType.HOLLOW_HEART]: "Hollow Heart",
    [isaac_typescript_definitions_1.TrinketType.KIDS_DRAWING]: "Kid's Drawing",
    [isaac_typescript_definitions_1.TrinketType.CRYSTAL_KEY]: "Crystal Key",
    [isaac_typescript_definitions_1.TrinketType.KEEPERS_BARGAIN]: "Keeper's Bargain",
    [isaac_typescript_definitions_1.TrinketType.CURSED_PENNY]: "Cursed Penny",
    [isaac_typescript_definitions_1.TrinketType.YOUR_SOUL]: "Your Soul",
    [isaac_typescript_definitions_1.TrinketType.NUMBER_MAGNET]: "Number Magnet",
    [isaac_typescript_definitions_1.TrinketType.STRANGE_KEY]: "Strange Key",
    [isaac_typescript_definitions_1.TrinketType.LIL_CLOT]: "Lil Clot",
    [isaac_typescript_definitions_1.TrinketType.TEMPORARY_TATTOO]: "Temporary Tattoo",
    [isaac_typescript_definitions_1.TrinketType.SWALLOWED_M80]: "Swallowed M80",
    [isaac_typescript_definitions_1.TrinketType.RC_REMOTE]: "RC Remote",
    [isaac_typescript_definitions_1.TrinketType.FOUND_SOUL]: "Found Soul",
    [isaac_typescript_definitions_1.TrinketType.EXPANSION_PACK]: "Expansion Pack",
    [isaac_typescript_definitions_1.TrinketType.BETHS_ESSENCE]: "Beth's Essence",
    [isaac_typescript_definitions_1.TrinketType.TWINS]: "The Twins",
    [isaac_typescript_definitions_1.TrinketType.ADOPTION_PAPERS]: "Adoption Papers",
    [isaac_typescript_definitions_1.TrinketType.CRICKET_LEG]: "Cricket Leg",
    [isaac_typescript_definitions_1.TrinketType.APOLLYONS_BEST_FRIEND]: "Apollyon's Best Friend",
    [isaac_typescript_definitions_1.TrinketType.BROKEN_GLASSES]: "Broken Glasses",
    [isaac_typescript_definitions_1.TrinketType.ICE_CUBE]: "Ice Cube",
    [isaac_typescript_definitions_1.TrinketType.SIGIL_OF_BAPHOMET]: "Sigil of Baphomet", // 189
};
