"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VERSUS_SCREEN_BACKGROUND_COLORS = void 0;
const isaac_typescript_definitions_1 = require("isaac-typescript-definitions");
const readOnly_1 = require("../functions/readOnly");
const BASEMENT_COLOR = (0, readOnly_1.newReadonlyColor)(26 / 255, 14 / 255, 12 / 255);
const CAVES_COLOR = (0, readOnly_1.newReadonlyColor)(18 / 255, 13 / 255, 8 / 255);
const DEPTHS_COLOR = (0, readOnly_1.newReadonlyColor)(8 / 255, 8 / 255, 8 / 255);
const WOMB_COLOR = (0, readOnly_1.newReadonlyColor)(27 / 255, 3 / 255, 3 / 255);
const SHEOL_COLOR = (0, readOnly_1.newReadonlyColor)(6 / 255, 6 / 255, 6 / 255);
/** We arbitrarily specify a default color equal to that of Basement. */
const DEFAULT_COLOR = BASEMENT_COLOR;
/** These values are taken from StageAPI. */
exports.VERSUS_SCREEN_BACKGROUND_COLORS = {
    [isaac_typescript_definitions_1.StageID.SPECIAL_ROOMS]: DEFAULT_COLOR,
    [isaac_typescript_definitions_1.StageID.BASEMENT]: BASEMENT_COLOR,
    [isaac_typescript_definitions_1.StageID.CELLAR]: (0, readOnly_1.newReadonlyColor)(26 / 255, 17 / 255, 13 / 255),
    [isaac_typescript_definitions_1.StageID.BURNING_BASEMENT]: (0, readOnly_1.newReadonlyColor)(28 / 255, 12 / 255, 10 / 255),
    [isaac_typescript_definitions_1.StageID.CAVES]: CAVES_COLOR,
    [isaac_typescript_definitions_1.StageID.CATACOMBS]: (0, readOnly_1.newReadonlyColor)(15 / 255, 10 / 255, 8 / 255),
    [isaac_typescript_definitions_1.StageID.FLOODED_CAVES]: (0, readOnly_1.newReadonlyColor)(21 / 255, 28 / 255, 35 / 255),
    [isaac_typescript_definitions_1.StageID.DEPTHS]: DEPTHS_COLOR,
    [isaac_typescript_definitions_1.StageID.NECROPOLIS]: (0, readOnly_1.newReadonlyColor)(10 / 255, 6 / 255, 6 / 255),
    [isaac_typescript_definitions_1.StageID.DANK_DEPTHS]: DEPTHS_COLOR,
    [isaac_typescript_definitions_1.StageID.WOMB]: WOMB_COLOR,
    [isaac_typescript_definitions_1.StageID.UTERO]: (0, readOnly_1.newReadonlyColor)(22 / 255, 6 / 255, 5 / 255),
    [isaac_typescript_definitions_1.StageID.SCARRED_WOMB]: (0, readOnly_1.newReadonlyColor)(42 / 255, 19 / 255, 10 / 255),
    [isaac_typescript_definitions_1.StageID.BLUE_WOMB]: (0, readOnly_1.newReadonlyColor)(26 / 255, 32 / 255, 40 / 255),
    [isaac_typescript_definitions_1.StageID.SHEOL]: SHEOL_COLOR,
    [isaac_typescript_definitions_1.StageID.CATHEDRAL]: (0, readOnly_1.newReadonlyColor)(6 / 255, 13 / 255, 17 / 255),
    [isaac_typescript_definitions_1.StageID.DARK_ROOM]: (0, readOnly_1.newReadonlyColor)(9 / 255, 4 / 255, 3 / 255),
    [isaac_typescript_definitions_1.StageID.CHEST]: (0, readOnly_1.newReadonlyColor)(15 / 255, 9 / 255, 6 / 255),
    [isaac_typescript_definitions_1.StageID.SHOP]: DEFAULT_COLOR,
    [isaac_typescript_definitions_1.StageID.ULTRA_GREED]: DEFAULT_COLOR,
    [isaac_typescript_definitions_1.StageID.VOID]: (0, readOnly_1.newReadonlyColor)(0, 0, 0),
    [isaac_typescript_definitions_1.StageID.DOWNPOUR]: (0, readOnly_1.newReadonlyColor)(29 / 255, 30 / 255, 32 / 255),
    [isaac_typescript_definitions_1.StageID.DROSS]: (0, readOnly_1.newReadonlyColor)(35 / 255, 35 / 255, 29 / 255),
    [isaac_typescript_definitions_1.StageID.MINES]: (0, readOnly_1.newReadonlyColor)(17 / 255, 15 / 255, 12 / 255),
    [isaac_typescript_definitions_1.StageID.ASHPIT]: (0, readOnly_1.newReadonlyColor)(12 / 255, 10 / 255, 10 / 255),
    [isaac_typescript_definitions_1.StageID.MAUSOLEUM]: (0, readOnly_1.newReadonlyColor)(14 / 255, 10 / 255, 14 / 255),
    [isaac_typescript_definitions_1.StageID.GEHENNA]: (0, readOnly_1.newReadonlyColor)(15 / 255, 4 / 255, 4 / 255),
    [isaac_typescript_definitions_1.StageID.CORPSE]: (0, readOnly_1.newReadonlyColor)(13 / 255, 14 / 255, 12 / 255),
    [isaac_typescript_definitions_1.StageID.MORTIS]: (0, readOnly_1.newReadonlyColor)(13 / 255, 14 / 255, 12 / 255),
    [isaac_typescript_definitions_1.StageID.HOME]: DEFAULT_COLOR,
    [isaac_typescript_definitions_1.StageID.BACKWARDS]: DEFAULT_COLOR, // 36
};
