/**
 * "Armor" refers to the damage scaling mechanic. The following list corresponds to the entities
 * that have the "shieldStrength" field in the "entities2.xml" file, with some exceptions.
 * (Invulnerable enemies are not included. Furthermore, Ultra Greed, Ultra Greedier, and Delirium
 * all have damage scaling, but do not have a corresponding "shieldStrength" field.)
 *
 * Also see:
 * https://bindingofisaacrebirth.fandom.com/wiki/Damage_Scaling#Entities_with_Armor_Values
 *
 * We use strings instead of a type + variant tuple so that we can have O(1) lookups.
 */
export declare const ENTITIES_WITH_ARMOR_SET: ReadonlySet<string>;
//# sourceMappingURL=entitiesWithArmorSet.d.ts.map